unit PVM;     (*      II             *)
              (* . .     *)
interface

(******************************* PSIMQ **********************************)

const maxN = 10;(*   i. i  PSIMQ *)

type tA = array[1..maxN, 1..maxN] of single; (*   PSIMQ *)
     tB = array[1..maxN] of single;


procedure PSIMQ(       (*    '  ii i  *)
      A : tA;          (* i  -.                *)
  var B : tB;          (*    :                                 *)
      N : integer;     (* A -  iii  i;       *)
  var ier : integer);  (* B -  i i i;  i
                               - ' 
                          N -  i (<=10)
                        ier -   ( ii i 0, 
                                 'i;    
                              i 'i,  ier=0  i    B
                              i        )

         i,   PSIMQ,   I  '   tA  i  tB
     (  'i  ii  INTERFACE  ii  PVM ).
         :  ii   4- i i
      i   ,  ii  -  i  F ;  i   
       i  k ,    PSIMQ    :

        var C:tA; F:tB; k:integer;
        begin
        ...
        PSIMQ( C, F, 4,  k );


(******************************* PSLAU *******************************)

Const dim = 20;(*   i. i  PSLAU *)

Type  matr = ARRAY [1..dim,1..dim+1] OF single; (*   PSLAU *)
      vect = array [1..dim] of single;


procedure PSLAU(     (*   '  ii i  *)
      N : integer;   (* i  .                       *)
      A : matr;      (*   :                                 *)
  var X : vect );    (* N -  i (<=20)
                        A -   ii N*(N+1)
                            iii 
                        X - -' 

         'i     i 'i,
    i:  " = 0"

      i,   PSLAU,   I  '   matr i vect
  (  'i  ii  INTERFACE  ii  PVM ).
      :  ii   4- i i
   i   ,  i  '     R ,  
  PSLAU    :

        var C:matr; R:vect;
        begin
        ...
        PSLAU( 4, C, R );



(********************************* PBIS **********************************)

type Fx_type = function(x:single):single; (*  ii  PBIS  PSIMPS *)


procedure PBIS(        (*    i  i  [A,B]   *)
      A,               (*   X  i  F(x)=0   ii   *)
      B : single;        (* ( i i).                       *)
      F : Fx_type;     (*   A,B -ii  iii            *)
      EPS : single;      (*    F  -i' i-ii,      *)
  var X : single;        (*        i  i F(x)=0.  i *)
  var IER : integer ); (* i '  i,   PBIS, :

                          function F(x:single):single; begin <i ii> end;

  EPS -  i   (  )
   X  -  - i i
  IER -   (ii i 0,  i F(x)  I 
                         i [A,B],    F(A)*F(B)>=0  )

    :    i i X-COS(X)=0  i
 [0,1]   i  ,    PBIS    :

                   var X:single; IER:integer;

                   function F(x:single):single; begin F:=x-cos(x) end;

              begin
              ...
              PBIS( 0, 1, F, 1E-4, X, IER );


(********************************* PAPROX *********************************)


Const dimArr = 100;(* max     PAPROX  PLINTER *)

Type arr = array [0..dimArr+1] of single; (*  i  PAPROX
                                       PLINTER *)


procedure PAPROX(    (*   i    i  ii        *)
     X,Y : arr;      (*     i.                    *)
     m,n : integer;  (*   :                                      *)
 var A : arr;        (*  X,Y -   i ii     *)
 var D : single );     (*       (  )
                          m  -   ii ( m<=100,
                                  101- :
                              (X0,Y0), (X1,Y1), ... , (Xm,Ym). )
  n  -ci   (i 0  100 )
  A  -ii  . A[0] -i , A[1] -.
          X  1- i, ..., A[n] -ii  X  n- i.
  D  -.i   i i ii

    i,   PAPROX,   I  '   arr  (i 
 '  ii  INTERFACE  ii  PVM ).
    :   7- i (X0,Y0),...,(X6,Y6)  
    4, i   ii    C
 ( .i -  i V ),   PAPROX  
 :
        var X,Y,C:arr; V:single;
        begin
        ...
        PAPROX( X, Y, 6, 4, C, V );


(******************************* PLINTER **********************************)


function PLinter(           (*   II  ii    i *)
    X,Y    : arr;           (*   ii.                                 *)
     m     : integer;       (*   :                               *)
  argument : single ) : single; (* X,Y -   i iii
                                    (  )
                                m  -   ( m<=100,
                                        101 :
                                    (X0,Y0), (X1,Y1), ... , (Xm,Ym). )
                          argument -,    ii
                                    ii (i  
                                        [ X0 , Xm ] )

    i,   PLinter,   I  '   arr  (i 
 '  ii  INTERFACE  ii  PVM ).
    :   7- i (X0,Y0),...,(X6,Y6)  
  iii iii  i  -0.43, i    
 ii V ),   PLinter   :

        var X,Y:arr; V:single;
        begin
        ...
        V := PLinter( X, Y, 6, -0.43 );


(********************************* PSIMPS *********************************)


procedure PSIMPS(       (*     i  [A,B]  i   *)
     A,B  : single;       (* i ii  F   i  EPS        *)
      F   : Fx_type;    (* Ci ().                           *)
     EPS  : single;       (*   F  - i' i-ii,    *)
  var Y   : single;       (* ii i.  F i '     *)
  var IER : integer );  (* i,   PSIMPS, :

                         function F(x:single):single; begin <i ii> end;

   Y  -  -  i
  IER -  . IER=0,  i    i
        IER=1,  I    ii ii [A,B] 
               16384 
        IER=2,    SIMPS ,  A>=B
        IER=3, - - - - - - - - - - - - - - - - - -  EPS<=0

    :    i  Q  i ii  X/SIN(X)  
 i  [0.1,0.9]   i  ,    PSIMPS  
  :
                   var Q:single; IER:integer;
                   function F(x:single):single; begin F:=x/sin(x) end;
              begin
              ...
              PSIMPS( 0.1, 0.9, F, 1E-4, Q, IER );


(********************************* PMZSMF *********************************)


procedure PMZSMF(       (*     i  [A,B]    X0 , *)
     A,B  : single;       (*  i  I  i  F   II. *)
      F   : Fx_type;    (*  i     *)
     EPS  : single;       (*  i  EPS .                             *)
var X0,Y0 : single;       (*   Y0 -  i  F   i  X0 .     *)
var  IER  : integer );  (*  IER -  .: =1,  A>=B  EPS<=0 .

   i-i,    F , i '   i, 
  PMZSMF, :
                         function F(x:single):single; begin <i ii> end;

    :        ii  SIN(X)/(1+X)
  i  [ 0, pi ]   i   ( i,  
    i, i i    
 i),    PMZSMF   :

                   var  ArgFmax, Fmax : single;
                        Error : INTEGER;
                   function F(x:single):single; begin F := -sin(x)/(1+x) end;
              begin
              ...
              PMZSMF( 0, pi, F, 1E-4, ArgFmax, Fmax, Error );
              writeln(' min: ',ArgFmax:6:4,'   Fmax: ', -Fmax:6:4);

  i      i  F   ,   
  writeln  i   Fmax .


(*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*)

implementation


(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)
(*                                                                   *)
(*                  i, ii   PSIMQ                     *)
(*                                                                   *)
(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)

(*********************************************************************)
(*  TurboPascal 5.5 demo procedure                                   *)
(*  Gauss Jordan matrix inversion and solution                       *)
procedure gaussj
  (var b     : tA;  (* square matrix of coefficients *)
    y        : tB;  (* constant vector *)
    var coef : tB;  (* solution vector *)
    ncol     : integer;  (* order of matrix *)
    var error: boolean); (* true if matrix singular *)

(*  Gauss Jordan matrix inversion and solution *)
(*  Adapted from McCormick  *)
(*  Feb  8, 81 *)
(*   B(N,N) coefficient matrix, becomes inverse *)
(*   Y(N)   original constant vector *)
(*   W(N,M) constant vector(s) become solution vector *)
(*   DETERM is the determinant *)
(*   ERROR = 1 if singular *)
(*   INDEX(N,3) *)
(*   NV is number of constant vectors *)

var
  w    : array[1..maxN{maxc}, 1..maxN{maxc}] of single;
  index: array[1..maxN{maxc}, 1..3] of integer;
  i, j, k, l, nv, irow, icol, n, l1   : integer;
  determ, pivot, hold, sum, t, ab, big: single;

procedure swap(var a, b: single);

var
  hold: single;

begin  (* swap *)
  hold := a;
  a := b;
  b := hold
end  (* procedure swap *);


begin     (* Gauss-Jordan main program *)
  error := false;
  nv := 1 (* single constant vector *);
  n := ncol;
  for i := 1 to n do
    begin
      w[i, 1] := y[i] (* copy constant vector *);
      index[i, 3] := 0
    end;
  determ := 1.0;
  for i := 1 to n do
    begin
      (* search for largest element *)
      big := 0.0;
      for j := 1 to n do
        begin
          if index[j, 3] <> 1 then
            begin
              for k := 1 to n do
                begin
                  if index[k, 3] > 1 then
                    begin
                      {writeln(' ERROR: matrix singular');}
                      error := true;
                      exit;         (* abort *)
                    end;
                  if index[k, 3] < 1 then
                    if abs(b[j, k]) > big then
                      begin
                        irow := j;
                        icol := k;
                        big := abs(b[j, k])
                      end
                end (* k loop *)
            end
        end (* j loop *);
      index[icol, 3] := index[icol, 3] + 1;
      index[i, 1] := irow;
      index[i, 2] := icol;

  (* interchange rows to put pivot on diagonal *)
  if irow <> icol then
    begin
      determ := - determ;
      for l := 1 to n do
        swap(b[irow, l], b[icol, l]);
      if nv > 0 then
        for l := 1 to nv do
          swap(w[irow, l], w[icol, l])
    end; (* if irow <> icol *)

      (* divide pivot row by pivot column *)
      pivot := b[icol, icol];
      determ := determ * pivot;
      b[icol, icol] := 1.0;
      for l := 1 to n do
        b[icol, l] := b[icol, l] / pivot;
      if nv > 0 then
        for l := 1 to nv do
          w[icol, l] := w[icol, l] / pivot;
      (*  reduce nonpivot rows *)
      for l1 := 1 to n do
        begin
          if l1 <> icol then
            begin
              t := b[l1, icol];
              b[l1, icol] := 0.0;
              for l := 1 to n do
                b[l1, l] := b[l1, l] - b[icol, l] * t;
              if nv > 0 then
                for l := 1 to nv do
                  w[l1, l] := w[l1, l] - w[icol, l] * t;
            end   (* if l1 <> icol *)
        end
    end (* i loop *);

  if error then exit;
  (* interchange columns *)
  for i := 1 to n do
    begin
      l := n - i + 1;
      if index[l, 1] <> index[l, 2] then
        begin
          irow := index[l, 1];
          icol := index[l, 2];
          for k := 1 to n do
            swap(b[k, irow], b[k, icol])
        end (* if index *)
    end  (* i loop *);
  for k := 1 to n do
    if index[k, 3] <> 1 then
      begin
        {writeln(' ERROR: matrix singular');}
        error := true;
        exit;   (* abort *)
      end;
  for i := 1 to n do
    coef[i] := w[i, 1];
end (* procedure gaussj *);


(*********************************************************************)
procedure PSIMQ(
      A : tA;
  var B : tB;
      N : integer;
  var ier : integer);

var  error : boolean;

begin
ier:=0;
gaussj( A, (* square matrix of coefficients *)
        B, (* constant vector *)
        B, (* solution vector *)
        N, (* order of matrix *)
        error); (* true if matrix singular *)
if error then ier:=1
end;(* PSIMQ *)



(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)
(*                                                                   *)
(*                  i, ii   PSLAU                     *)
(*                                                                   *)
(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)

  procedure Gauss1(a : matr; n : Integer; e : single; VAR x : vect);
    VAR i,j,k : Integer;
        y,w : single;
  BEGIN
        FOR i:=1 TO n DO
          BEGIN
            k:=i; y:=a[i,i];
            FOR j:=i+1 TO n DO
              BEGIN  w:=a[j,i];
                IF Abs(w)>Abs(y) THEN BEGIN k:=j; y:=w  END
              END;
           IF Abs(y)<e THEN BEGIN WriteLn(' = 0'); exit END;
           FOR j:=i TO n+1 do
             BEGIN  w:=a[k,j]; a[k,j]:=a[i,j]; a[i,j]:=w/y END;
           FOR k:=i+1 TO n DO
             FOR j:=n+1 DOWNTO i+1 DO a[k,j]:=a[k,j]-a[i,j]*a[k,i]
         END;
         FOR i:=n DOWNTO 1 DO
           BEGIN w:=0;
             FOR  j:=i+1 TO n DO w:=w+a[i,j]*x[j];
             x[i]:=a[i,n+1]-w
           END
     END;{Gauss1}

(*********************************************************************)
procedure PSLAU(
      N : integer;
      A : matr;
  var X : vect );

const precision = 1E-8;

begin
Gauss1( A, N, precision, X )
end;{ PSLAU }



(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)
(*                                                                   *)
(*                    i, ii   PBIS                    *)
(*                                                                   *)
(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)

procedure PBIS(
      A,
      B : single;
      F : Fx_type;
      EPS : single;
  var X : single;
  var IER : integer );

label M, FIN;

begin
if F(A)*F(B)>=0 then begin IER:=1; goto FIN end;
IER:=0;
M:
X:=0.5*(A+B);
if (B-A)<(2*EPS) then GOTO FIN;
if (F(A)*F(X)) < 0 then B:=X else A:=X;
goto M;
FIN:
end;{ PBIS }



(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)
(*                                                                   *)
(*                  i, ii   PAPROX                    *)
(*                                                                   *)
(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)

Procedure apr (m,n:integer; x,y:arr; Var t:single;Var a:arr);
   type
       ar1 = ARRAY [1..dim+1,1..dim+2] OF single;
   Var
       i,j:integer; u:single; c:ar1;

   PROCEDURE Gauss1(a : ar1; n : Integer; e : single; VAR x : arr);
      VAR i,j,k : Integer;
          y,w : single;
      BEGIN{ Gauss1 }
        FOR i:=1 TO n DO
          BEGIN
            k:=i; y:=a[i,i];
            FOR j:=i+1 TO n DO                            
              BEGIN  w:=a[j,i];
                IF Abs(w)>Abs(y) THEN BEGIN k:=j; y:=w  END
              END;
           IF Abs(y)<e THEN BEGIN Write(' '); Halt END;
           FOR j:=i TO n+1 DO
             BEGIN  w:=a[k,j]; a[k,j]:=a[i,j]; a[i,j]:=w/y END;
           FOR k:=i+1 TO n DO
             FOR j:=n+1 DOWNTO i+1 DO a[k,j]:=a[k,j]-a[i,j]*a[k,i]
         END;
         FOR i:=n DOWNTO 1 DO
           BEGIN w:=0;
             FOR  j:=i+1 TO n DO w:=w+a[i,j]*x[j-1];
             x[i-1]:=a[i,n+1]-w
           END
      END;{Gauss1}

 Begin{arp}
     for i:=0 to n do a[i]:=1;
       for i:=0 to 2*m do
         begin  u:=0;
           for j:=0 to n do u:=u+a[j];
             if i<=m then
                 begin for j:=0 to i do c[i-j+1,j+1]:=u;
                      u:=0; for j:=0 to n do u:=u+y[j]*a[j];
                      c[i+1,m+2]:=u
                 end  else if i<>2*2 then
                                for j:=1 MOD m to m do c[i-j+1,j+1]:=u
                                      else c[m+1,m+1]:=u;
                  for j:=0 to n do a[j]:=a[j]*x[j]
               end;
          gauss1(c,m+1,1e-6,a);
       t:=0;
       for i:=0 to n do
           begin  u:=0;
              for j:=m downto 1 do u:=(u+a[j])*x[i];
                  t:=t+sqr(y[i]-u-a[0])
             end;
         t:=sqrt(t/(n+1))
  end;{apr}

(*********************************************************************)

procedure PAPROX( X,Y:arr; M,N:integer; var A:arr; var D:single);
   Const ErrMess=#13#10'i  PAPROX:'#13#10;
   var i,j:byte;
   begin
{  if N>M then
      begin writeln(ErrMess,
      'Ci . i  i  i!'); exit end;
}
   for i:=0 to M-1 do for j:=i+1 to M do if X[i]=X[j] then
      begin writeln(ErrMess,
      'i  i   ',i:1,'  ',j:1,' !'); exit end;
   apr(n,m,x,y,D,A);
   end;{PAPROX}



(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)
(*                                                                   *)
(*                  i, ii   PLINTER                   *)
(*                                                                   *)
(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)

function PLinter( X,Y:arr; M:integer; argument:single):single;
   Label FIN;
   Const ErrMess=#13#10'i  PLinter:'#13#10;
   var i,j:byte;
   begin
   for i:=0 to M-1 do for j:=i+1 to M do if X[i]=X[j] then
      begin
      writeln(ErrMess,'i  i   ',i:1,'  ',j:1,' !');
      goto FIN
      end;
   for i:=0 to M-1 do
      if (X[i]<=argument) and (argument<=X[i+1]) then
      begin
      PLinter := (Y[i+1]-Y[i])/(X[i+1]-X[i])*(argument-X[i])+Y[i];
      goto FIN
      end;
   writeln(ErrMess,
      '   i [ ',X[0]:5:2,' , ',X[M]:5:2,' ] !');
   FIN:
   end;{PLinter}


(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)
(*                                                                   *)
(*                  i, ii   PSIMPS                    *)
(*                                                                   *)
(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)

procedure PSIMPS( A,B : single;
                  F : Fx_type;
                  EPS : single;
              var Y : single;
              var IER : integer );
label FIN;
var E1, H, H2, S1, S2, S3, x : single;
    N : word;
begin
if A>=B then begin IER:=2; goto FIN end;
if EPS<=0 then begin IER:=3; goto FIN end;
N:=1; (* N =  i  [A,B] *)
E1:=EPS*15;
H:=(B-A)/2;
Y:=2*F(A+H);
S1:=Y+F(A)+F(B); { S1 = F(A)+2F(A+H)+F(B) }
Y:=S1+Y;         {  Y = F(A)+4F(A+H)+F(B) }
repeat
   S2:=0;
   S3:=Y;        {     i }
   H2:=H;
   H:=H/2;       {  1- i:  H = (B-A)/4  }
   x:=A+H;
   while x<B do begin S2:=S2+F(x); x:=x+H2 end;
   S2:=2*S2;     {  1- i:  S2 = 2F(A+H2/2) + 2F(A+3H2/2)  }
   S1:=S1+S2;    { S1 = F(A) + 2F(A+H2/2) + 2F(A+H2) + 2F(A+3H2/2) + F(B) }
   Y:=S1+S2;     {  Y = F(A) + 4F(A+H2/2) + 2F(A+H2) + 4F(A+3H2/2) + F(B) }
   N:=2*N;
   if N >= 16384 then begin IER:=1; goto FIN end;
until {abs( 1-Y/(2*S3) ) < E1;} {abs(2*S3-Y)<E1*2*abs(S3);}
   H*abs(Y-2*S3) < 3*E1;
Y:=Y*H/3;
IER:=0;
FIN:
end;{PSIMPS}


(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)
(*                                                                       *)
(*                    i, ii   PMZSMF                      *)
(*                                                                       *)
(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)

procedure PMZSMF(       (*     i  [A,B]    X0 , *)
     A,B  : single;       (*  i  I  i  F   II. *)
      F   : Fx_type;    (*  i     *)
     EPS  : single;       (*  i  EPS .                             *)
var X0,Y0 : single;       (*   Y0 -  i  F   i  X0 .     *)
var  IER  : integer );  (*  IER -  .: =1,  A>=B  EPS<=0  *)

   var GS,                 (*    *)
       XP,YP, XL,YL : single;(*    i    *)
begin
if (A>=B) or (EPS<=0) then begin IER:=1; exit end;
IER:=0;
GS := 0.5*(sqrt(5)-1);     (*    *)

XP:=A+(B-A)*GS;  YP:=F(XP);
XL:=B-(B-A)*GS;  YL:=F(XL);
repeat
  if YP<YL then
      begin A:=XL; XL:=XP; YL:=YP; XP:=A+(B-A)*GS; YP:=F(XP) end
  else {YP>=YL}
      begin B:=XP; XP:=XL; YP:=YL; XL:=B-(B-A)*GS; YL:=F(XL) end
until (B-A)<EPS;

X0:=0.5*(A+B); Y0:=F(X0)
end;{ PMZSMF }

(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)
end.
