unit StructureDonnees;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,ListArray2,
  Grids,ColorStringGrid,MyNewGrid,Contnrs,GestionTextes;

const
  ExtIcone='.bmp';                // obligatoire pour TBitBtn
  ExtImage='.jpg';
  ExtImageb='.msu';
  ExtTxt='.rtf';
  ExtFicPhylo='.phg';
  ExtFicMat='.tab';
  ExtFicCar='.car';
  ExtFicCod='.cod';
  ExtFicArb='.arb';
  ExtFicBoite='.boi';
  ExtFicConfig='.cph';
  FicGlossaire='Glossaire.txt';
  FicAideCodage='aide_codage.htm';

  clSilver  = TColor($00C0C0C0 );
  clLavender =   TColor($00FAE6E6);
  clWheat = TColor($00B3DEF5);
  clPink    =  TColor($00CBC0FF);
  clCoral  =  TColor($00507FFF);
  clDarkorange  =   TColor($00008CFF);
  clSalmon  =   TColor($007280FA);
  clPalegoldenrod  = TColor($00AAE8EE);
  clTan    = TColor($008CB4D2);
  clPalegreen   = TColor($0098FB98);
  clMediumaquamarine = TColor($00AACD66);
  clAqua = TColor($00FFFF00);
  clMediumturquoise  = TColor($00CCD148);
  clLightsteelblue = TColor($00DEC4B0);
  clOrchid  = TColor($00D670DA);
  clWhistle  = TColor($00D8BFD8);
  clPalevioletred = TColor($009370DB);
  clCadetblue  = TColor($00A09E5F);
  HauteurPetiteImage=220;
  LargeurPetiteImage=352;
  ImColW=452;
  ImColH=313;
  IcColW=134;
  IcColH=53;
  ImDocW=338;
  ImDocH=201;
  ImDocBH=426;
  IcTaxW=85;
  IcTaxH=48;

 type
  TProfil=Array of integer;
  TProfils=Array of TProfil;
// un taxon
  TTaxon=class
    Nom: string;
    Image: string;
    Selected:boolean; //Ajout JFM 02/05/08 pour pouvoir enregistrer un fichier .cph avec
                      // les seuls Taxons slectionns
    Choisi:Boolean;  //Taxon choisi dans la planche;
    Enabled:Boolean;  //pour indiquer les taxons  utiliser;
    TypeTaxon:string;    //combinaison de F (fossile) E (extragroupe) U ( exclure du tableau) X (pour exercices)  S (supplmentaire pour Organiser)
                         // D correspond  des fossiles trs fragmentaires  exclure des tableaux mais qui servent  la datation ...
    AgeApp:integer; // ge d'apparition de l'espce en milliers d'annes;
    AgeDisp:integer; // ge de disparition de l'espce en milliers d'annes;
    ImageCars: TStringList;
    DocsDivers:TStringList;
    constructor create;  //Ajout JFM
    destructor Destroy; override;
    function LitTypeTax(chaine:string):string;
    function LitAges(var date1,date2:string):boolean;
    function GetExtraGroupe:boolean;
    procedure SetExtraGroupe(valeur:Boolean);
    property Extragroupe:boolean read GetExtraGroupe  write SetExtraGroupe;
  end;
  TCaractD=class(TObject)  //Ajout JFM
    Nom: string;
    TypeCarD:integer;  // 0: non ordonn,  1: ordonn
    NomCarParent: string; // nom de la donnee servant  l'illustration
    Selected:boolean;
    Active:boolean; // pour savoir s'il est cliqu dans le tableau
    ListeEtats: TStringList; //Liste ordonne (si possible)  des tats : l'tat primitif toujours en premier,
                             // puis tats drivs puis '?' (si ncessaire)  la fin
    ListeDocEtats: TStringList;  // liste des illustrations correspondant  chaque tat
    CouleursEtats:Array of TAffichCell;
    NomsGroupes:TStringList; // liste des dnomination des groupes dfinis par les tats drivs du caractre
    GroupesNommes:Array of boolean;// tableau indiquant les groupes nomms (mmes indices que NomsGroupes)
    NomsGroupesNommes:TStringList; // liste des dnomination des groupes dfinis par les tats drivs du caractre et donns par l'utilisateur
    AffRAZ:TAffichCell;
    Couleur:TColor;

    constructor create;
    destructor Destroy; override;
    procedure AjusteEtats;
    procedure AjouteEtat(nouvEtat,NouvDoc,NouvGroupe:string);
    procedure InsereEtat(i:integer;nouvEtat,NouvDoc:string);
    procedure RetireEtat(i:integer);
    procedure RAZEtat;
    procedure Assign(CaracD:TCaractD);
    function LitAffichCellEtatNm(etat:string):TAffichCell;
    function LitAffichCellEtat(numetat:integer):TAffichCell;
    function FixeAffichCellEtatNm(etat:string;Aff:TAffichCell):boolean;
    function FixeAffichCellEtat(numetat:integer;Aff:TAffichCell):boolean;
    procedure RAZGroupesNommes;
  end;
  TCarDs=class(TObject)
   private
    FCodesEtats:TStrListArray; //contenu de .cod  Ajout JFM 06/08
    FItems:TList;
    function GetItem(Index:integer):TCaractD;
    procedure SetItem(Index:integer;UnCard:TCaractD);
   public
    CodAuto:boolean;// pour neutraliser le chargement du .cod pour des vrifications
    DeuxEtatsMax:Boolean;   // Ajout JFM

    function Add(UnCarD:TCaractD):integer;
    procedure Clear;
    procedure Delete(Index:integer);
    procedure Exchange(Index1, Index2: Integer);
    procedure Move(CurIndex, NewIndex: Integer);
    procedure Insert(Index: Integer; UnCarD:TCaractD);
    function IndexOf(UnCarD:TCaractD):integer;
    procedure Assign(Modele:TCarDs);

    function GetNomCarD(NumCarD: integer):string;
    function GetNumCarD(NomCarD: string):integer;
    function GetCarD(NomCard:string):TCaractD;
    function GetEtats(NumCarD: integer):TStringList;
    function GetDocEtats(NumCarD: integer):TStringList;
    function GetEtat(NumCarD,NumEtat: integer):String;
    function GetNbMaxiEtats:integer;
    procedure LireCod(FichCod:string);
    function SauveCod(NomFicCod:string):boolean;
    procedure SelecTout;
    procedure RazSelect;
    procedure RazDActive;
    procedure CouleursDefaut;
    procedure RazCouleursD;
    procedure CreeCodeSEtats; //Ajout JFM 01/06/08
    procedure EtablitAffichage(Tableau:TStringGrid);

    function GetCodesEtats:TStrListArray;
    function GetAffichage(NomCarD,etat:string):TAffichCell;
    procedure SetAffichage(NomCarD,etat:string;Aff:TAffichCell);
    function GetNbCarD:integer;
    constructor Create;
    destructor Destroy;override;

    property Items[Index:integer]:TCaractD read GetItem write SetItem;
    property CodesEtats:TStrListArray read GetCodesEtats;
    property Affichage[NomCarD,etat:string]:TAffichCell read GetAffichage write SetAffichage;
    property NbCarD:integer read GetNbCarD;
  end;
// Caractres
  TCaracteres=class
   public
    CheminImagesC:string;
    CheminTextesC:string;
    CheminImagesT:string;
    //CodAuto:boolean;// pour neutraliser le chargement du .cod pour des vrifications
    TypeCaract:TStringList;     // liste des types de caractres (1ere liste droulante de Observer et Comparer)
    NCarParType:TStringList;    // Nombre de caractres de chaque type
    Noms: TStringList;          // Noms des Caractres type 1 puis type 2... (2e liste droulante de Observer et Comparer)
    Selectionnes:Array of boolean; //indication des caractres retenus;
    NomsCourts: TStringList;   // (5 car max ?) //pour les prfixes d'image  la cration de collections
    CarDs:TCarDs;   // Caractres dtaills (utiliss dans "Choisir")
    //CarD: TList;
                     //Liste de TCaractD   //JFM 01/06/08 remplaant le StringList prcdent
    CarDRef:TCarDs;  // copie de rfrence des CarD si modif des caractres.
    NumTypeComp: TStringList;  // liste des numros ?  ou nombre par type ? de caractres pour la comparaison
    DeuxEtatsMax:Boolean;   // Ajout JFM

    Procedure CreeNomsCourts;
    function GetNbCar(NumType: integer):integer;
    function GetNumCar(NumType: integer; Num: integer):integer;
    function GetNumPremCar(NumType: integer):integer;
    function GetNumDernCar(NumType: integer):integer;
    function GetNomCourt(NumC:integer):string;
    function GetNom(NumC:integer):string;
    function GetNomCarD(NumCarD: integer):string;
    function GetNumCarD(NomCarD: string):integer;
    function GetEtats(NumCarD: integer):TStringList;
    function GetDocEtats(NumCarD: integer):TStringList;
    function GetEtat(NumCarD,NumEtat: integer):String;
    function GetDocEtat(NumCarD,NumEtat: integer):String;
    function GetNumCarParent(NumCarD: integer):integer;//-2 si on doit afficher l'image du taxon
                                                       //-1 si le caractre associ n'existe pas
    function GetNumTypeComp(Index:integer):integer;
    Procedure GetTypeNumdeNumabs(Numabs:integer;var numtype,numero:integer);
    Procedure GetTypeNum(Nom:string;var numtype,numero:integer);
    procedure GetListeCar(NumType: integer;Var ListeCarT:TStringList);
    procedure LireCar(FichCar:string);   //Lecture des fichier .car
    procedure LireCod(FichCod:string);   //Lecture des fichier .cod
    function LireCarDeStrinList(V2:boolean;var n:integer;ListeLignes: TStringList):boolean;  //Lecture dans un StrinList
    function SauveCar(Fich:string):boolean;  //enregistrement d'un fichier .Car
    function TransformeCarEnStrinList(V2,Tous:boolean;var ListeLignes:TStringList):boolean;  //Ecriture dans un StrinList
    function GetNbMaxiEtats:integer;
    function SauveCod(NomFicCod:string):boolean;
    procedure SelecTout;
    procedure RazSelect;
    procedure RazDActive;
    Procedure CreeCodeSEtats; //Ajout JFM 01/06/08
    procedure ChargeCDRef;
    procedure RetourCDARef;
    function GetCodesEtats:TStrListArray;
    property CodesEtats:TStrListArray read GetCodesEtats;
  end;
  TAttribut=record
    Caractere:string[50];
    Etat:String[40];
    NumEtat:integer;
    Statut:integer; //Statut:= 0:primitif, 1:indtermin, 2:driv non exclusif,  3:driv exclusif
  end;
  TListeAttributs=class
  private
    FAttributs:Array of TAttribut;
    AttributNul:TAttribut;
  public
    constructor Create;
    Destructor Destroy;override;
    procedure Add(UnAttribut:TAttribut);
    procedure Clear;
    function AttributDe(NomCar:string):TAttribut;
    function NumeroEtat(NomCar:string):integer;
    function Etat(NomCar:string):string;
    function Statut(NomCar:string):integer;
    procedure Ajoute(NomCar,Etat:string;NumEtat,Statut:integer);
    procedure Retire(NomCar:string);
    procedure ModifieOuAjoute(NomCar,Etat:string;NumEtat,Statut:integer);
      //Ajoute s'il n'y a pas de NomCar rpertori
  end;
// liste des taxons
  TTaxons=class(TList)
    NbTaxons: integer;
    //NbCaract: integer;
    FCaracteres:TCaracteres;
    CheminImagesT:string;
    CheminIconesT:string;

    procedure InsereTaxon(T:TTaxon;Var num:integer); //num numro du nouveau taxon les suivants changent de numro
    procedure AddTaxon(T:TTaxon);
    procedure RetireTaxon(Num: integer);
    procedure RetireTaxonNomme(Nom: string);
    function GetNom(Num: integer): string;
    function GetImage(Num: integer): string;
    function GetIcone(Num: integer): string;
    function GetImageCar(NumEsp: integer; NumCar: integer):string;
    function GetImageCarBig(NumEsp: integer; NumCar: integer):string;
    function GetTexteCar(NumEsp: integer; NumCar: integer):string;
    function GetNumTaxon(NomTaxon: string):integer;
    function GetTaxon(NomTaxon:string):TTaxon;
    procedure SelectAll;
    procedure RAZSelected;
    procedure RAZChoisis;
    procedure ChoisisTout;
    procedure LireFichier(Fich: string); //lecture d'un fichier .phg
    procedure EnregistrerFichier(Fich: string); //enregistrement d'un fichier .phg
    procedure CopieDansStringList(Tout:boolean;var ListeLignes: TStringList);
    procedure CopieDansStringListVAnc(var ListeLignes: TStringList);
    procedure LitDansStringList(ListeLignes: TStringList;var n:integer);
    function GetNbCaract:integer;
    property NbCaract: integer read GetNbCaract;
    procedure Copie(Modele:TTaxons;Tout:Boolean);
  end;
  // sous-collection
  TSousCollection=Class
    Nom:string;   //nom accentu...
    NomFicBase:string;
    DossierCollection:string; // Nom du dossier contenant la collection
    DossierTab:string;
    DossierCarIm:string;
    DossierUtiles:string;
    FichierTS:string;

    Exclusions:string;//  Fentres non accessibles avec la sous-collection
  //O pour Observer, C pour Comparer,R pour construire, T pour charger le tableau rempli, P pour Coder,
  //D pour Dater,B pour Classer (botes), G pour Grouper, A pour tablir des parents (Arbre), N pour Organiser
    CommencerPar:string[1]; // comme ci-dessus sauf D qui mne  Polariser
    ArbreExclu:boolean;// pour exclure la possibilit d'afficher l'arbre dans FormParente
                       // maintenant inutile
    ClasserMode6:Boolean;
    FModeCollege:boolean;
    FAccesArbre:boolean;
    FichierCph:string;
    TabRef:TStrListArray; //tableau de rfrence de la sous-collection
    TabRefRef:TStrListArray; //copie de rfrence du tableau de rfrence du groupe d'images
                             // pour restauration aprs modif des caractres.
    Taxons:TTaxons;
    Caracteres:TCaracteres;
    FEnsGroupes:TStringList;
    TaxonsExercice:Array of TTaxon;
    TaxonsSup:Array of TTaxon;
    NomTaxonExtraGroupe:string;
    TaxonsActifs:Array of TTaxon;
    MesCarD:TCarDs;
    DatationFaite:Boolean;
    procedure EnregistreCph(Tout:boolean;NmSsCol:string;NomFic:string);  // si tout=false, seuls les taxons et caractD slectionns.
    Function StructCph(Tout:Boolean):string;
    Function LitStrucCph(ChaineStruc:String):Boolean;
    procedure LitCph(NomFic:string);
    procedure LitTabref(NomFicTab:string);
    procedure VerifieTabRef;
    function LitSousCollection(NomFic:string):boolean;
    procedure EcritLigneConf(LaListe:TStringList);
    procedure LitLigneConf(LaListe:TstringList;var n:integer);
    procedure RechercheDocsCompl;
    procedure RazConfig;
    function DocsEtatsPresents(NumCarD:integer):boolean;
    function RechercheDoc(NomTaxon,NomCarD:string;var Numtaxon,NumCar:integer;var legende:string):string;
    function RechercheDocTaxonsSup:string;
    function EstFossile(NumTaxon:integer):boolean;
    function EstFossileNm(NomTaxon:string):boolean;
    function EstExterne(NumTaxon:integer):boolean;
    function EstExterneNm(NomTaxon:string):boolean;
    function AgeNm(NomTaxon:string):integer;
    function AgeStrNm(NomTaxon:string):string;
    function Age(NumTaxon:integer):integer;
    function AgeStr(NumTaxon:integer):string;
    function AgesStr(NumTaxon:integer):string;
    function AgesStrNm(NomTaxon:string):string;
    function EtatDe(NomTaxon,NomCarD:string;Var NumEtat:integer):string;
    function VerifStatutDe(NomCarD:string;Numetat,StatutOrg:integer):integer;
    function NomEtat(NomCarD:string;NumEtat:integer):string;
    Function TrouveAge(NomCarac,NomEtat:string;Var ValAge:integer):string;
    function ConstruitListeEtatsAncetre(AfDExcl,AfD,AfA:TAffichCoul;var Nomgroupe:string;var ListeTaxons:TStringList;Tableau:TColorStringGrid):TStringList;
      // si ce n'est pas un groupe monophyltique (pas d'tat driv commun exclusif) Nomgroupe renvoie 'groupe htrogne'
    function ListeEtatsDerExcl(ListeTaxons:string;ListeTotaleTaxons:TStringList;var Nomgroupe,ListeEtats:string):String;
    Function DetermineStatut(NomCar:string;ListeTaxons,ListeTotaleTaxons:TStringList;Methode:integer;Var NumEtatCommun:integer;Var EtatCommun,Nomgroupe:string):integer;
              //Result:= 0:primitif, 1:indtermin, 2:driv non exclusif,  3:driv exclusif
              // Methode 0: m. de Wagner (rversions et convergences acceptes)
              //         1: m. de Camin Sokal (convergences seules acceptes)
              //         2: m. de Dollo (rversions seules acceptes)

    function ConstruitListeEtatsAncetreBis(AfDExcl,AfD,AfA:TAffichCoul;var AfUtil:TAffichCoul;var Nomgroupe:string;var ListeTaxons:TStringList;Tableau:TColorStringGrid):TStringList;
    Function NomGroupe(NomCarD,NomEtat:string):string;
    Function LesGroupes(ListeTaxons,ListeTousTaxons:TStringList):string; //renvoie la structure d'un commatext de StringList
    function LeTaxon(NomTaxon:string):TTaxon;
    function NumTaxon(UnTaxon:TTaxon):integer;
    function LeCarD(NomCarD:string):TCaractD;
    function LeTypeCarD(NomCarD:string):integer;
    function GetCarD(Index:integer):TCaractD;
    function LeCarDRef(NomCarD:string):TCaractD;
    function AvecFossiles(TenirCompteSelection:boolean):boolean;
    procedure RetourTabRef;
    procedure MemoriseTabRef;
    procedure RetourCarRef;
    procedure CreeTaxonsExercice;
    procedure CreeTaxonsSup;
    procedure CreeTaxonsActifs(Tous:Boolean);  //si Tous=True les taxons de type U sont inclus (pour Observer et Comparer)
                                               //les Taxons de type X (exercice) sont toujours exclus
    function CreeTabAges(Tableau:TStrListArray):TStrListArray;
    constructor Create;
    destructor Destroy; override;
    function GetAffichage(NomCarD,etat:string):TAffichCell;
    procedure SetAffichage(NomCarD,etat:string;Aff:TAffichCell);
    procedure RAZCodageAffichage;
    procedure LitAffichage(Tableau:TStringGrid);
    procedure EtablitAffichage(Tableau:TStringGrid);

    function GetEtatRef(NomTax,NomCarD:string):string;
    procedure SetEtatRef(NomTax,NomCarD:string;etat:string);

    function GetCodeCase(NomTax,NomCarD:string):string;

    function GetEnsGroupes:TStringList;
    procedure initialiseEnsGroupes;
    procedure MiseEnCodeCoulNaoum;
    Function GroupesDeclares:Boolean;
    //procedure MiseEnCodeCouleurJF;

    procedure RetablitCaractere(ASupprimer:TStringList;ARetablir:string); //rtablit un caractreD et rejuste le TabRef
    procedure SuprimeColonneTabRef(NomCarD:string);
    procedure RetablitColonneTabRef(NomCarD:string); //rtablit d'aprs TabRefRef
    procedure ListeCaractGroupe(Raz:boolean;nomGroupe:string;var Lignes:TStrings);

    property Affichage[NomCarD,etat:string]:TAffichCell read GetAffichage write SetAffichage;
    property EtatRef[NomTax,NomCarD:string]:string read GetEtatRef write SetEtatRef;
    property CodeCase[NomTax,NomCarD:string]:string read GetCodeCase;  //lecture seule
    property EnsGroupes:TStringList read GetEnsGroupes; //lecture seule
    property CarD[Index:integer]:TCaractD read GetCarD;
    //Gestion des TaxonsActifs
    function GetImageTaxActif(Num: integer): string;
    function GetIconeTaxActif(Num: integer): string;
    function GetImageCarTaxActif(Num: integer; NumCar: integer):string;
    function GetImageCarBigTaxActif(Num: integer; NumCar: integer):string;
    function GetTexteCarTaxActif(Num: integer; NumCar: integer):string;
    function GetNumTaxActif(NomTaxon: string):integer;
    function CalculeProfils(DebCol,DebLign:integer;Tableau:TStringList;var PrCol0:integer;var profils:TProfils):integer; // renvoie le numro de la colonne maxi pour un caractre de type 1
                    // PrCol0 colonne  mettre en premier pour les caractres de type 0
    function CalculeProfil(Colonne:TStrings;PremLigne:integer):string;
    procedure ClasseColonnesTableau(DebCol,DebLign:integer;Var Tableau:TStringList);
    procedure ClasseLignesTableau(DebCol,PremLigne,DerLigne:integer;Var Tableau:TStringList);
    procedure FusionneColonnesTableau(Tableau:TTabGrid);
    Procedure OrdonnerTabDapresTab(MultiEnTete:Boolean;TableauModele:TTabGrid;Var TabAClasser:TTabGrid);
    Function AUnEtatDerive(NomTaxon:string;ListeCaracteres:TStringList):Boolean;
  end;
  var
    CouleursCaractDBoites:Array of TColor;
    EditeurImages:string;
    EditeurHtml:string;
    EditeurRtf:string;
  function NomSansExtension(NomFic:string):string;
  procedure InitCouleursCaractDBoites;
  Function compareProfils(profil1,profil2:Tprofil):integer; //renvoie 0 si les 2 profils sont identiques,
                                                                   // -1 si profil1 est contenu dans profil2
                                                                   // 1 si profil2 est contenu dans profil1
                                                                   // -2 si profil1 a moins d'tats drivs que profil2
                                                                   // 2 si profil1 a plus d'tats drivs que profil2
  Function SuiteDeZeros(n:integer):string;
  function ConvertitAffCelAffCoul(Aff:TAffichCell):TAffichCoul;
  function ConvertitAffCoulAffCel(Aff:TAffichCoul):TAffichCell;
  function DecodeInfoMol(Chaine:string;Var Codegi,Codemol,Espece:string;Circulaire,Mitochondrial:Boolean):string;
{ var
   Collections:TStringList;      //Ajout JFM 09/04/08
   NomsCollections:TstringList;
   CheminsCollections:TStringList;  //Ajout JFM 09/04/08
   NumColDef:integer;
   NumColActive:integer;            //Ajout JFM 09/04/08
   SeriesImages:TStringList;         //Ajout JFM 09/04/08
   NumSerImActive:integer;          //Ajout JFM 09/04/08
   LaSousCollection:TSousCollection; //
   ControleACopier:TWinControl;     //Ajout JFM 10/04/08
   AObserve:boolean;
   FormActivite:TForm;
   //Taxons : TTaxons;
   //Caracteres: TCaracteres;
   //TabRef:TStrListArray;
   RepIcones:string; //'Icones' les noms de fichiers contenant des icones
                                 // sont les noms des images prcds de S_
   RepImTaxons:string; //'Taxons'
   RepCaractIm:string; //'Carac-Images'         // jfr modifie le 27/05/02
   RepCaracTxt:string; //'Carac-Textes'
   RepMolecules:string; //'Molecules'
   RepFicPhg:string;//'Fichiers-Images';
   RepUtiles:string;//'Utiles';
   RepArbres:string;//'Arbres';
   RepAide:string;//'Aide';
   RepTableaux:string;//'Tableaux-Caracteres';
   RepDatation:string;// Documents concernant la datation

   CheminProg:string ; // Chemin de l'excutable
   CheminColl:string ; //Chemin du rpertoire 'Collections' parent de tous les rpertoires de collection
   CheminCollSelect :string; //Chemin du rpertoire de la collection slectionne
   CheminIcones :string;   //
   CheminImTaxons:string;
   CheminCaract:string;
   CheminCaracTxt:string;
   CheminMolecules:string;
   CheminUtiles:string;
   CheminClustal:string;
   CheminAlign :string; //  jfr modifi 2/10/2003
   CheminFicPhg:string;
   CheminArbres:string;
   CheminAide:string;
   CheminTableaux:string;
   CheminDatations:string;
   CheminConfig:string;
   CheminEchelleStrati:string;
   AdresseAide:string; // Adresse internet de l'aide en ligne
   ModeEcran800:boolean;
   TypePolytom:string;
   ModifRacine:String;
   ExempleArbre:String;
   Quadrillage:string;
   ModifRacineUnordered:string;
   FCodAuto:Boolean;
   ModeCollege:Boolean; //Ajout JFM 17/04/08
   //CollectionDefaut:string;
   PeutAfficherArbre:Boolean;
   EnleverTaxon:string;
   CodageExige:boolean;
   FTabOblig:Boolean;
   TableauCorrect:Boolean;
   TableauAmorce:Boolean;
   CodageCorrect:Boolean;
   TableauChoixModifie:Boolean;
   InitialiserBoite:Boolean;
   InitialiserBoite6:Boolean;
   InitialiserTri:Boolean;
   InitialiserCoder:Boolean;
   InitialiserArbre:Boolean;
   ArbreDApresBoites:boolean;
   ArbreDApresTri:boolean;
   ColorerDerive:boolean;

   CouleurAncetreClique:TColor;
   CouleurAncHorsGroupe:Tcolor;
   CouleurAncetreRacine:Tcolor;
   CouleurPrimitif:TColor;
   CouleurTextePrimitif:Tcolor;
   CouleurDerive:TColor;   //=CouleurAncHorsGroupe;//ClYellow; //par dfaut
   CouleurBranchesGroupe:TColor;  //=CouleurMisEnEvid
   CouleurNoeudsGroupe:TColor; //= CouleurAncDesc
   CouleursEtatsDef: array[0..17] of TColor;

   ModDeriveExcl,ModDerive,ModAncestral,Desactive:TAffichCell;

   TableauCouleurs:TTableauAffichCell;
   NavigateurHtml:string;

   function TraduitCouleur(NomC:string):TColor;
   function ChoisitCouleurTexte(CouleurFond:TColor):TColor;
   function GetTempDir: string;
   function SauveTableauV2(NomColl,NomPhg,NomFic:string;Tableau:TStringGrid):boolean;
   procedure AjouteTableauAStringList(Tableau:TStringGrid;var LaListe:TstringList);
   procedure CouleursEtatsParDefaut;
   function LitNomSerieImage(index:integer):string;
   procedure ClasserSeriesImages;
   procedure LireColSerie(NomFic:string;Var NomC,NomS:string);
   function TranscritAge(age:integer):String;
   function ValeurAge(StrAge:string):integer;//en millier d'Annes
   function AfficCellIdentiques(Aff1,Aff2:TAffichCell):boolean;
   function AfficCoulIdentiques(Aff1,Aff2:TAffichCoul):boolean;
   function ConstruireListeEtatsAncetreBis(LesTaxons:TTaxons;LesCarD:TCarDs;TabRef:TStrListArray;AvecFossiles:boolean;AfDExcl,AfD,AfA:TAffichCoul;var AfUtil:TAffichCoul;var Nomgroupe:string;var ListeTaxons:TStringList;Tableau:TColorStringGrid):TstringList;
   Function StrucTableau(LeTableau:TTabGrid):string;
   Procedure StructureTableau(LeTableau:TTabGrid;ChaineStruct:string);
   Function NomCollection(Fichier:string):string;
   function LireEnvironTab(FTab:string;var NmCollection,NomFicImage:string;var NumV:integer):boolean;
   }

implementation
uses Typedef,utils,math;

function DecodeInfoMol(Chaine:string;Var Codegi,CodeMol,Espece:string;Circulaire,Mitochondrial:Boolean):string;
Var
  CopChaine,CN,chainecode:string;
  Continuer:boolean;
  pgi,pfgi,nn:integer;
  function ExtraitCode(code:string):boolean;
  Var
    aRech,strcode:string;
    prd,prf:integer;
  begin
    ExtraitCode:=false;
    aRech:=code+'|';
    prd:=pos(aRech,CopChaine);
    if prd>0 then
      begin
        strcode:=Copy(CopChaine,prd+Length(aRech),Length(CopChaine)); //+1 ?
        prf:=pos('|',strcode);
        if prf>0 then
          begin
            ExtraitCode:=True;
            CodeMol:=Copy(CopChaine,prd,prf+Length(aRech));
            Delete(CopChaine,prd,prf+Length(aRech));
          end;
      end;
  end;
begin
  Result:='';
  CopChaine:=Chaine;
  Codegi:='';
  CodeMol:='';
  Espece:='';
  Circulaire:=False;
  Mitochondrial:=False;
  // extraction des codes de molcule;
  pgi:=pos('gi|',CopChaine);
  if pgi>0 then
    begin
      chainecode:=Copy(CopChaine,pgi+3,length(CopChaine));
      pfgi:=pos('|',chainecode);
      if pfgi=0 then pfgi:=pos(' ',chainecode);
      if pfgi>0 then
        begin
          Codegi:=Copy(CopChaine,pgi+3,pfgi-1);
          Delete(CopChaine,pgi,pfgi+3);
        end;
    end;
  Continuer:=Not ExtraitCode('gb');
  if Continuer then
    Continuer:=Not ExtraitCode('emb');
  if Continuer then
    Continuer:=Not ExtraitCode('dbj');
  if Continuer then
    Continuer:=Not ExtraitCode('sp');
  if Continuer then
    Continuer:=Not ExtraitCode('pdb');
  if Continuer then
    Continuer:=Not ExtraitCode('ref');
// Extraction du nom d'espce
  pgi:=pos('[',CopChaine);
  if pgi>0 then
    begin
      chainecode:=Copy(CopChaine,pgi+1,length(CopChaine));
      pfgi:=pos(']',chainecode);
      if pfgi>0 then
        begin
          Espece:=Copy(CopChaine,pgi+1,pfgi-1);
          Delete(CopChaine,pgi,pfgi+1);
        end;
    end;
// Extraction des tags
  pgi:=Pos('<Circ>',CopChaine);
  Circulaire:=(pgi>0); //ADN circulaire
  if Circulaire then
    Delete(CopChaine,pgi,6);
  pgi:=Pos('<MitM>',CopChaine);
  Mitochondrial:=(pgi>0); // Mitochondrie de Mammifre
  if Mitochondrial then
    Delete(CopChaine,pgi,6);
  //Suppression des espaces multiples
  pgi:=pos('  ',CopChaine);
  While pgi>0 do
    begin
      Delete(CopChaine,pgi,1);
      pgi:=pos('  ',CopChaine);
    end;
  Result:=Trim(CopChaine);
end;
Function SuiteDeZeros(n:integer):string;
Var
  i:integer;
begin
  Result:='';
  For i:=1 to n do Result:=Result+'0';
end;

Function compareProfils(profil1,profil2:Tprofil):integer;
Var
  i,n,n1,n2:integer;
  inclu21,inclu12:boolean;
  identiques:boolean;
begin
  Result:=-3;
  inclu21:=true;
  inclu12:=true;
  n:=Length(profil1);
  if Length(profil2)<>n then exit;
  identiques:=True;
  n1:=0;
  n2:=0;
  For i:=0 to n-1 do
    begin
      if profil1[i]<>profil2[i] then
        begin
          identiques:=False;
          if profil1[i]=0 then inclu12:=false
          else if profil2[i]=0 then inclu21:=false;
          //if profil1[i]>profil2[i] then inclu12:=false
          //else inclu21:=false;
        end;
      if profil1[i]>0 then inc(n1);
      if profil2[i]>0 then inc(n2);
    end;
  if identiques then result:=0
  else if inclu21 then result:=1
  else if inclu12 then result:=-1
  else if n2>n1 then result:=-2
  else result:=2;
end;
function ConvertitAffCelAffCoul(Aff:TAffichCell):TAffichCoul;
begin
  Result.Active:=Aff.Active;
  Result.CouleurFond:=Aff.CouleurFond;
  Result.CouleurTexte:=Aff.CouleurTexte;
  Result.styleFond:=Aff.styleFond;
  Result.CouleurContour:=Aff.CouleurContour;
end;
function ConvertitAffCoulAffCel(Aff:TAffichCoul):TAffichCell;
begin
  Result.Active:=Aff.Active;
  Result.CouleurFond:=Aff.CouleurFond;
  Result.CouleurTexte:=Aff.CouleurTexte;
  Result.styleFond:=Aff.styleFond;
  Result.CouleurContour:=Aff.CouleurContour;
end;

{

Function StrucTableau(LeTableau:TTabGrid):string;
Var
  Liste:TStringList;
  Ligne:TStringList;
  i,j,nb:integer;
begin
  Result:='';
  Liste:=TStringList.Create;
  Ligne:=TStringList.Create;
  try
    nb:=LeTableau.FixedRows;
    Liste.Add(IntToStr(nb));
    For i:=0 to LeTableau.RowCount-1 do
      begin
        Ligne.Clear;
        For j:=0 to LeTableau.ColCount-1 do
          Ligne.Add(LeTableau.Cells[j,i]);
        Liste.Add(Ligne.CommaText);
      end;
   Result:=Liste.CommaText;
  finally
    Liste.Free;
    Ligne.Free;
  end;
end;

Procedure StructureTableau(LeTableau:TTabGrid;ChaineStruct:string);
Var
  Liste:TStringList;
  Ligne:TStringList;
  i,j,n,nb:integer;
begin
  Liste:=TStringList.Create;
  Ligne:=TStringList.Create;
  try
    Liste.CommaText:=ChaineStruct;
    nb:=StrToInt(Liste[0]);
    n:=Liste.Count-1;
    LeTableau.RowCount:=n;
    For i:=0 to n-1 do
      begin
        Ligne.CommaText:=Liste[i+1];
        LeTableau.ColCount:=Ligne.Count;
        For j:=0 to LeTableau.ColCount-1 do
          LeTableau.Cells[j,i]:=Ligne[j];
      end;
    LeTableau.FixedRows:=nb;
    LeTableau.FixedCols:=1;
  finally
    Liste.Free;
    Ligne.Free;
  end;
end;

function ChoisitCouleurTexte(CouleurFond:TColor):TColor;
Var
  Val:real;
  R,G,B:LongInt;
begin
  B:=(CouleurFond and $FF0000) div $10000;
  G:=(CouleurFond and $FF00) div $100;
  R:=(CouleurFond and $FF);
  Val:=0.2126*R+0.7152*G+0.0722*B;
  if Val>127 then
    Result:=clBlack
  else
    Result:=clWhite;
end;

function AfficCoulIdentiques(Aff1,Aff2:TAffichCoul):boolean;
begin
  Result:=True;
  if Aff1.Active<>Aff2.Active then Result:=False
  else if Aff1.CouleurFond<>Aff2.CouleurFond then Result:=False
  else if Aff1.CouleurTexte<>Aff2.CouleurTexte then Result:=False
  else if Aff1.styleFond<> Aff2.styleFond then Result:=False
  else if Aff1.CouleurContour<> Aff2.CouleurContour then Result:=False;
end;

function AfficCellIdentiques(Aff1,Aff2:TAffichCell):boolean;
begin
  Result:=True;
  if Aff1.Active<>Aff2.Active then Result:=False
  else if Aff1.CouleurFond<>Aff2.CouleurFond then Result:=False
  else if Aff1.CouleurTexte<>Aff2.CouleurTexte then Result:=False
  else if Aff1.styleFond<> Aff2.styleFond then Result:=False
  else if Aff1.CouleurContour<> Aff2.CouleurContour then Result:=False;
end;
}
function TranscritAge(age:integer):String;
begin
  if age=0 then Result:=''
//  else if age>=1000 then Result:=FormatFloat('###0.##',age/1000)+' Ma'
  else if age>=1000 then Result:=FormatFloat('###0.##',age/1000)+M_Ma_2
//  else Result:=IntToStr(age*1000)+' ans';
  else Result:=IntToStr(age*1000)+M_ans;
end;
function ValeurAge(StrAge:string):integer;//en millier d'Annes
Var
  p:integer;
  copie:string;
begin
  if StrAge='' then Result:=0
  else
    begin
//      p:=pos(' MA',UpperCase(StrAge));
      p:=pos(M_Ma_2,UpperCase(StrAge));
      copie:=StrAge;
      if p>0 then
        begin
          Delete(copie,p,3);
          Result:=1000;
        end
      else Result:=1;
      copie:=Trim(Copie);
      try
        Result:=Round(Result*StrToFloat(Copie));
      except
        Result:=0;
      end;
    end;
end;

procedure LireColSerie(NomFic:string;Var NomC,NomS:string);
Var
  ListeLignes:TStringList;
begin
  NomC:='';
  NomS:='';
  ListeLignes:=TStringList.Create;
  if FileExists(NomFic) then
    ListeLignes.LoadFromFile(NomFic)
  else exit;
  if ListeLignes.Count>2 then
    begin
      NomC:=ListeLignes[0];
      NomS:=ListeLignes[1];
    end;
  ListeLignes.Free;
end;

function NomSansExtension(NomFic:string):string;
Var
  ext:string;
  n:integer;
begin
  Result:=ExtractFileName(NomFic);
  ext:=ExtractFileExt(Result);
  n:=Length(Result)-Length(ext);
  Result:=Copy(Result,1,n);
end;
procedure InitCouleursCaractDBoites;
Var
  i:integer;
begin
  SetLength(CouleursCaractDBoites,29);
  i:=0;
  CouleursCaractDBoites[i]:=clPalevioletred; //0
  inc(i);
  CouleursCaractDBoites[i]:=clLavender;   //1
  inc(i);
  CouleursCaractDBoites[i]:=clSalmon;  //2
  inc(i);
  CouleursCaractDBoites[i]:=clWheat;   //3
  inc(i);
  CouleursCaractDBoites[i]:=clLightsteelblue;   //4
  inc(i);
  CouleursCaractDBoites[i]:=clCadetblue;   //5
  inc(i);
  CouleursCaractDBoites[i]:=clDarkorange;  //6
  inc(i);
  CouleursCaractDBoites[i]:=clMediumturquoise; //7
  inc(i);
  CouleursCaractDBoites[i]:=clPalegoldenrod;  //8
  inc(i);
  CouleursCaractDBoites[i]:=clTan;  //9
  inc(i);
  CouleursCaractDBoites[i]:=clPalegreen; //10
  inc(i);
  CouleursCaractDBoites[i]:=clMediumaquamarine;  //11
  inc(i);
  CouleursCaractDBoites[i]:=clAqua;  //12
  inc(i);
  CouleursCaractDBoites[i]:=clSilver;  //13
  inc(i);
  CouleursCaractDBoites[i]:=clPink;   //14
  inc(i);
  CouleursCaractDBoites[i]:=clOrchid;  //15
  inc(i);
  CouleursCaractDBoites[i]:=clWhistle; //16
  inc(i);
  CouleursCaractDBoites[i]:=clCoral;   //17
  inc(i);
  CouleursCaractDBoites[i]:=clRed;    //18
  inc(i);
  CouleursCaractDBoites[i]:=clBlue;  //19
  inc(i);
  CouleursCaractDBoites[i]:=clLime;     //20
  inc(i);
  CouleursCaractDBoites[i]:=clFuchsia;  //21
  inc(i);
  CouleursCaractDBoites[i]:=clSkyBlue;  //22
  inc(i);
  CouleursCaractDBoites[i]:=clDkGray;  //23
  inc(i);
  CouleursCaractDBoites[i]:=$C0FFFF;  //jaune-ple 24
  inc(i);
  CouleursCaractDBoites[i]:=$00C0FF;        // orange 25
  inc(i);
  CouleursCaractDBoites[i]:=clgreen;        // 26
  inc(i);
  CouleursCaractDBoites[i]:=clNavy;        // 27
  inc(i);
  CouleursCaractDBoites[i]:=clWhite;   //28
end;

procedure AjouteTableauAStringList(Tableau:TStringGrid;var LaListe:TstringList);
Var
  ARow:integer;
  Acol:integer;
  StrRef:string;
begin
  for ARow:=0 to Tableau.RowCount-1 do
    begin
      StrRef:=Tableau.Cells[0,ARow];
      For ACol:=1 to Tableau.ColCount-1 do
        StrRef:=StrRef+#7+Tableau.Cells[Acol,ARow];
     StrRef:=StrRef+#13+#10;
     LaListe.Add(StrRef);
    end;
end;
function SauveTableauV2(NomColl,NomPhg,NomFic:string;Tableau:TStringGrid):boolean;
Var
  ARow:integer;
  Acol:integer;
  data: TMemoryStream;
  StrRef:string;
begin
  data:=NIL;
  Result:=False;
  try
    data:=TMemoryStream.Create;
    StrRef:='<V2>'+#13+#10+NomColl+#13+#10+NomPhg+#13+#10;
    data.Write(StrRef[1],length(StrRef));
    for ARow:=0 to Tableau.RowCount-1 do
      begin
        StrRef:=Tableau.Cells[0,Arow];
        For ACol:=1 to Tableau.ColCount-1 do
          StrRef:=StrRef+#7+Tableau.Cells[Acol,ARow];
       StrRef:=StrRef+#13+#10;
       data.Write(StrRef[1],length(StrRef));
      end;
    Result:=True;
  finally
    data.Free;
  end;
end;

function TraduitCouleur(NomC:string):TColor;
Var
  NomsCouleurs: Array [0..19] of string[12];
  ValeursCouleurs: Array [0..19] of TColor;
  i:integer;
begin
  NomsCouleurs[0]:='noir';
  ValeursCouleurs[0]:=clBlack;
  NomsCouleurs[1]:='marron';
  ValeursCouleurs[1]:=clMaroon;
  NomsCouleurs[2]:='vert-sombre';
  ValeursCouleurs[2]:=clGreen;
  NomsCouleurs[3]:='olive';
  ValeursCouleurs[3]:=clOlive;
  NomsCouleurs[4]:='bleu-nuit';
  ValeursCouleurs[4]:=clNavy;
  NomsCouleurs[5]:='pourpre';
  ValeursCouleurs[5]:=clPurple;
  NomsCouleurs[6]:='teal';
  ValeursCouleurs[6]:=clTeal;
  NomsCouleurs[7]:='gris';
  ValeursCouleurs[7]:=clGray;
  NomsCouleurs[8]:='argent';
  ValeursCouleurs[8]:=clSilver;
  NomsCouleurs[9]:='rouge';
  ValeursCouleurs[9]:=clRed;
  NomsCouleurs[10]:='vert';
  ValeursCouleurs[10]:=clLime;
  NomsCouleurs[11]:='jaune';
  ValeursCouleurs[11]:=clYellow;
  NomsCouleurs[12]:='bleu';
  ValeursCouleurs[12]:=clBlue;
  NomsCouleurs[13]:='fuchsia';
  ValeursCouleurs[13]:=clFuchsia;
  NomsCouleurs[14]:='bleu-ciel';
  ValeursCouleurs[14]:=clAqua;
  NomsCouleurs[15]:='gris-clair';
  ValeursCouleurs[15]:=clLtGray;
  NomsCouleurs[16]:='gris-fonce';
  ValeursCouleurs[16]:=clDkGray;
  NomsCouleurs[17]:='blanc';
  ValeursCouleurs[17]:=clWhite;
  NomsCouleurs[18]:='jaune-pale';
  ValeursCouleurs[18]:=$C0FFFF;
  NomsCouleurs[19]:='orange';
  ValeursCouleurs[19]:=$00C0FF;
  Result:=0;
  For i:=0 to 19 do
    if UpperCase(Nomc)=UpperCase(NomsCouleurs[i]) then
      begin
        Result:=ValeursCouleurs[i];
        break;
      end;
end;
function GetTempDir: string;
var
  Buffer: array[0..MAX_PATH] of Char;
begin
  GetTempPath(SizeOf(Buffer) - 1, Buffer);
  Result := StrPas(Buffer);
end;
//*********  TListeAttributs  ***************
constructor TListeAttributs.Create;
begin
  inherited Create;
  AttributNul.Caractere:='';
  AttributNul.Etat:='';
  AttributNul.NumEtat:=-1;
  AttributNul.Statut:=1;
end;
Destructor TListeAttributs.Destroy;
begin
  SetLength(FAttributs,0);
  inherited Destroy;
end;
procedure TListeAttributs.Add(UnAttribut:TAttribut);
var
  i,n:integer;
  nouveau:boolean;
begin
  n:=Length(FAttributs);
  nouveau:=true;
  for i:=0 to n-1 do
    begin
      if UnAttribut.Caractere=Fattributs[i].Caractere then
        begin
          Fattributs[i].Etat:=UnAttribut.Etat;
          Fattributs[i].NumEtat:=UnAttribut.NumEtat;
          Fattributs[i].Statut:=UnAttribut.Statut;
          nouveau:=false;
          break;
        end;
    end;
  if nouveau then
    begin
      SetLength(FAttributs,n+1);
      FAttributs[n]:=UnAttribut;
    end;
end;
procedure TListeAttributs.Clear;
begin
  SetLength(FAttributs,0);
end;
function TListeAttributs.AttributDe(NomCar:string):TAttribut;
var
  i:integer;
begin
  Result:=AttributNul;
  for i:=0 to Length(FAttributs)-1 do
    begin
      if Fattributs[i].Caractere=NomCar then
        begin
          Result:=Fattributs[i];
          break;
        end;
    end;
end;
function TListeAttributs.NumeroEtat(NomCar:string):integer;
var
  i:integer;
begin
  Result:=-1;
  for i:=0 to Length(FAttributs)-1 do
    begin
      if Fattributs[i].Caractere=NomCar then
        begin
          Result:=Fattributs[i].NumEtat;
          break;
        end;
    end;
end;
function TListeAttributs.Etat(NomCar:string):string;
var
  i:integer;
begin
  Result:='';
  for i:=0 to Length(FAttributs)-1 do
    begin
      if Fattributs[i].Caractere=NomCar then
        begin
          Result:=Fattributs[i].Etat;
          break;
        end;
    end;
end;
function TListeAttributs.Statut(NomCar:string):integer;
var
  i:integer;
begin
  Result:=-1;
  for i:=0 to Length(FAttributs)-1 do
    begin
      if Fattributs[i].Caractere=NomCar then
        begin
          Result:=Fattributs[i].Statut;
          break;
        end;
    end;
end;
procedure TListeAttributs.Ajoute(NomCar,Etat:string;NumEtat,Statut:integer);
Var
  UnAttribut:TAttribut;
begin
  UnAttribut.Caractere:=NomCar;
  UnAttribut.Etat:=Etat;
  UnAttribut.NumEtat:=NumEtat;
  UnAttribut.Statut:=Statut;
  Add(UnAttribut);
end;
procedure TListeAttributs.ModifieOuAjoute(NomCar,Etat:string;NumEtat,Statut:integer);
Var
  i,n:integer;
  Ajouter:Boolean;
begin
  Ajouter:=True;
  n:=Length(FAttributs)-1;
  for i:=0 to n do
    begin
      if Fattributs[i].Caractere=NomCar then
        begin
          Fattributs[i].Etat:=Etat;
          Fattributs[i].NumEtat:=NumEtat;
          Fattributs[i].Statut:=Statut;
          Ajouter:=False;
          Break;
        end
    end;
  if Ajouter then
    Ajoute(NomCar,Etat,NumEtat,Statut);
end;
procedure TListeAttributs.Retire(NomCar:string);
var
  i,j,n:integer;
begin
  n:=Length(FAttributs)-1;
  for i:=0 to n do
    begin
      if Fattributs[i].Caractere=NomCar then
        begin
          for j:=i to n-1 do
            Fattributs[j]:=Fattributs[j+1];
          SetLength(FAttributs,n);
          break;
        end;
    end;
end;

//*****  TSousCollection *****
constructor TSousCollection.Create;
begin
  inherited Create;
  Exclusions:='';
  CommencerPar:='';
  ArbreExclu:=false;
  ClasserMode6:=False;
  NomTaxonExtraGroupe:='';
  DatationFaite:=False;
  FAccesArbre:=False;
end;
destructor TSousCollection.Destroy;
begin
  if TabRef<>Nil then TabRef.Free;
  if TabRefRef<>Nil then TabRefRef.Free;
  if FEnsGroupes<>Nil then FEnsGroupes.Free;

  inherited Destroy;
end;
function TSousCollection.RechercheDocTaxonsSup:string;
Var
  chaine:string;
begin
  Result:='';
  chaine:=Caracteres.CheminTextesC+'DocTaxonsSup.rtf';
  if Not FileExists(chaine) then
    begin
      chaine:=Caracteres.CheminTextesC+'DocTaxonsSup.txt';
      if Not FileExists(chaine) then
        begin
          chaine:=Caracteres.CheminTextesC+'DocTaxonsSup.odt';
          if Not FileExists(chaine) then
            begin
              chaine:=Caracteres.CheminTextesC+'DocTaxonsSup.doc';
              if Not FileExists(chaine) then
                begin
                  chaine:=Caracteres.CheminTextesC+'DocTaxonsSup.pdf';
                  if Not FileExists(chaine) then
                    begin
                      chaine:=Caracteres.CheminTextesC+'DocTaxonsSup.html';
                      if Not FileExists(chaine) then
                        begin
                          chaine:=Caracteres.CheminTextesC+'DocTaxonsSup.htm';
                        end;
                    end;
                end;
            end;
        end;
    end;
  if FileExists(chaine) then
    Result:=Chaine;
end;

function TSousCollection.RechercheDoc(NomTaxon,NomCarD:string;var Numtaxon,NumCar:integer;var legende:string):string;
Var
  NumCarD:integer;
  LeCarD:TCaractD;
  Etat:string;
  NumEtat:integer;
  chaine:string;
  Col,Row:integer;
begin
  Result:='';
  legende:='';
  NumCar:=-2;
  NumTaxon:=Taxons.GetNumTaxon(NomTaxon);
  if NumTaxon>-1 then
    begin
      NumCarD:=Caracteres.GetNumCarD(NomCarD);
      if NumCarD>-1 then
        begin
          NumCar:=Caracteres.GetNumCarParent(NumCarD);
          if NumCar>-1 then
            begin
              chaine:=Taxons.GetTexteCar(NumTaxon,NumCar);
              if Not FileExists(chaine) then chaine:=Taxons.GetImageCar(NumTaxon,NumCar);
              if FileExists(chaine) then
                begin
                  Result:=Chaine; // rponse classique
                  exit;
                end;
            end
          else if NumCar=-2 then
            begin
              chaine:=Taxons.GetImage(NumTaxon);
              if FileExists(chaine) then
                begin
                  Result:=Chaine; // image du taxon
                  exit;
                end;
            end;
          row:=TabRef.IndexOfRow(NomTaxon);
          col:=TabRef.IndexOfcol(NomCarD);
          if (row>-1)and (col>-1) then
            begin
              Etat:=TabRef.StrItems[Row,Col];
              //LeCarD:=TCaractD(Caracteres.CarD[NumCarD]);
              LeCarD:=Caracteres.CarDs.Items[NumCarD];
              NumEtat:=LeCarD.ListeEtats.IndexOf(Etat);
              if NumEtat>-1 then
                chaine:=Caracteres.GetDocEtat(NumCarD,NumEtat)
              else chaine:='';
              if FileExists(Chaine) then
                Result:=Chaine  // doc gnrique correspondant  l'tat du CarD
              else
                begin
                  legende:=NomCarD+' : '+Etat;  // sinon retourner NomCarD=etat
                  chaine:=Taxons.GetImage(NumTaxon);
                end;
                if FileExists(Chaine) then Result:=Chaine;
            end;
        end;
    end;
end;

procedure TSousCollection.RechercheDocsCompl;
Var
  i:integer; //,j
  Tax:TTaxon;
  Dossier :string;
begin
  if Caracteres.CheminImagesC<>'' then
    for i:=0 to Taxons.Count-1 do
      begin
        Tax:=TTaxon(Taxons.Items[i]);
        Dossier:=Taxons.GetImage(i);
        Dossier:=NomSansExtension(Dossier);
        Dossier:=Caracteres.CheminImagesC+Dossier;
        RechercheTousFichiers(Dossier,Tax.DocsDivers);
      end;
end;
procedure TSousCollection.EcritLigneConf(LaListe:TStringList);
Var
  chaine:string;
begin
  Chaine:='';
  //  Fentres non accessibles avec la sous-collection
  if Exclusions<>'' then Chaine:='<Exclusions:'+Exclusions+'>';
  // Par exemple B pour FormClasser6
  if CommencerPar<>'' then Chaine:=Chaine+'<CommencerPar:'+CommencerPar+'>';
  // pour exclure la possibilit d'afficher l'arbre dans FormClasse
  if ArbreExclu then Chaine:=Chaine+'<ArbreExclu>';
  if ClasserMode6 then Chaine:=Chaine+'<ClasserMode6>';
  if FModeCollege then Chaine:=Chaine+'<ModeCollege>';
  if FAccesArbre then Chaine:=Chaine+'<AccesArbre>';
  if NomTaxonExtragroupe<>'' then Chaine:=Chaine+'<NomTaxonExtragroupe:'+NomTaxonExtragroupe+'>';
  if DatationFaite then Chaine:=Chaine+'<DatationFaite>';
  LaListe.Add(Chaine);
end;
procedure TSousCollection.LitLigneConf(LaListe:TstringList;var n:integer);
Var
  chaine:string;
  sousChaine:string;
  p:integer;  //,ps
  function Chercher(AChercher:string):boolean;
  Var
    l:integer;
  begin
    Result:=False;
    l:=Length(AChercher);
    p:=pos(AChercher,chaine);
    if p>0 then 
      begin
        Delete(Chaine,p,l);
        Result:=True;
      end;
  end;
begin
  Chaine:=LaListe.Strings[n];
  inc(n);
  CommencerPar:='';
  Exclusions:='';
  ClasserMode6:=False;
  FModeCollege:=False;
  if Chercher('<ClasserMode6>') then
    ClasserMode6:=true;
  if Chercher('<ArbreExclu>') then
    ArbreExclu:=true;
  if Chercher('<ModeCollege>') then
    FModeCollege:=true;
  if Chercher('<AccesArbre>') then
    FAccesArbre:=true;
  if Chercher('<DatationFaite>') then
    DatationFaite:=true;
  if Chercher('<CommencerPar:') then
    begin
      CommencerPar:=Chaine[p];
      Delete(Chaine,p,2);
    end;

  if Chercher('<Exclusions:') then
    begin
      SousChaine:=Copy(Chaine,p,Length(Chaine)-p);//+1
      p:=pos('>',SousChaine);
      if p>0 then
        begin
          Exclusions:=Copy(SousChaine,1,p-1);
          //MessageDlg('sous-chane: '+ SousChaine+' Exclusions: '+Exclusions,mtInformation,[mbOK],0);
        end
      else
        begin
          Exclusions:=SousChaine;
          //MessageDlg('sous-chane: '+ SousChaine+' Exclusions: '+Exclusions,mtInformation,[mbOK],0);
        end;
    end;
  NomTaxonExtragroupe:='';
  if Chercher('<NomTaxonExtragroupe:') then
    begin
      NomTaxonExtragroupe:=Copy(Chaine,p,Length(Chaine)-p);
      //MessageDlg('NomTaxonExtragroupe: '+NomTaxonExtragroupe,mtInformation,[mbOK],0);
    end;
end;
Function TSousCollection.StructCph(Tout:Boolean):string;
var
  ListeLignes: TStringList;
  T:TTaxon;
  LeCarD:TCaractD;
  LesCarD:TList;
  i,j,col,lig:integer;
  chaine:string;
begin
  ListeLignes:=TStringList.Create;
  try
    ListeLignes.Add(ExtractFileName(DossierCollection));  // nom du dossier de la collection
    ListeLignes.Add(Nom);  // nom  afficher pour la collection d'images
    EcritLigneConf(ListeLignes);
    // sauvegarde de la structure Taxons  quivalente au .phg
    Taxons.CopieDansStringList(Tout,ListeLignes);
    ListeLignes.Add('<Caractres V2>'); // sauvegarde des caractres  quiv .car et .cod
                                                   // limiter  ceux qui sont slectionns
    Caracteres.TransformeCarEnStrinList(true,Tout,ListeLignes);
    ListeLignes.Add('<Tableau Ref>'); // sauvegarde du tableau de rfrence : quivalent du .tab
    //sauvegarde de la partie utile du .tab  tout si Tout=True
    LesCarD:=TList.Create;  // liste des caractresD slectionns
    //For i:=0 to Caracteres.CarD.Count-1 do
    For i:=0 to Caracteres.CarDs.GetNbCarD-1 do
      begin
        //LeCarD:=TCaractD(Caracteres.CarD[i]);
        LeCarD:=Caracteres.CarDs.Items[i];
        if (Tout or LecarD.Selected) then LesCarD.Add(LeCarD);
      end;
    chaine:=#7;
    For i:=0 to LesCarD.Count-1 do
      begin
        LeCarD:=TCaractD(LesCarD[i]);
        chaine:=chaine+LeCard.Nom+#7;
      end;
    ListeLignes.Add(chaine);

    For i:=0 to Taxons.NbTaxons-1 do
      begin
        T:=TTaxon(Taxons[i]);
        if (Tout or T.Selected) then
          begin
            chaine:=T.Nom+#7;
            for j:=0 to LesCarD.Count-1 do
              begin
                LeCard:=TCaractD(LesCard[j]);
                lig:=TabRef.IndexOfRow(T.Nom);
                col:=TabRef.IndexOfCol(LeCard.Nom);
                Chaine:=Chaine+TabRef.StrItems[lig,col]+#7;
              end;
            ListeLignes.Add(chaine);
          end;
      end;
    Result:=ListeLignes.CommaText;
  finally
    ListeLignes.Free;
    if LesCarD<> nil then LesCarD.Free;
  end;
end;

procedure TSousCollection.EnregistreCph(Tout:boolean;NmSsCol:string;NomFic:string);
var
  ListeLignes: TStringList;
  T:TTaxon;
  LeCarD:TCaractD;
  LesCarD:TList;
  i,j,col,lig:integer;
  chaine:string;
begin
  ListeLignes:=TStringList.Create;
  try
    ListeLignes.Add(ExtractFileName(DossierCollection));  // nom du dossier de la collection
    ListeLignes.Add(NmSsCol);  // nom  afficher pour la collection d'images
    EcritLigneConf(ListeLignes);
    // sauvegarde de la structure Taxons  quivalente au .phg
    Taxons.CopieDansStringList(Tout,ListeLignes);
    ListeLignes.Add('<Caractres V2>'); // sauvegarde des caractres  quiv .car et .cod
                                                   // limiter  ceux qui sont slectionns
    Caracteres.TransformeCarEnStrinList(true,Tout,ListeLignes);
    ListeLignes.Add('<Tableau Ref>'); // sauvegarde du tableau de rfrence : quivalent du .tab
    //sauvegarde de la partie utile du .tab
    LesCarD:=TList.Create;  // liste des caractresD slectionns
    //For i:=0 to Caracteres.CarD.Count-1 do
    For i:=0 to Caracteres.CarDs.GetNbCarD-1 do
      begin
        //LeCarD:=TCaractD(Caracteres.CarD[i]);
        LeCarD:=Caracteres.CarDs.Items[i];
        if (Tout or LecarD.Selected) then LesCarD.Add(LeCarD);
      end;
    chaine:=#7;
    For i:=0 to LesCarD.Count-1 do
      begin
        LeCarD:=TCaractD(LesCarD[i]);
        chaine:=chaine+LeCard.Nom+#7;
      end;
    ListeLignes.Add(chaine);

    For i:=0 to Taxons.NbTaxons-1 do
      begin
        T:=TTaxon(Taxons[i]);
        if (Tout or T.Selected) then
          begin
            chaine:=T.Nom+#7;
            for j:=0 to LesCarD.Count-1 do
              begin
                LeCard:=TCaractD(LesCard[j]);
                lig:=TabRef.IndexOfRow(T.Nom);
                col:=TabRef.IndexOfCol(LeCard.Nom);
                Chaine:=Chaine+TabRef.StrItems[lig,col]+#7;
              end;
            ListeLignes.Add(chaine);
          end;
      end;
    ListeLignes.SaveToFile(NomFic);
  finally
    ListeLignes.Free;
    if LesCarD<> nil then LesCarD.Free;
  end;
end;
function TSousCollection.DocsEtatsPresents(NumCarD:integer):boolean;
begin
  Result:=False;
  if Caracteres.GetDocEtat(NumCarD,0)<>'' then result:=True;
end;

procedure TSousCollection.RazConfig;
begin
  Exclusions:='';
  CommencerPar:='';
  ArbreExclu:=false;
  Nom:='';
end;
Function TSousCollection.LitSousCollection(NomFic:string):boolean;
Var
  extension:string;
  NomFicCar:string;
  NomFicCod:string;
  NomFicTab:string;
begin
  Result:=False;
  FichierCph:=NomFic;
  extension:=ExtractFileExt(NomFic);
  NomFicBase:=ExtractFileName(NomFic);
  NomFicBase:=Copy(NomFicBase,1,Length(NomFicBase)-Length(Extension));
  RazConfig;
  if UpperCase(extension) = '.CPH' then LitCph(NomFic)
  else if UpperCase(extension) = '.PHG' then
    begin

       // RAZ des Taxons
      Taxons.Free; // si une autre liste tait en mmoire on la libre
      Taxons:=TTaxons.Create;
      // charger le .phg;
      //Taxons.CheminImagesT:=CheminImTaxons;
      //Taxons.CheminIconesT:=CheminIcones;
      Taxons.LireFichier(NomFic);
      // RAZ des Caractres
      Caracteres.Free;
      Caracteres:=TCaracteres.Create;
      // charger le .car;
      NomFicCar:=DossierUtiles+NomFicBase+ExtFicCar;
      if Not FileExists(NomFicCar) then
        NomFicCar:=DossierCarIm+NomFicBase+ExtFicCar;
      if Not FileExists(NomFicCar) then
        begin
//          MessageDlg('Le fichier '+ExtractFileName(NomFicCar)+' n''existe pas',mtError,[mbOk],0);
          MessageDlg(M_Lefichier+ExtractFileName(NomFicCar)+L_NexistePas,mtError,[mbOk],0);
          exit;
        end;
      Caracteres.LireCar(NomFicCar);
      //Caracteres.CheminImagesC:=DossierCarIm;
      //Caracteres.CheminTextesC:=CheminCaracTxt;
      Taxons.FCaracteres:=Caracteres;
      // charger le .cod;
      NomFicCod:=DossierUtiles+NomFicBase+ExtFicCod;
      if Not FileExists(NomFicCod) then
        NomFicCod:=DossierCarIm+NomFicBase+ExtFicCod;
      {if Not FileExists(NomFicCod) then
        begin
          MessageDlg('Le fichier '+ExtractFileName(NomFicCod)+' n''existe pas'
          +#10#13+'Il sera gnr automatiquement',mtWarning,[mbOk],0);
        end
      else}
        Caracteres.LireCod(NomFicCod);
      // charger le .tab; de rfrence; DossierTab:string;
      NomFicTab:=DossierTab+NomFicBase+ExtFicMat;
      if Not FileExists(NomFicTab) then
        NomFicTab:=DossierCarIm+NomFicBase+ExtFicMat;
      if Not FileExists(NomFicTab) then
        NomFicTab:=DossierUtiles+NomFicBase+ExtFicMat;
      if Not FileExists(NomFicTab) then
        begin
//          MessageDlg('Le fichier '+ExtractFileName(NomFicTab)+' n''existe pas'
          MessageDlg(M_Lefichier+ExtractFileName(NomFicTab)+L_NexistePas
//          +#10#13+'Le tableau ne pourra tre corrig',mtWarning,[mbOk],0);
          +#10#13+M_Letableaunepourrat,mtWarning,[mbOk],0);
        end
      else
        begin
          LitTabref(NomFicTab);
          MemoriseTabRef;
        end;
    end;
  MesCarD:=Caracteres.CarDs;
  Result:=True;
end;
Function TSousCollection.LitStrucCph(ChaineStruc:String):Boolean;
var
  ListeLignes: TStringList;
  num:integer;
begin
  ListeLignes:=TStringList.Create;
  FichierCph:='';
  NomFicBase:='';
  NomTaxonExtraGroupe:='';
  try
    RazConfig;
    ListeLignes.CommaText:=ChaineStruc;
    DossierCollection:=ListeLignes.Strings[0];  // nom du dossier de la collection
    Nom:=ListeLignes.Strings[1];  // nom  afficher pour la collection d'images
    // chargement de la structure Taxons  quivalente au .phg
    Num:=2;
    LitLigneConf(ListeLignes,num);
    Taxons.Free;
    Taxons:=TTaxons.Create;
    Taxons.LitDansStringList(ListeLignes,num);
    //ListeLignes.Add('<Caractres V2>'); // sauvegarde des caractres  quiv .car et .cod
    // chargement de la structure Caracteress  quivalente aux .car et .cod
    Caracteres.Free;
    Caracteres:=TCaracteres.Create;
    Caracteres.LireCarDeStrinList(true,num,ListeLignes);
    Taxons.FCaracteres:=Caracteres;
    //ListeLignes.Add('<Tableau Ref>'); // sauvegarde du tableau de rfrence : quivalent du .tab
    //chargement du .tab
    if TabRef=Nil then TabRef:=TStrListArray.createListArray;
    TabRef.LitDeStrList(ListeLignes,#7,num);
    MemoriseTabRef; //Conservation d'une copie en cas de modification
  finally
    ListeLignes.Free;
  end;
  Result:=True;
end;

procedure TSousCollection.LitCph(NomFic:string);
var
  ListeLignes: TStringList;
  num:integer;
begin
  ListeLignes:=TStringList.Create;
  FichierCph:=NomFic;
  NomFicBase:=ExtractFileName(NomFic);
  NomFicBase:=Copy(NomFicBase,1,Length(NomFicBase)-4);
  NomTaxonExtraGroupe:='';
  try
    RazConfig;
    ListeLignes.LoadFromFile(NomFic);
    DossierCollection:=ListeLignes.Strings[0];  // nom du dossier de la collection
    Nom:=ListeLignes.Strings[1];  // nom  afficher pour la collection d'images
    // chargement de la structure Taxons  quivalente au .phg
    Num:=2;
    LitLigneConf(ListeLignes,num);
    Taxons.Free;
    Taxons:=Ttaxons.Create;
    Taxons.LitDansStringList(ListeLignes,num);
    //ListeLignes.Add('<Caractres V2>'); // sauvegarde des caractres  quiv .car et .cod
    // chargement de la structure Caracteress  quivalente aux .car et .cod
    Caracteres.Free;
    Caracteres:=TCaracteres.Create;
    Caracteres.LireCarDeStrinList(true,num,ListeLignes);
    Taxons.FCaracteres:=Caracteres;
    //ListeLignes.Add('<Tableau Ref>'); // sauvegarde du tableau de rfrence : quivalent du .tab
    //chargement du .tab
    if TabRef=Nil then TabRef:=TStrListArray.createListArray;
    TabRef.LitDeStrList(ListeLignes,#7,num);
    MemoriseTabRef; //Conservation d'une copie en cas de modification
  finally
    ListeLignes.Free;
  end;
end;
procedure TSousCollection.LitTabref(NomFicTab:string);
Var
  ListeLignes:TstringList;
  num:integer;
begin
  ListeLignes:=TstringList.Create;
  ListeLignes.LoadFromFile(NomFicTab);
  If ListeLignes[0]='<V2>' then num:=3
  else num:=1;
  if TabRef=nil then TabRef:=TStrListArray.createListArray;
  TabRef.LitDeStrList(ListeLignes,#7,num);
  ListeLignes.Free;
  VerifieTabRef;
end;
procedure TSousCollection.VerifieTabRef;
Var
  i,j,col:integer;
  UnCarD:TCaractD;
  copieTab:TStrListArray;
  changement:Boolean;
begin
  changement:=false;
  copieTab:=TStrListArray.createListArray;
  //copieTab.RowCount:=TabRef.RowCount;
  col:=0;
  //copieTab.ColCount:=col+1;
  For j:=0 to TabRef.RowCount-1 do
    copieTab.StrItems[j,0]:=TabRef.StrItems[j,0];
  For i:=1 to Tabref.GetMaxColCount-1 do
    begin
      UnCarD:=LeCarD(TabRef.StrItems[0,i]);
      If UnCarD<>Nil then
        begin
          col:=col+1;
          //copieTab.ColCount:=col+1;
          For j:=0 to TabRef.RowCount-1 do
            copieTab.StrItems[j,col]:=TabRef.StrItems[j,i];
        end
      else changement:=True;
    end;
  if changement then
    Tabref.Assign(copieTab);
  copieTab.Free;
end;
function TSousCollection.EstFossile(NumTaxon:integer):boolean;
Var
  Tax:TTaxon;
begin
  Result:=False;
  Tax:=TTaxon(Taxons.Items[NumTaxon]);
  if pos('F',Tax.TypeTaxon)>0 then Result:=True;
end;
function TSousCollection.EstFossileNm(NomTaxon:string):boolean;
Var
  NumTaxon:integer;
  Tax:TTaxon;
begin
  Result:=False;
  NumTaxon:=Taxons.GetNumTaxon(NomTaxon);
  if NumTaxon<0 then exit;
  Tax:=TTaxon(Taxons.Items[NumTaxon]);
  if pos('F',Tax.TypeTaxon)>0 then Result:=True;
end;
function TSousCollection.EstExterne(NumTaxon:integer):boolean;
Var
  Tax:TTaxon;
begin
  Result:=False;
  Tax:=TTaxon(Taxons.Items[NumTaxon]);
  if pos('E',Tax.TypeTaxon)>0 then Result:=True;
end;
function TSousCollection.EstExterneNm(NomTaxon:string):boolean;
Var
  NumTaxon:integer;
  Tax:TTaxon;
begin
  Result:=False;
  NumTaxon:=Taxons.GetNumTaxon(NomTaxon);
  if NumTaxon<0 then exit;
  Tax:=TTaxon(Taxons.Items[NumTaxon]);
  if pos('E',Tax.TypeTaxon)>0 then Result:=True;
end;
function TSousCollection.Age(NumTaxon:integer):integer;
Var
  Tax:TTaxon;
begin
  Result:=0;
  Tax:=TTaxon(Taxons.Items[NumTaxon]);
  if pos('F',Tax.TypeTaxon)>0 then
    begin
      Result:=Tax.AgeApp;
    end;
end;
function TSousCollection.AgeNm(NomTaxon:string):integer;
Var
  NumTaxon:integer;
  Tax:TTaxon;
begin
  Result:=0;
  NumTaxon:=Taxons.GetNumTaxon(NomTaxon);
  if NumTaxon<0 then exit;
  Tax:=TTaxon(Taxons.Items[NumTaxon]);
  if pos('F',Tax.TypeTaxon)>0 then
    begin
      Result:=Tax.AgeApp;
    end;
end;
function TSousCollection.AgeStr(NumTaxon:integer):string;
Var
  Tax:TTaxon;
  age:integer;
begin
  Result:='';
  Tax:=TTaxon(Taxons.Items[NumTaxon]);
  if pos('F',Tax.TypeTaxon)>0 then
    begin
      age:=Tax.AgeApp;
      if age <1000   then
        begin
          age:=1000*age;
          Result:='-'+IntToStr(Age);
        end
//      else Result:='-'+FloatToStrF(Age/1000,ffGeneral,4,2)+' Ma';
      else Result:='-'+FloatToStrF(Age/1000,ffGeneral,4,2)+M_Ma_2;
    end;
end;
function TSousCollection.AgeStrNm(NomTaxon:string):string;
Var
  NumTaxon:integer;
  Tax:TTaxon;
  age:integer;
begin
  Result:='';
  NumTaxon:=Taxons.GetNumTaxon(NomTaxon);
  if NumTaxon<0 then exit;
  Tax:=TTaxon(Taxons.Items[NumTaxon]);
  if pos('F',Tax.TypeTaxon)>0 then
    begin
      age:=Tax.AgeApp;
      if age <1000  then
        begin
          age:=1000*age;
          Result:='-'+IntToStr(Age);
        end
//      else Result:='-'+FloatToStrF(Age/1000,ffGeneral,4,2)+' Ma';
      else Result:='-'+FloatToStrF(Age/1000,ffGeneral,4,2)+M_Ma_2;
    end;
end;
function TSousCollection.AgesStr(NumTaxon:integer):string;
Var
  Tax:TTaxon;
  age:integer;
begin
  Result:='';
  Tax:=TTaxon(Taxons.Items[NumTaxon]);
  if pos('F',Tax.TypeTaxon)>0 then
    begin
      age:=Tax.AgeApp;
      if Tax.AgeDisp>=age then
        begin
          if age <1000  then
            begin
              age:=1000*age;
              Result:='-'+IntToStr(Age);
            end
//          else Result:='-'+FloatToStrF(Age/1000,ffGeneral,4,2)+' Ma';
          else Result:='-'+FloatToStrF(Age/1000,ffGeneral,4,2)+M_Ma_2;
          exit;
        end;
      if age <1000  then
        begin
          age:=1000*age;
          Result:='(-'+IntToStr(Age)+'  -'+IntToStr(Tax.AgeDisp)+')';
        end
//      else Result:='(-'+FloatToStrF(Age/1000,ffGeneral,4,2)+'  -'+FloatToStrF(Tax.AgeDisp/1000,ffGeneral,4,2)+' Ma)';
      else Result:='(-'+FloatToStrF(Age/1000,ffGeneral,4,2)+'  -'+FloatToStrF(Tax.AgeDisp/1000,ffGeneral,4,2)+M_Ma_4;
    end;
end;
function TSousCollection.AgesStrNm(NomTaxon:string):string;
Var
  NumTaxon:integer;
  Tax:TTaxon;
  age:integer;
begin
  Result:='';
  NumTaxon:=Taxons.GetNumTaxon(NomTaxon);
  if NumTaxon<0 then exit;
  Tax:=TTaxon(Taxons.Items[NumTaxon]);
  if pos('F',Tax.TypeTaxon)>0 then
    begin
      age:=Tax.AgeApp;
      if Tax.AgeDisp>=age then
        begin
          if age <1000  then
            begin
              age:=1000*age;
              Result:='-'+IntToStr(Age);
            end
//          else Result:='-'+FloatToStrF(Age/1000,ffGeneral,4,2)+' Ma';
          else Result:='-'+FloatToStrF(Age/1000,ffGeneral,4,2)+M_Ma_2;
          exit;
        end;
      if age <1000  then
        begin
          age:=1000*age;
          Result:='(-'+IntToStr(Age)+'  -'+IntToStr(Tax.AgeDisp)+')';
        end
//      else Result:='(-'+FloatToStrF(Age/1000,ffGeneral,4,2)+'  -'+FloatToStrF(Tax.AgeDisp/1000,ffGeneral,4,2)+' Ma)';
      else Result:='(-'+FloatToStrF(Age/1000,ffGeneral,4,2)+'  -'+FloatToStrF(Tax.AgeDisp/1000,ffGeneral,4,2)+M_Ma_4;
    end;
end;
Function TSousCollection.DetermineStatut(NomCar:string;ListeTaxons,ListeTotaleTaxons:TStringList;Methode:integer;Var NumEtatCommun:integer;Var EtatCommun,Nomgroupe:string):integer;
              //Result:= 0:primitif, 1:indtermin, 2:driv non exclusif,  3:driv exclusif
              //gre uniquement la methode Wagner  methode=0
Var
  i,j,n,t:integer;
  UnCarD:TCaractD;
  Tax:TTaxon;
  PEtat,Etat:string;
  PNumEtat,NumEtat:integer;
  ordonne:boolean;
  different,partage:boolean;
  NomTaxon:string;
  FPI:boolean;// pour signaler les points d'interrogation
begin
  //
  Result:=-1;
  NomGroupe:='';
  etat:='';
  NumEtatCommun:=0;
  UnCarD:=LeCarD(NomCar);
  if UnCarD<>Nil then
    begin
      NomTaxon:=ListeTaxons[0];
      PEtat:=EtatDe(NomTaxon,NomCar,PNumEtat);
      ordonne:=(UnCarD.TypeCarD=1);
      different:=false;
      FPI:=false;                           //ne pas tenir compte des ? s'il y a un tat driv exclusif
      for j:=1 to ListeTaxons.Count-1 do   //rechercher les '?'
        begin                // et rechercher si les tats sont diffrents au sein du groupe
          NomTaxon:=ListeTaxons[j];
          Etat:=EtatDe(NomTaxon,NomCar,NumEtat);
          if Etat='?' then FPI:=true;
          if Etat<>PEtat then
            begin
              different:=true;
              if NumEtat<PNumEtat then
                begin
                  PNumEtat:=NumEtat;
                  PEtat:=Etat;
                end;
            end;
        end;
      // traitement des diffrents cas
      if (different and (Not ordonne)) or(PNumEtat=0)  then  // primitif ou non ordonn diffrent
        begin
          Result:=0;//
          EtatCommun:=UnCarD.ListeEtats[0]; // tat primitif
          NumEtatCommun:=0;
        end
      else if FPI then   //s'il y a un '?' mettre  '?'
        begin
          Result:=1;
          EtatCommun:='?';
          NumEtatCommun:=0;
        end
      else // commun ou diffrents tous>primitif et caractre ordonn
        begin
          EtatCommun:=PEtat;
          NumEtatCommun:=PNumEtat;
          // rechercher s'il est partag avec d'autres taxons
          partage:=false;
          for j:=0 to ListeTotaleTaxons.Count-1 do
            begin
              NomTaxon:=ListeTotaleTaxons[j];
              if (ListeTaxons.IndexOf(NomTaxon)=-1)  then
                begin
                  Tax:=LeTaxon(NomTaxon);
                   if (Tax<>Nil) then
                    begin
                      Etat:=EtatDe(NomTaxon,NomCar,NumEtat);
                      if (Etat=PEtat)or(ordonne and (NumEtat>PNumEtat) and (Etat<>'?')) then
                        begin
                          partage:=true;
                          break;
                        end;
                    end;
                end;
            end;
            if partage then    //si partag avec d'autres et pas '?'
              Result:=2
            else //si exclusif et pas ?
              begin
                Result:=3;
                if UnCarD.NomsGroupes[PNumEtat]<>'' then
                  NomGroupe:=UnCarD.NomsGroupes[PNumEtat];
              end;
        end;
    end;
end;

Function TSousCollection.LesGroupes(ListeTaxons,ListeTousTaxons:TStringList):string; //renvoie la structure d'un commatext de StringList
Var
  UnCarD:TCaractD;
  NomCar:string;
  p,i,j:integer;
  ListeGroupes:TStringList;
  NumEtatCommun:integer;
  EtatCommun,Nomgroupe:string;
  Statut:integer;
begin
  Result:='';
  if (ListeTousTaxons.Count=0)or (ListeTaxons.Count=0) then exit;
  initialiseEnsGroupes;
  if (FEnsGroupes.Count=0) then exit;
  ListeGroupes:=TStringList.Create;
  For i:=0 to MesCarD.NbCarD-1 do
    begin
      UnCarD:=MesCarD.Items[i];
      if UnCarD<>Nil then
        begin
          NomCar:=UnCarD.Nom;
          Statut:=DetermineStatut(NomCar,ListeTaxons,ListeTousTaxons,0,NumEtatCommun,EtatCommun,Nomgroupe);
          if Statut=3 then //Caractere driv exclusif
            begin
              ListeGroupes.Add(NomGroupe);
            end;
        end;
    end;
  if ListeGroupes.Count>0 then
    Result:=ListeGroupes.CommaText;
  ListeGroupes.Free;
end;
Function TSousCollection.NomGroupe(NomCarD,NomEtat:string):string;
Var
  UnCarD:TCaractD;
  p:integer;
begin
  Result:='';
  UnCard:=LeCarD(NomCarD);
  If UnCarD<>Nil then
    begin
      p:=UnCarD.ListeEtats.IndexOf(NomEtat);
      if p>0 then
        Result:=UnCarD.NomsGroupes[p];
    end;
end;
function TSousCollection.ConstruitListeEtatsAncetreBis(AfDExcl,AfD,AfA:TAffichCoul;var AfUtil:TAffichCoul;var Nomgroupe:string;var ListeTaxons:TStringList;Tableau:TColorStringGrid):TstringList;
Var
  i,j,n,t:integer;
  UnCarD:TCaractD;
  Tax:TTaxon;
  PEtat,Etat:string;
  PNumEtat,NumEtat:integer; //,Minetat
  ordonne:boolean;
  different,partage:boolean;
  NomTaxon,NomCarD:string;
  NbCar:integer;
  GroupeHeterogene:boolean;
  FPI:boolean;// pour signaler les points d'interrogation
  // ajouter aussi une colonne avec les ges des premiers fossiles ayant ces tats
begin
  Result:=TstringList.Create;
  GroupeHeterogene:=True;
  Nomgroupe:='';
//  Tableau.Cells[0,0]:='caractres';
  Tableau.Cells[0,0]:=M_Caractres;
//  Tableau.Cells[1,0]:='tats';
  Tableau.Cells[1,0]:=M_tats;
  NbCar:=0;
  Tableau.ColCount:=2;
  Tableau.RowCount:=2;
  Tableau.FixedCols:=1;
  Tableau.FixedRows:=1;
  Tableau.RAZAffichCell;
  //Remplissage de la colonne des caractres :
  //For i:=0 to Caracteres.CarD.Count-1 do
  For i:=0 to Caracteres.CarDs.NbCarD-1 do
    begin
      //UnCarD:=TCaractD(Caracteres.CarD[i]);
      UnCarD:=Caracteres.CarDs.Items[i];
      if UnCarD.Active then
        begin
          inc(NbCar);
          Tableau.RowCount:=NbCar+1;
          NomCarD:=UnCarD.Nom;
          Tableau.Cells[0,NbCar]:=NomCarD;
          NomTaxon:=ListeTaxons[0];

          PEtat:=EtatDe(NomTaxon,NomCarD,PNumEtat);
          ordonne:=(UnCarD.TypeCarD=1);
          different:=false;
          FPI:=false;
          for j:=1 to ListeTaxons.Count-1 do   //rechercher les '?'
            begin                // et rechercher si les tats sont diffrents au sein du groupe
              NomTaxon:=ListeTaxons[j];
              Etat:=EtatDe(NomTaxon,NomCarD,NumEtat);
              if Etat='?' then FPI:=true;
              if Etat<>PEtat then
                begin
                  different:=true;
                  if NumEtat<PNumEtat then
                    begin
                      PNumEtat:=NumEtat;
                      PEtat:=Etat;
                    end;
                end;
            end;
          // traitement des diffrents cas
          if (different and (Not ordonne)) or(PNumEtat=0)  then  // primitif ou non ordonn diffrent
            begin
              Tableau.AffichCell[1,NbCar]:=AfA;
              Tableau.Cells[1,NbCar]:=UnCarD.ListeEtats[0]; // tat primitif
            end
          else if FPI then   //s'il y a un '?' mettre  '?' et ne pas colorer
            begin
              Tableau.Cells[1,NbCar]:='?';
              Tableau.AffichCell[1,NbCar]:=AfA;
            end
          else // commun ou diffrents tous>primitif et caractre ordonn
            begin
              Tableau.Cells[1,NbCar]:=PEtat;
              // rechercher s'il est partag avec d'autres taxons
              partage:=false;
              for j:=0 to Taxons.NbTaxons-1 do
                begin
                  Tax:=TTaxon(Taxons[j]);
                  NomTaxon:=Tax.Nom;
                  if Tax.Selected and (ListeTaxons.IndexOf(NomTaxon)=-1)  then
                    begin
                      Etat:=EtatDe(NomTaxon,NomCarD,NumEtat);
                      if Etat=PEtat then
                        begin
                          partage:=true;
                          break;
                        end;
                    end;
                end;
                if partage then    //si partag avec d'autres et pas '?' colorer AfD
                  Tableau.AffichCell[1,NbCar]:=AfD
                else //si exclusif et pas ? colorer AfDExcl
                  begin
                    if Affichage[NomCarD,PEtat].Active then
                      begin
                        Tableau.AffichCell[1,NbCar]:=ConvertitAffCelAffCoul(Affichage[NomCarD,PEtat]);
                        AfUtil:=Tableau.AffichCell[1,NbCar];
                      end
                    else
                      begin
                        Tableau.AffichCell[1,NbCar]:=AfDExcl;
                        AfUtil:=AfDExcl;
                      end;
                    Result.Add(NomCarD);
                    GroupeHeterogene:=False;
                    if UnCarD.NomsGroupes[PNumEtat]<>'' then
                      NomGroupe:=UnCarD.NomsGroupes[PNumEtat];
                  end;
            end;
        end;
    end;
//  if GroupeHeterogene then NomGroupe:='Groupe htrogne';
  if GroupeHeterogene then NomGroupe:=M_Groupehtrogne;
  If AvecFossiles(True) then
    begin
      // recherche des ges des taxons fossiles ayant les tats drivs indiqus
      Tableau.ColCount:=3;
//      Tableau.Cells[2,0]:='ge fossile';
      Tableau.Cells[2,0]:=M_gefossile;
      for i:=1 to Tableau.RowCount-1 do
        begin
          t:=0;
          etat:=Tableau.Cells[1,i];
          //vrifier si c'est un tat driv
          UnCarD:=LeCarD(Tableau.Cells[0,i]);
          if (UnCarD<>nil) and (etat<>'?') and (UnCarD.ListeEtats.IndexOf(etat)>0) then
            begin
              n:=tabref.IndexOfCol(Tableau.Cells[0,i]);
              for j:=1 to tabref.RowCount-1 do
                if tabref.StrItems[j,n]=etat then
                  begin
                    Tax:=LeTaxon(tabref.StrItems[j,0]);
                    if (Tax<>Nil) and EstFossileNm(tabref.StrItems[j,0]) then
                        t:=max(t,Tax.AgeApp);
                  end;
              if t>0 then Tableau.Cells[2,i]:=TranscritAge(t)
              else Tableau.Cells[2,i]:='';
            end
          else Tableau.Cells[2,i]:='';

        end;
    end;
  Tableau.ajusteColonnes;
  Tableau.Alignment:=taCenter;
  Tableau.Refresh;
end;

function TSousCollection.ListeEtatsDerExcl(ListeTaxons:string;ListeTotaleTaxons:TStringList;var Nomgroupe,ListeEtats:string):String;
Var
  i,j,n,t:integer;
  UnCarD:TCaractD;
  Tax:TTaxon;
  PEtat,Etat:string;
  PNumEtat,NumEtat:integer;
  LaListeT:TStringList;
  LaListeC:TStringList;
  LaListeE:TStringList;
  ordonne:boolean;
  different,partage:boolean;
  NomTaxon,NomCarD:string;
  NbCar:integer;
begin
  Nomgroupe:='';
  Result:='';
  NbCar:=0;
  LaListeT:=TStringList.Create;
  LaListeC:=TStringList.Create;
  LaListeE:=TStringList.Create;
  LaListeT.CommaText:=ListeTaxons;
  if LaListeT.Count<1 then exit;
  For i:=0 to Caracteres.CarDs.NbCarD-1 do
    begin
      UnCarD:=Caracteres.CarDs.Items[i];
      if UnCarD.Active then
        begin
          inc(NbCar);
          NomCarD:=UnCarD.Nom;
          NomTaxon:=LaListeT[0];
          PEtat:=EtatDe(NomTaxon,NomCarD,PNumEtat);
          ordonne:=(UnCarD.TypeCarD=1);
          if ((ordonne and (PNumEtat>0))or (Not ordonne)) and (PEtat<>'?') then
            begin
              different:=false;
              for j:=1 to LaListeT.Count-1 do
                begin
                  NomTaxon:=LaListeT[j];
                  Etat:=EtatDe(NomTaxon,NomCarD,NumEtat);
                  if Etat<>PEtat then
                    begin
                      if NumEtat<PNumEtat then
                        begin
                          PNumEtat:=NumEtat;
                          PEtat:=Etat;
                        end
                      else
                        begin
                          different:=true;
                          break;
                        end;
                    end;
                end;
              if different then
                continue
              else //vrifier s'il est partag par d'autres
                begin
                  partage:=false;
                  for j:=0 to Taxons.NbTaxons-1 do
                    begin
                      Tax:=TTaxon(Taxons[j]);
                      NomTaxon:=Tax.Nom;
                      if (ListeTotaleTaxons.IndexOf(NomTaxon)>-1)and (LaListeT.IndexOf(NomTaxon)=-1)  then
                        begin
                          Etat:=EtatDe(NomTaxon,NomCarD,NumEtat);
                          if (Etat=PEtat)or (ordonne and (NumEtat>PNumEtat) and (Etat<>'?')) then
                            begin
                              partage:=true;
                              break;
                            end;
                        end;
                    end;
                  if Not partage then
                    begin
                      LaListeC.Add(NomCarD);
                      LaListeE.Add(PEtat);
                      if UnCarD.NomsGroupes[PNumEtat]<>'' then
                        NomGroupe:=UnCarD.NomsGroupes[PNumEtat];
                    end;
                end;
            end;
        end;
    end;
  Result:=LaListeC.CommaText;
  ListeEtats:=LaListeE.CommaText;
  LaListeC.Free;
  LaListeE.Free;
  LaListeT.Free;
end;
{Function TSousCollection.DetermineStatut(NomCar,ListeTaxons:string;ListeTotaleTaxons:TStringList;Methode:integer;Var NumEtatCommun:integer;Var EtatCommun,Nomgroupe:string):integer;
              //Result:= 0:primitif, 1:indtermin, 2:driv non exclusif,  3:driv exclusif
Var
  i,j,n,t:integer;
  UnCarD:TCaractD;
  Tax:TTaxon;
  PEtat,Etat:string;
  PNumEtat,NumEtat:integer;
  ordonne:boolean;
  different,partage:boolean;
  NomTaxon:string;
  FPI:boolean;// pour signaler les points d'interrogation
  ListeT:TStringList;
begin
  //
  Result:=-1;
  NomGroupe:='';
  etat:='';
  NumEtatCommun:=0;
  UnCarD:=LeCarD(NomCar);
  if UnCarD<>Nil then
    begin
      ListeT:=TStringList.Create;
      ListeT.CommaText:=ListeTaxons;
      NomTaxon:=ListeT[0];

      PEtat:=EtatDe(NomTaxon,NomCar,PNumEtat);
      ordonne:=(UnCarD.TypeCarD=1);
      different:=false;
      FPI:=false;
      for j:=1 to ListeT.Count-1 do   //rechercher les '?'
        begin                // et rechercher si les tats sont diffrents au sein du groupe
          NomTaxon:=ListeT[j];
          Etat:=EtatDe(NomTaxon,NomCar,NumEtat);
          if Etat='?' then FPI:=true;
          if Etat<>PEtat then
            begin
              different:=true;
              if NumEtat<PNumEtat then
                begin
                  PNumEtat:=NumEtat;
                  PEtat:=Etat;
                end;
            end;
        end;
      // traitement des diffrents cas
      if (different and (Not ordonne)) or(PNumEtat=0)  then  // primitif ou non ordonn diffrent
        begin
          Result:=0;//
          EtatCommun:=UnCarD.ListeEtats[0]; // tat primitif
          NumEtatCommun:=0;
        end
      else if FPI then   //s'il y a un '?' mettre  '?'
        begin
          Result:=1;
          EtatCommun:='?';
          NumEtatCommun:=0;
        end
      else // commun ou diffrents tous>primitif et caractre ordonn
        begin
          EtatCommun:=PEtat;
          NumEtatCommun:=PNumEtat;
          // rechercher s'il est partag avec d'autres taxons
          partage:=false;
          for j:=0 to ListeTotaleTaxons.Count-1 do
            begin
              NomTaxon:=ListeTotaleTaxons[j];
              if (ListeT.IndexOf(NomTaxon)=-1)  then
                begin
                  Tax:=LeTaxon(NomTaxon);
                   if (Tax<>Nil) then
                    begin
                      Etat:=EtatDe(NomTaxon,NomCar,NumEtat);
                      if (Etat=PEtat)or(ordonne and (NumEtat>PNumEtat) and (Etat<>'?')) then
                        begin
                          partage:=true;
                          break;
                        end;
                    end;
                end;
            end;
            if partage then    //si partag avec d'autres et pas '?'
              Result:=2
            else //si exclusif et pas ?
              begin
                Result:=3;
                if UnCarD.NomsGroupes[PNumEtat]<>'' then
                  NomGroupe:=UnCarD.NomsGroupes[PNumEtat];
              end;
        end;
      ListeT.Free;
    end;
end;
}
function TSousCollection.ConstruitListeEtatsAncetre(AfDExcl,AfD,AfA:TAffichCoul;var Nomgroupe:string;var ListeTaxons:TStringList;Tableau:TColorStringGrid):TstringList;
Var
  i,j,n,t:integer;
  UnCarD:TCaractD;
  Tax:TTaxon;
  PEtat,Etat:string;
  PNumEtat,NumEtat:integer; //,Minetat
  ordonne:boolean;
  different,partage:boolean;
  NomTaxon,NomCarD:string;
  NbCar:integer;
  GroupeHeterogene:boolean;
  FPI:boolean;// pour signaler les points d'interrogation
  // ajouter aussi une colonne avec les ges des premiers fossiles ayant ces tats
begin
  Result:=TstringList.Create;
  GroupeHeterogene:=True;
  Nomgroupe:='';
//  Tableau.Cells[0,0]:='caractres';
  Tableau.Cells[0,0]:=M_Caractres;
//  Tableau.Cells[1,0]:='tats';
  Tableau.Cells[1,0]:=M_tats;
  NbCar:=0;
  Tableau.ColCount:=2;
  Tableau.RowCount:=2;
  Tableau.FixedCols:=1;
  Tableau.FixedRows:=1;
  Tableau.RAZAffichCell;
  //Remplissage de la colonne des caractres :
  //For i:=0 to Caracteres.CarD.Count-1 do
  For i:=0 to Caracteres.CarDs.NbCarD-1 do
    begin
      //UnCarD:=TCaractD(Caracteres.CarD[i]);
      UnCarD:=Caracteres.CarDs.Items[i];
      if UnCarD.Active then
        begin
          inc(NbCar);
          Tableau.RowCount:=NbCar+1;
          NomCarD:=UnCarD.Nom;
          Tableau.Cells[0,NbCar]:=NomCarD;
          NomTaxon:=ListeTaxons[0];

          PEtat:=EtatDe(NomTaxon,NomCarD,PNumEtat);
          ordonne:=(UnCarD.TypeCarD=1);
          different:=false;
          FPI:=false;
          for j:=1 to ListeTaxons.Count-1 do   //rechercher les '?'
            begin                // et rechercher si les tats sont diffrents au sein du groupe
              NomTaxon:=ListeTaxons[j];
              Etat:=EtatDe(NomTaxon,NomCarD,NumEtat);
              if Etat='?' then FPI:=true;
              if Etat<>PEtat then
                begin
                  different:=true;
                  if NumEtat<PNumEtat then
                    begin
                      PNumEtat:=NumEtat;
                      PEtat:=Etat;
                    end;
                end;
            end;
          // traitement des diffrents cas
          if (different and (Not ordonne)) or(PNumEtat=0)  then  // primitif ou non ordonn diffrent
            begin
              Tableau.AffichCell[1,NbCar]:=AfA;
              Tableau.Cells[1,NbCar]:=UnCarD.ListeEtats[0]; // tat primitif
            end
          else if FPI then   //s'il y a un '?' mettre  '?' et ne pas colorer
            begin
              Tableau.Cells[1,NbCar]:='?';
              Tableau.AffichCell[1,NbCar]:=AfA;
            end
          else // commun ou diffrents tous>primitif et caractre ordonn
            begin
              Tableau.Cells[1,NbCar]:=PEtat;
              // rechercher s'il est partag avec d'autres taxons
              partage:=false;
              for j:=0 to Taxons.NbTaxons-1 do
                begin
                  Tax:=TTaxon(Taxons[j]);
                  NomTaxon:=Tax.Nom;
                  if Tax.Selected and (ListeTaxons.IndexOf(NomTaxon)=-1)  then
                    begin
                      Etat:=EtatDe(NomTaxon,NomCarD,NumEtat);
                      if (Etat=PEtat)or(ordonne and (NumEtat>PNumEtat) and (Etat<>'?')) then
                        begin
                          partage:=true;
                          break;
                        end;
                    end;
                end;
                if partage then    //si partag avec d'autres et pas '?' colorer AfD
                  Tableau.AffichCell[1,NbCar]:=AfD
                else //si exclusif et pas ? colorer AfDExcl
                  begin
                    Tableau.AffichCell[1,NbCar]:=AfDExcl;
                    Result.Add(NomCarD);
                    GroupeHeterogene:=False;
                    if UnCarD.NomsGroupes[PNumEtat]<>'' then
                      NomGroupe:=UnCarD.NomsGroupes[PNumEtat];
                  end;
            end;
        end;
    end;
//  if GroupeHeterogene then NomGroupe:='Groupe htrogne';
  if GroupeHeterogene then NomGroupe:=M_Groupehtrogne;
  If AvecFossiles(True) then
    begin
      // recherche des ges des taxons fossiles ayant les tats drivs indiqus
      Tableau.ColCount:=3;
//      Tableau.Cells[2,0]:='ge fossile';
      Tableau.Cells[2,0]:=M_gefossile;
      for i:=1 to Tableau.RowCount-1 do
        begin
          t:=0;
          etat:=Tableau.Cells[1,i];
          //vrifier si c'est un tat driv
          UnCarD:=LeCarD(Tableau.Cells[0,i]);
          if (UnCarD<>nil) and (etat<>'?') and (UnCarD.ListeEtats.IndexOf(etat)>0) then
            begin
              n:=tabref.IndexOfCol(Tableau.Cells[0,i]);
              for j:=1 to tabref.RowCount-1 do
                if tabref.StrItems[j,n]=etat then
                  begin
                    Tax:=LeTaxon(tabref.StrItems[j,0]);
                    if (Tax<>Nil) and EstFossileNm(tabref.StrItems[j,0]) then
                        t:=max(t,Tax.AgeApp);
                  end;
              if t>0 then Tableau.Cells[2,i]:=TranscritAge(t)
              else Tableau.Cells[2,i]:='';
            end
          else Tableau.Cells[2,i]:='';

        end;
    end;
  Tableau.ajusteColonnes;
  Tableau.Alignment:=taCenter;
  Tableau.Refresh;
end;
Function TSousCollection.TrouveAge(NomCarac,NomEtat:string;Var ValAge:integer):string;
Var
  n,j:integer;
  UnCarD:TCaractD;
  Tax:TTaxon;
begin
  ValAge:=0;
  Result:='';
  //vrifier si c'est un tat driv
  UnCarD:=LeCarD(NomCarac);
  if (UnCarD<>nil) and (NomEtat<>'?') and (UnCarD.ListeEtats.IndexOf(NomEtat)>0) then
    begin
      n:=tabref.IndexOfCol(NomCarac);
      for j:=1 to tabref.RowCount-1 do
        if tabref.StrItems[j,n]=NomEtat then
          begin
            Tax:=LeTaxon(tabref.StrItems[j,0]);
            if (Tax<>Nil) and EstFossileNm(tabref.StrItems[j,0]) then
               ValAge:=max(ValAge,Tax.AgeApp);
          end;
      if ValAge>0 then
        Result:=TranscritAge(ValAge)
      else
        Result:='';
    end;
end;
function TSousCollection.AvecFossiles(TenirCompteSelection:boolean):boolean;
Var
  i:integer;
  Tax:TTaxon;
begin
  Result:=False;
  For i:=0 to Taxons.NbTaxons-1 do
    begin
      Tax:=TTaxon(Taxons[i]);
      if (Tax<>Nil) and ((Not TenirCompteSelection) or Tax.Selected) and EstFossile(i) then
        begin
          Result:=True;
          Break;
        end;
    end;
end;
function TSousCollection.NomEtat(NomCarD:string;NumEtat:integer):string;
Var
  LesEtats:TStringList;
begin
  Result:='';
  LesEtats:= MesCarD.GetEtats(MesCarD.GetNumCarD(NomCarD));
  if (LesEtats<>nil)and (NumEtat<LesEtats.Count) then
    Result:=LesEtats[NumEtat];
end;
function TSousCollection.VerifStatutDe(NomCarD:string;Numetat,StatutOrg:integer):integer;
Var
  n:integer;
  NomEtat:String;
begin
  Result:=StatutOrg;
  if (NomTaxonExtraGroupe<>'')and (StatutOrg>0) then
    begin
      NomEtat:=EtatDe(NomTaxonExtraGroupe,NomCarD,n);
      if (NomEtat<>'')and(NomEtat<>'?')and (n>=NumEtat) then
      Result:=0;
    end;
end;
function TSousCollection.EtatDe(NomTaxon,NomCarD:string;Var NumEtat:integer):string;
Var
  col,row:integer;
  //LeCard:TCaractD;
  LesEtats:TStringList;
begin
  Result:='';
  NumEtat:=-1;
  col:=TabRef.IndexOfCol(NomCarD);
  row:=TabRef.IndexOfRow(NomTaxon);
  If (col>0) and (Row>0) then
    Result:=TabRef.StrItems[Row,Col];
  if Result<>'' then
    begin
      //LeCard:=TCaractD(Caracteres.CarD[Caracteres.GetNumCarD(NomCard)]);
      //LesEtats:= Caracteres.GetEtats(Caracteres.GetNumCarD(NomCard));
      LesEtats:= MesCarD.GetEtats(MesCarD.GetNumCarD(NomCarD));
      if LesEtats<>nil then NumEtat:=LesEtats.IndexOf(Result);
    end;
end;
function TSousCollection.NumTaxon(UnTaxon:TTaxon):integer;
Var
  i:integer;
begin
  Result:=-1;
  for i:=0 to Taxons.Count-1 do
    begin
      if TTaxon(Taxons[i])=UnTaxon then
        begin
          Result:=i;
          Break;
        end;
    end;
end;
function TSousCollection.LeTaxon(NomTaxon:string):TTaxon;
Var
  NumTax:integer;
begin
  Result:=Nil;
  NumTax:=Taxons.GetNumTaxon(NomTaxon);
  if NumTax>-1 then Result:=TTaxon(Taxons.Items[NumTax]);
end;
function TSousCollection.LeCarD(NomCarD:string):TCaractD;
Var
  NumCar:integer;
begin
  Result:=Nil;
  NumCar:=MesCarD.GetNumCarD(NomCarD);
  //if NumCar>-1 then Result:=TCaractD(Caracteres.CarD[NumCar]);
  if NumCar>-1 then
    Result:=MesCarD.Items[NumCar];
end;
function TSousCollection.LeTypeCarD(NomCarD:string):integer;
Var
  UnCarD:TCaractD;
begin
  Result:=-1;
  UnCarD:=LeCarD(NomCarD);
  if UnCarD<>Nil then
    Result:=UnCarD.TypeCarD;
end;
function TSousCollection.GetAffichage(NomCarD,etat:string):TAffichCell;
Var
  UnCarD:TCaractD;
begin
  UnCarD:=LeCarD(NomCard);
  if UnCarD<>Nil then
    begin
      Result:=UnCarD.LitAffichCellEtatNm(etat);
    end
  else
    begin
      UnCarD:=TCaractD.create;
      Result:=UnCarD.AffRAZ;
      UnCarD.Free;
    end;
end;
procedure TSousCollection.SetAffichage(NomCarD,etat:string;Aff:TAffichCell);
Var
  UnCarD:TCaractD;
begin
  UnCarD:=LeCarD(NomCard);
  if UnCarD<>Nil then UnCarD.FixeAffichCellEtatNm(etat,Aff);
end;
procedure TSousCollection.RAZCodageAffichage;
Var
  i,j:integer;
  UnCarD:TCaractD;
begin
  //For i:=0 to Caracteres.CarD.Count-1 do
  For i:=0 to Caracteres.CarDs.NbCarD-1 do
    begin
      //UnCarD:=TCaractD(Caracteres.CarD[i]);
      UnCarD:=Caracteres.CarDs.Items[i];
      if UnCarD<>Nil then
        begin
          For j:=0 to UnCarD.ListeEtats.Count-1 do
            begin
              UnCarD.FixeAffichCellEtat(j,UnCarD.AffRAZ);
            end;
        end;
    end;
end;
procedure TSousCollection.LitAffichage(Tableau:TStringGrid);
Var
  i,j:integer;
  NomCarD,etat:string;
begin
  if (Not (Tableau is TMyCustomGrid)) and (Not (Tableau is TColorStringGrid)) then exit;
  For i:=Tableau.FixedCols to Tableau.ColCount-1 do
    begin
      NomCarD:=Tableau.Cells[i,0];
      For j:=Tableau.FixedRows to Tableau.RowCount-1 do
        begin
          etat:=Tableau.Cells[i,j];
          if (Tableau is TMyCustomGrid) then
            Affichage[NomCarD,etat]:=TMyCustomGrid(Tableau).AffichCell[i,j]
          else if (Tableau is TColorStringGrid) then
            Affichage[NomCarD,etat]:=ConvertitAffCoulAffCel(TColorStringGrid(Tableau).AffichCell[i,j]);
        end;
    end;
end;
procedure TSousCollection.EtablitAffichage(Tableau:TStringGrid);
Var
  i,j:integer;
  NomCarD,etat:string;
begin
  if (Not (Tableau is TMyCustomGrid)) and (Not (Tableau is TColorStringGrid)) then exit;
  For i:=Tableau.FixedCols to Tableau.ColCount-1 do
    begin
      NomCarD:=Tableau.Cells[i,0];
      For j:=1 to Tableau.RowCount-1 do
        begin
          etat:=Tableau.Cells[i,j];
          if (Tableau is TMyCustomGrid) then
            TMyCustomGrid(Tableau).AffichCell[i,j]:=Affichage[NomCarD,etat]
          else if (Tableau is TColorStringGrid) then
            TColorStringGrid(Tableau).AffichCell[i,j]:=ConvertitAffCelAffCoul(Affichage[NomCarD,etat]);
        end;
    end;
end;
Procedure TSousCollection.OrdonnerTabDapresTab(MultiEnTete:Boolean;TableauModele:TTabGrid;Var TabAClasser:TTabGrid);
Var
  i,j,k,debL,TaCFR,decal,n:integer;
  //CaractT:TCaractD;
begin
  TabAClasser.ColCount:=TableauModele.ColCount;
  DebL:=TableauModele.FixedRows;
  if Multientete then
    begin
      TabAClasser.RowCount:=TableauModele.RowCount;
      TabAClasser.FixedRows:=TableauModele.FixedRows;
    end
  else
    begin
      TabAClasser.RowCount:=TableauModele.RowCount-DebL+1;
      TabAClasser.FixedRows:=1;
    end;
  TaCFR:=TabAClasser.FixedRows;
  TabAClasser.FixedCols:=TableauModele.FixedCols;
  decal:=0;
  TabAClasser.Cells[0,0]:=TableauModele.Cells[0,0];
  For i:=DebL to TableauModele.RowCount-1 do
    TabAClasser.Cells[0,TaCFR+i-DebL]:=TableauModele.Cells[0,i];
  For i:=1 to TableauModele.ColCount-1 do
    begin
      if Multientete or (DebL=1) then
        begin
          for j:=0 to TableauModele.RowCount-1 do
            begin
              TabAClasser.Cells[i,j]:=TableauModele.Cells[i,j];
              TabAClasser.AffichCell[i,j]:=TableauModele.AffichCell[i,j];
            end;
        end
      else
        begin
          for k:=0 to DebL-1 do
            begin
              if TableauModele.Cells[i,k]<>'' then
                begin
                  if k>0 then
                    begin
                      inc(decal);
                      TabAClasser.ColCount:=TableauModele.ColCount+decal;
                    end;
                  TabAClasser.Cells[i+decal,0]:=TableauModele.Cells[i,k];
                end
              else break;
            end;
        end
    end;
  if Not (Multientete or (DebL=1)) then
    begin
      For i:=1 to TabAClasser.ColCount-1 do
        For j:=1 to TabAClasser.RowCount-1 do
          begin
            TabAClasser.Cells[i,j]:=EtatDe(TabAClasser.Cells[0,j],TabAClasser.Cells[i,0],n);
          end;
    end;
end;

procedure TSousCollection.RetourTabRef;
begin
  if TabRef=Nil then TabRef.CopyCreate(TabRefRef)
  else TabRef.Assign(TabRefRef);
end;
procedure TSousCollection.MemoriseTabRef;
begin
  if TabRefRef=Nil then
    TabRefRef:=TStrListArray.CopyCreate(TabRef)
  else
    TabRefRef.Assign(TabRef);
end;
procedure TSousCollection.RetourCarRef;
begin
  RetourTabRef;
  Caracteres.RetourCDARef;
end;
function TSousCollection.GetEtatRef(NomTax,NomCarD:string):string;
Var
 NTax,NCar:integer;
begin
  Result:='';
  if (NomTax='')or(NomCarD='') then exit;
  NTax:=TabRef.IndexOfRow(NomTax);
  NCar:=TabRef.IndexOfCol(NomCarD);
  if (NTax>-1) and (NCar>0) then Result:=TabRef.StrItems[NTax,NCar];
end;
procedure TSousCollection.SetEtatRef(NomTax,NomCarD:string;etat:string);
Var
 NTax,NCar:integer;
begin
  if (NomTax='')or(NomCarD='') then exit;
  NTax:=TabRef.IndexOfRow(NomTax);
  NCar:=TabRef.IndexOfCol(NomCarD);
  if (NTax>-1) and (NCar>0) then TabRef.StrItems[NTax,NCar]:=etat;
end;
function TSousCollection.GetCarD(Index:integer):TCaractD;
begin
  Result:=Caracteres.CarDs.Items[Index];
end;

function TSousCollection.LeCarDRef(NomCarD:string):TCaractD;
Var
  //NumCar:integer;
  i:integer;
  Trouve:boolean;
  UnCarD:TCaractD;
begin
  Result:=Nil;
  if trim(NomCarD)='' then exit;
  Trouve:=false;
  i:=0;
  while (not Trouve) and (i < Caracteres.CarDRef.NbCarD) do
    begin
      UnCarD:=Caracteres.CarDRef.Items[i];
      if (UnCarD<>Nil) and (NomCarD=UnCarD.Nom) then Trouve:=True else inc(i);
    end;
  if Trouve then Result:=Caracteres.CarDRef.Items[i];
end;
function TSousCollection.GetCodeCase(NomTax,NomCarD:string):string;
Var
  etat:string;
  UnCarD:TCaractD;
  numetat:integer;
begin
  Result:='-1';
  etat:=GetEtatRef(NomTax,NomCarD);
  if etat='?' then result:=etat
  else if trim(etat)<>'' then
    begin
      UnCarD:=LeCarD(NomCarD);
      if UnCarD<>Nil then
        begin
          numetat:=UnCarD.ListeEtats.IndexOf(etat);
          Result:=IntToStr(numetat);
        end;
    end;
end;
Function TSousCollection.GroupesDeclares:Boolean;
begin
  Result:=False;
  initialiseEnsGroupes;
  if FEnsGroupes.Count>0 then
    Result:=True;
end;
procedure TSousCollection.initialiseEnsGroupes;
Var
  UnCarD:TCaractD;
  i,j:integer;
begin
  if FEnsGroupes=Nil then FEnsGroupes:=TStringList.Create;
  FEnsGroupes.Clear;
  //For i:=0 to Caracteres.CarD.Count-1 do
  For i:=0 to Caracteres.CarDs.NbCarD-1 do
    begin
      //UnCarD:=TCaractD(Caracteres.CarD[i]);
      UnCarD:=Caracteres.CarDs.Items[i];
      if UnCarD<>Nil then
        begin
          For j:=0 to UnCarD.NomsGroupes.Count-1 do
            if trim(UnCarD.NomsGroupes[j])<>'' then
              begin
                if FEnsGroupes.IndexOf(UnCarD.NomsGroupes[j])=-1 then
                  FEnsGroupes.Add(UnCarD.NomsGroupes[j]);
              end;
        end;
    end;
end;
function TSousCollection.GetEnsGroupes:TStringList;
begin
  initialiseEnsGroupes;
  Result:=FEnsGroupes;
end;

procedure TSousCollection.RetablitCaractere(ASupprimer:TStringList;ARetablir:string); //rtablit un caractreD et rejuste le TabRef
Var
  UnCarD,NvCarD:TCaractD;
  i,n:integer; //,j
begin
  //suppression des Caractres D  Supprimer
  For i:=0 to ASupprimer.Count-1 do
    begin
      UnCarD:=LeCarD(ASupprimer[i]);
      if UnCarD<>Nil then
        begin
          n:=Caracteres.CarDs.IndexOf(UnCarD);
          if n>-1 then Caracteres.CarDs.Delete(n);
        end;
      SuprimeColonneTabRef(ASupprimer[i]);// suppression de la colonne correspondante du TabRef
    end;
  //rtablir le caractre
  UnCarD:=LeCarDRef(ARetablir);
  if UnCarD<>Nil then
    begin
      NvCarD:=TCaractD.Create;
      NvCarD.Assign(UnCarD);
      Caracteres.CarDs.Add(NvCarD);
    end;
  // rtablir la colonne du TabRef
  RetablitColonneTabRef(ARetablir);
end;
procedure TSousCollection.SuprimeColonneTabRef(NomCarD:string);
Var
  n,i,j:integer;
  TabRefCopie:TStrListArray;
begin
  n:=TabRef.IndexOfCol(NomCarD);
  if n>-1 then
    begin
      TabRefCopie:=TStrListArray.CopyCreate(TabRef);
      For i:=n to TabrefCopie.GetMaxColCount-2 do
        For j:=0 to TabRefCopie.RowCount-1 do
          TabRefCopie.StrItems[j,i]:=TabRefCopie.StrItems[j,i+1];
      //Remise 'zro' de la dernire colonne
      For j:=0 to TabRefCopie.RowCount-1 do
          TabRefCopie.StrItems[j,TabrefCopie.GetMaxColCount-1]:='';
      TabRef.ClearListArray(toDelete);
      For i:=0 to TabrefCopie.GetMaxColCount-1 do
        begin
          if (i=0) or (TabRefCopie.StrItems[0,i]<>'') then
            For j:=0 to TabRefCopie.RowCount-1 do
              TabRef.StrItems[j,i]:=TabRefCopie.StrItems[j,i];
        end;
      TabRefCopie.Free;
    end;
end;
procedure TSousCollection.RetablitColonneTabRef(NomCarD:string); //rtablit d'aprs TabRefRef
Var
  i,n,nc:integer;
begin
  nc:=TabRefRef.IndexOfCol(NomCarD);
  if (nc>0)and (Trim(NomCarD)<>'') then
    begin
      n:=Tabref.GetMaxColCount;
      For i:=1 to Tabref.GetMaxColCount-1 do
        begin
          if TabRef.StrItems[0,i]='' then
            begin
              n:=i;
              break;
            end;
        end;
      For i:=0 to Tabref.RowCount-1 do
        TabRef.StrItems[i,n]:=TabRefRef.StrItems[i,nc];
    end;
end;
procedure TSousCollection.ListeCaractGroupe(Raz:boolean;nomGroupe:string;var Lignes:TStrings);
Var
  UnCarD:TCaractD;
  i,j,k:integer;
  mess:string;
  prem,premF,PasPourF:boolean;
  Tax:TTaxon;
begin
  if nomGroupe='' then exit;
  initialiseEnsGroupes;
  if Raz then Lignes.Clear
  else if Lignes.Count>0 then Lignes.Add('***********');
  prem:=True;
  For i:=0 to Caracteres.CarDs.NbCarD-1 do
    begin
      UnCarD:=Caracteres.CarDs.Items[i];          
      if UnCarD<>Nil then
        begin
          For j:=0 to UnCarD.NomsGroupes.Count-1 do
            if trim(UnCarD.NomsGroupes[j])=nomGroupe then
              begin
                premF:=True;
                if prem then
                  begin
//                    mess:='Les '+nomGroupe+' sont dfinis par :';
                    mess:=M_Les_4+nomGroupe+M_sontdfinispar;
                    Lignes.Add(Mess);
                  end;
                prem:=false;
                mess:='-> '+UnCarD.Nom+' ='+UnCarD.ListeEtats[j];
                Lignes.Add(Mess);
                PasPourF:=False;// tester pour les fossiles;
                For k:=0 to Taxons.NbTaxons-1 do
                  begin
                    Tax:=TTaxon(Taxons[k]);
                    if (Tax<>Nil)and(EtatRef[Tax.Nom,UnCarD.Nom]='?') then
                      PasPourF:=True;
                  end;
                if PasPourF then
                  begin
//                    mess:='    (critre non applicable certains fossiles)';
                    mess:=M_critrenonapplicabl;
                    Lignes.Add(Mess);
                  end;
                For k:=0 to Taxons.NbTaxons-1 do
                  begin
                    Tax:=TTaxon(Taxons[k]);
                    if (Tax.AgeApp>0)and(EtatRef[Tax.Nom,UnCarD.Nom]=UnCarD.ListeEtats[j]) then
                      begin
                        if premF then
                          begin
//                            mess:='fossiles de la collection :';
                            mess:=M_fossilesdelacollec;
                            Lignes.Add(Mess);
                            premF:=False;
                          end;
//                        mess:=Tax.Nom+' connu depuis -'+TranscritAge(Tax.AgeApp);
                        mess:=Tax.Nom+M_connudepuis+TranscritAge(Tax.AgeApp);
                        Lignes.Add(Mess);
                      end;
                  end;
              end;
        end;
    end;
end;
procedure TSousCollection.CreeTaxonsActifs(Tous:Boolean); //si Tous=True les taxons de type U ou D sont inclus (pour Observer et Comparer)
                                               //les Taxons de type X (exercice) sont toujours exclus
                                               // type D correspond  des fossiles trs fragmentaires  exclure des tableaux ais qui servent  la datation
Var
  i,n:integer;
  LeTaxon:TTaxon;
begin
  n:=0;
  SetLength(TaxonsActifs,n);
  For i:=0 to Taxons.Count-1 do
    begin
      LeTaxon:=TTaxon(Taxons[i]);
      if (LeTaxon<>Nil) and (pos('S',LeTaxon.TypeTaxon)=0) and (pos('X',LeTaxon.TypeTaxon)=0) and (Tous or((pos('U',LeTaxon.TypeTaxon)=0)and(pos('D',LeTaxon.TypeTaxon)=0))) then
        begin
          SetLength(TaxonsActifs,n+1);
          TaxonsActifs[n]:=LeTaxon;
          inc(n);
        end;
    end;
end;
procedure TSousCollection.CreeTaxonsExercice;
Var
  i,n:integer;
  LeTaxon:TTaxon;
begin
  n:=0;
  SetLength(TaxonsExercice,n);
  For i:=0 to Taxons.Count-1 do
    begin
      LeTaxon:=TTaxon(Taxons[i]);
      if (LeTaxon<>Nil) and (pos('X',LeTaxon.TypeTaxon)>0) then
        begin
          SetLength(TaxonsExercice,n+1);
          TaxonsExercice[n]:=LeTaxon;
          inc(n);
        end;
    end;
end;
procedure TSousCollection.CreeTaxonsSup;
Var
  i,n:integer;
  LeTaxon:TTaxon;
begin
  n:=0;
  SetLength(TaxonsSup,n);
  For i:=0 to Taxons.Count-1 do
    begin
      LeTaxon:=TTaxon(Taxons[i]);
      if (LeTaxon<>Nil) and (pos('X',LeTaxon.TypeTaxon)>0) then
        begin
          SetLength(TaxonsSup,n+1);
          TaxonsSup[n]:=LeTaxon;
          inc(n);
        end;
    end;
end;

function TSousCollection.CreeTabAges(Tableau:TStrListArray):TStrListArray;
Var
  i:integer;
  NomTaxon:string;
begin
  if Tableau=Nil then Result:=Nil
  else
    begin
      Result:=TStrListArray.createListArray;
      //Result.RowCount:=Tableau.RowCount;
      for i:=0 to Tableau.RowCount-1 do
        begin
          NomTaxon:=Tableau.StrItems[i,0];
          Result.StrItems[i,0]:=NomTaxon;
          Result.StrItems[i,1]:=AgeStrNm(NomTaxon);
        end;
    end;
end;

procedure TSousCollection.MiseEnCodeCoulNaoum;
Const
  NdClDef : array[0..17] of TColor =(clBlue, clYellow,clFuchsia,clRed, clGreen,
              clLime ,clNavy, clPurple ,clTeal ,clGray, clSilver,clMaroon ,  clOlive ,
              clAqua , clLtGray ,clDkGray ,  clWhite, clBlack );
Var
  CaracD:TCaractD;
  i,j:integer;
  AfCR,AfCD,AfCP:TAffichCell;
begin
  AfCR.Active:=false;
  AfCR.CouleurFond:=clWhite;
  AfCR.CouleurTexte:=clBlack;
  AfCR.styleFond:=bsSolid;
  AfCR.CouleurContour:=clBlack;
  AfCD:=AfCR;
  AfCD.Active:=true;
  AfCP:=AfCD;
  AfCP.CouleurTexte:=clBlue;
  AfCP.CouleurContour:=clBlue;
  For i:=0 to Caracteres.CarDs.NbCarD-1 do
    begin
      CaracD:=Caracteres.CarDs.Items[i];
      if CaracD<>Nil then
        begin
          if (CaracD.ListeEtats.Count>0) then CaracD.FixeAffichCellEtat(0,AfCP);
          For j:=1 to CaracD.ListeEtats.Count-1 do
            begin
              if trim(CaracD.ListeEtats[j])='?' then
                CaracD.FixeAffichCellEtat(j,AfCR)
              else
                begin
                  AfCD.CouleurFond:=NdClDef[j mod 18];
                  CaracD.FixeAffichCellEtat(j,AfCD);
                end;
            end;
        end;
    end;
end;
function TSousCollection.GetImageTaxActif(Num: integer): string;
Var
  Tax:TTaxon;
begin
  Result:='';
  if (Num>-1)and (Num<Length(TaxonsActifs)) then
    begin
      Tax:=TaxonsActifs[Num];
      if Tax<>Nil Then
        begin
          Result:=Taxons.CheminImagesT+Tax.Image+ExtImage;
        end;
    end;
end;
function TSousCollection.GetIconeTaxActif(Num: integer): string;
Var
  Tax:TTaxon;
begin
  Result:='';
  if (Num>-1)and (Num<Length(TaxonsActifs)) then
    begin
      Tax:=TaxonsActifs[Num];
      if Tax<>Nil Then
        begin
          Result:=Taxons.CheminIconesT+Tax.Image+ExtIcone;
        end;
    end;
end;
function TSousCollection.GetImageCarTaxActif(Num: integer; NumCar: integer):string;
Var
  Tax:TTaxon;
  NomFichier:string;
begin
  Result:='';
  if (Num>-1)and (Num<Length(TaxonsActifs))and (NumCar>-1) and(NumCar<Taxons.NbCaract) then
    begin
      Tax:=TaxonsActifs[Num];
      if Tax<>Nil Then
        begin
          NomFichier:=Taxons.FCaracteres.CheminImagesC+Tax.ImageCars[NumCar]+ExtImageb;
          if not FileExists(NomFichier) then
            NomFichier:=Taxons.FCaracteres.CheminImagesC+Tax.ImageCars[NumCar]+ExtImage;
          Result:=NomFichier;
        end;
    end;
end;
function TSousCollection.GetImageCarBigTaxActif(Num: integer; NumCar: integer):string;
Var
  Tax:TTaxon;
  NomFichier:string;
begin
  Result:='';
  if (Num>-1)and (Num<Length(TaxonsActifs))and (NumCar>-1) and(NumCar<Taxons.NbCaract) then
    begin
      Tax:=TaxonsActifs[Num];
      if Tax<>Nil Then
        begin
          //Result:=Taxons.FCaracteres.CheminImagesC+Tax.ImageCars[NumCar]+'B'+ExtImage;
          NomFichier:=Taxons.FCaracteres.CheminImagesC+Tax.ImageCars[NumCar]+'B'+ExtImageb;
          if not FileExists(NomFichier) then
            NomFichier:=Taxons.FCaracteres.CheminImagesC+Tax.ImageCars[NumCar]+'B'+ExtImage;
          Result:=NomFichier;
        end;
    end;
end;
function TSousCollection.GetTexteCarTaxActif(Num: integer; NumCar: integer):string;
Var
  Tax:TTaxon;
begin
  Result:='';
  if (Num>-1)and (Num<Length(TaxonsActifs))and (NumCar>-1) and(NumCar<Taxons.NbCaract) then
    begin
      Tax:=TaxonsActifs[Num];
      if Tax<>Nil Then
        begin
          Result:=Taxons.FCaracteres.CheminTextesC+Tax.ImageCars[NumCar]+ExtTxt;
          //Result:=Taxons.FCaracteres.CheminImagesC+Tax.ImageCars[NumCar]+ExtImage;
        end;
    end;
end;
function TSousCollection.GetNumTaxActif(NomTaxon: string):integer;
Var
  Tax:TTaxon;
  i:integer;
begin
  Result:=-1;
  For i:=0 to Length(TaxonsActifs)-1 do
    begin
      Tax:=TaxonsActifs[i];
      if (Tax<>Nil) and (Tax.Nom=NomTaxon) then
        begin
          Result:=i;
          Break;
        end;
    end;
end;
Function TSousCollection.AUnEtatDerive(NomTaxon:string;ListeCaracteres:TStringList):Boolean;
Var
  i:integer;
  LEtat:string;
  NumEtat:integer;
begin
  Result:=False;
  For i:=0 to ListeCaracteres.Count-1 do
    begin
      LEtat:=EtatDe(NomTaxon,ListeCaracteres[i],NumEtat);
      if (LEtat<>'')and(LEtat<>'?')and (NumEtat>0) then
        begin
          Result:=True;
          break;
        end;
    end;
end;
function  TSousCollection.CalculeProfils(DebCol,DebLign:integer;Tableau:TStringList;var PrCol0:integer;var profils:TProfils):integer;// renvoie le numro de la colonne maxi pour un caractre de type 1
                    // PrCol0 colonne  mettre en premier pour les caractres de type 0
Var
  i,j,n,debC,Debl:integer;
  CD:TCaractD;
  CDE:boolean;
  ValMax0,ValMax1,Val:integer;
  Colonne:TStringList;
begin
  Result:=0;
  ValMax0:=-1;
  ValMax1:=-1;
  PrCol0:=0;
  DebC:=DebCol;
  DebL:=DebLign;
  Colonne:=TStringList.Create;
  SetLength(Profils,Tableau.Count-DebC);
  For i:=DebC to Tableau.Count-1 do
    begin
      Colonne.CommaText:=Tableau[i];
      SetLength(Profils[i-DebC],Colonne.Count-DebL);
      CD:=LeCarD(Colonne[0]);
      CDE:=(CD<>Nil);
      Val:=0;
      For j:=DebL to Colonne.Count-1 do
        begin
          if CDE then
            begin
              n:=CD.ListeEtats.IndexOf(Colonne[j]);
              if n>-1 then
                begin
                  Profils[i-DebC,j-DebL]:=n;
                  if n>0 then inc(Val);
                end
              else Profils[i-DebC,j-DebL]:=0;
            end
          else Profils[i-DebC,j-DebL]:=0;
        end;
      if CDE and (CD.TypeCarD>0) and (Val>ValMax1)  then
        begin
          ValMax1:=Val;
          Result:=i;
        end
      else if CDE and (CD.TypeCarD=0) and (Val>ValMax0)  then
        begin
          ValMax0:=Val;
          PrCol0:=i;
        end;
    end;
  Colonne.Free;
end;

procedure TSousCollection.ClasseColonnesTableau(DebCol,DebLign:integer;Var Tableau:TStringList);
Var
  i,j,n,DebC,DebL:integer;
  Profils:TProfils;
  profil1,profil2,unprofil:TProfil;
  ExtraitTableau:TStringList;
  Colonne:TStringList;
  PrCol0:integer;
  NomCar:string;
  UnCarD:TCaractD;
begin
  n:=CalculeProfils(DebCol,DebLign,Tableau,PrCol0,profils);  // choisir la colonne dont le type est >0  mettre en premier
  DebC:=DebCol;
  DebL:=DebLign;
  ExtraitTableau:=TStringList.Create;
  Colonne:=TStringList.Create;
  // si n> DebC  : mettre la colonne en premier
  if n>DebC then
    begin
      Tableau.Exchange(n,DebC);
      unprofil:=profils[n-DebC];
      profils[n-DebC]:=profils[0];
      profils[0]:=unprofil;
    end;
  // construire un extrait du tableau (sousTableau)avec les colonnes dont le profil est inclu
  if n>=DebC then
    begin
      inc(DebC);
      For i:=DebC to Tableau.Count-1 do
        begin
          profil1:=profils[0];
          profil2:=profils[i-DebCol];
          n:=compareProfils(profil1,profil2);
          if (n=1) or (n=0) then ExtraitTableau.Add(Tableau[i]);
        end;
    // Si nombre de colonnes>1 Appeler ClasseColonnesTableau(sousTableau)
      if ExtraitTableau.Count>1 then
        ClasseColonnesTableau(0,DebLign,ExtraitTableau);
  // Classer les colonnes correspondantes;
      For i:=0 to ExtraitTableau.Count-1 do
        begin
          //rechercher le numro de la colonne du tableau d'origine
          Colonne.CommaText:=ExtraitTableau[i];
          NomCar:=Colonne[0];
          n:=0;
          for j:=DebC to Tableau.Count-1 do
            begin
              Colonne.CommaText:=Tableau[j];
              if NomCar=Colonne[0] then
                begin
                  n:=j;
                  break;
                end;
            end;
          if n>=DebC then
            begin
              Tableau.Exchange(n,DebC);
              unprofil:=profils[n-DebC];
              profils[n-DebC]:=profils[0];
              profils[0]:=unprofil;
              inc(DebC);
            end;
        end;
    end;

  //
  ExtraitTableau.Clear;
  // Faire un soustableau avec les autres colonnes dont le type est >0
  For i:=DebC to Tableau.Count-1 do
    begin
      Colonne.CommaText:=Tableau[i];
      NomCar:=Colonne[0];
      UnCarD:=LeCarD(NomCar);
      If UnCarD<>Nil then
        begin
          if UnCarD.TypeCarD>0 then ExtraitTableau.Add(Tableau[i]);
        end;
    end;
  // Si nombre de colonnes>1 Appeler ClasseColonnesTableau(sousTableau)
  if ExtraitTableau.Count>1 then
    ClasseColonnesTableau(0,DebLign,ExtraitTableau);
  // Classer les colonnes correspondantes;
  For i:=0 to ExtraitTableau.Count-1 do
    begin
      //rechercher le numro de la colonne du tableau d'origine
      Colonne.CommaText:=ExtraitTableau[i];
      NomCar:=Colonne[0];
      n:=0;
      for j:=DebC to Tableau.Count-1 do
        begin
          Colonne.CommaText:=Tableau[j];
          if NomCar=Colonne[0] then
            begin
              n:=j;
              break;
            end;
        end;
      if n>=DebC then
        begin
          Tableau.Exchange(n,DebC);
          unprofil:=profils[n-DebC];
          profils[n-DebC]:=profils[0];
          profils[0]:=unprofil;
          inc(DebC);
        end;
    end;
  //
  ExtraitTableau.Clear;
  // choisir la colonne dont le type est =0  mettre en premier
  n:=CalculeProfils(DebC,DebLign,Tableau,PrCol0,profils);
  n:=PrCol0;
    // si n> DebC  : mettre la colonne en premier
  if n>DebC then
    begin
      Tableau.Exchange(n,DebC);
      unprofil:=profils[n-DebC];
      profils[n-DebC]:=profils[0];
      profils[0]:=unprofil;
    end;
  // construire un extrait du tableau (sousTableau)avec les colonnes dont le profil est inclu
  if n>=DebC then
    begin
      inc(DebC);
      For i:=DebC to Tableau.Count-1 do
        begin
          profil1:=profils[0];
          //profil2:=profils[i-DebCol];
          profil2:=profils[i-DebC];
          n:=compareProfils(profil1,profil2);
          if (n=1) or (n=0) then ExtraitTableau.Add(Tableau[i]);
        end;
    // Si nombre de colonnes>1 Appeler ClasseColonnesTableau(sousTableau)
      if ExtraitTableau.Count>1 then
        ClasseColonnesTableau(0,DebLign,ExtraitTableau);
  // Classer les colonnes correspondantes;
      For i:=0 to ExtraitTableau.Count-1 do
        begin
          //rechercher le numro de la colonne du tableau d'origine
          Colonne.CommaText:=ExtraitTableau[i];
          NomCar:=Colonne[0];
          n:=0;
          for j:=DebC to Tableau.Count-1 do
            begin
              Colonne.CommaText:=Tableau[j];
              if NomCar=Colonne[0] then
                begin
                  n:=j;
                  break;
                end;
            end;
          if n>=DebC then
            begin
              Tableau.Exchange(n,DebC);
              unprofil:=profils[n-DebC];
              profils[n-DebC]:=profils[0];
              profils[0]:=unprofil;
              inc(DebC);
            end;
        end;
    end;

  //
  // Classer les colonnes qui restent;
  if DebC<Tableau.Count-1 then
    ClasseColonnesTableau(DebC,DebLign,Tableau);

  ExtraitTableau.Free;
  Colonne.Free;
end;
procedure TSousCollection.ClasseLignesTableau(DebCol,PremLigne,DerLigne:integer;Var Tableau:TStringList);
Var
  i,j,n,prem,der:integer;
  Ligne:TStringList;
  NomCar:string;
  UnCarD:TCaractD;
  NomEtat:string;
  TesterPDI:integer;
begin
  Ligne:=TStringList.Create;
  Ligne.CommaText:=Tableau[0];
  If (DebCol>=Ligne.Count) or (DerLigne>=Tableau.Count) then
    begin
      Ligne.Free;
      exit;
    end;
  NomCar:=Ligne[DebCol];
  UnCarD:=LeCarD(NomCar);
  prem:=PremLigne;
  if UnCarD<>Nil then
    begin
      TesterPDI:=0;
      n:=UnCarD.ListeEtats.Count;
      for i:=n-1 Downto 1 do
        begin
          NomEtat:=UnCarD.ListeEtats[i];
          if NomEtat='?' then
            TesterPDI:=i
          else
            begin
              der:=DerLigne;
              j:=prem;
              while (j<=der) do
                begin
                  Ligne.CommaText:=Tableau[j];
                  if Ligne[DebCol]=NomEtat then
                    inc(j)
                  else
                    begin
                      Tableau.Exchange(j,Der);
                      dec(Der);
                    end;
                end;
              if Prem<Der then
                ClasseLignesTableau((DebCol+1),Prem,Der,Tableau);
              prem:=j;
            end;
        end;
      if TesterPDI>0 then
        begin
          NomEtat:='?';
          der:=DerLigne;
          j:=prem;
          while (j<der) do
            begin
              Ligne.CommaText:=Tableau[j];
              if Ligne[DebCol]=NomEtat then
                inc(j)
              else
                begin
                  Tableau.Exchange(j,Der);
                  dec(Der);
                end;
            end;
          if Prem<Der then
            ClasseLignesTableau((DebCol+1),Prem,Der,Tableau);
          prem:=j;
        end;
      der:=DerLigne;
      if Prem<Der then
        ClasseLignesTableau((DebCol+1),Prem,Der,Tableau);
    end;
  Ligne.Free;
end;
procedure TSousCollection.FusionneColonnesTableau(Tableau:TTabGrid);
Var
  i,j,deri,derj:integer;
  profil1,profil2,ChaineNulle:String;
begin
  // initialisation
  ChaineNulle:=SuiteDeZeros(Tableau.RowCount-Tableau.FixedRows);
  deri:=Tableau.ColCount-2;
  derj:=Tableau.ColCount-1;
  i:=Tableau.FixedCols;
  // comparaison des colonnes et fusions
  While i<=deri do
    begin
      profil1:=CalculeProfil(Tableau.Cols[i],Tableau.FixedRows);
      j:=i+1;
      While j<=derj do
        begin
          profil2:=CalculeProfil(Tableau.Cols[j],Tableau.FixedRows);
          if (profil1=profil2) and (profil1<>ChaineNulle) then
            begin
              Tableau.FusionnerlesColonnes(i,j);
              dec(derj);
              dec(deri);
            end
          else inc(j);
        end;
      inc(i);
    end;
end;
function TSousCollection.CalculeProfil(Colonne:TStrings;PremLigne:integer):string;
Var
  i,n:integer;
  CD:TCaractD;
begin
  Result:='';
  CD:=LeCarD(Colonne[0]);
  if CD<>Nil then
    begin
      For i:=PremLigne to Colonne.Count-1 do
        begin
          n:=CD.ListeEtats.IndexOf(Colonne[i]);
          if n>-1 then
            Result:=Result+IntToStr(n)
          else Result:=Result+'0';
        end;
    end;
end;

//**********************************
//TTaxon
constructor TTaxon.create;
Begin
  inherited create;
  Selected:=true;
  Enabled:=true;
  Choisi:=False;
  TypeTaxon:=''; //combinaison de F (fossile) E (extragroupe) ...
  AgeApp:=0; // ge en milliers d'annes, actuel par defaut
  AgeDisp:=0;
  ImageCars:=TStringList.Create;
  DocsDivers:=TStringList.Create;
end;
function TTaxon.LitTypeTax(chaine:string):string;
Var
  copie:string;
  i:integer;
begin
  copie:='';
  Result:='';
  for i:=1 to Length(Chaine) do
    if (UpperCase(Chaine[i])='F') or (UpperCase(Chaine[i])='U')or(UpperCase(Chaine[i])='X') or (UpperCase(Chaine[i])='E') then copie:=copie+UpperCase(Chaine[i]);
  if copie<>'' then TypeTaxon:=copie;
  Result:=TypeTaxon;
end;
function TTaxon.LitAges(var date1,date2:string):boolean;
Var
  d1,d2,dt:integer;
begin
  Result:=true;
  try
    d1:=Abs(StrToInt(trim(date1)));
  except
    d1:=0;
    Result:=False;
  end;
  try
    d2:=Abs(StrToInt(trim(date2)));
  except
    d2:=0;
    Result:=False;
  end;
  if d2>d1 then
    begin
      dt:=d1;
      d1:=d2;
      d2:=dt;
    end;
  date1:=IntToStr(d1);
  date2:=IntToStr(d2);
  AgeApp:=d1;
  AgeDisp:=d2;
end;
destructor TTaxon.Destroy;
begin
  ImageCars.Free;
  DocsDivers.Free;
  inherited Destroy;
end;
function TTaxon.GetExtraGroupe:boolean;
begin
  Result:=(pos('E',TypeTaxon)>0);
end;
procedure TTaxon.SetExtraGroupe(valeur:Boolean);
Var
  n:integer;
begin
  n:=pos('E',TypeTaxon);
  if valeur and (n=0)then TypeTaxon:=TypeTaxon+'E'
  else if (Not Valeur) and (n>0) then Delete(TypeTaxon,n,1);
end;

//***********************************
//TTaxons
procedure TTaxons.LitDansStringList(ListeLignes: TStringList;var n:integer);
var
  L:TStringList;
  T:TTaxon;
  i,j:integer;
begin
  L:=TStringList.Create;

  for i:=n to ListeLignes.Count - 1 do
    begin
      //if ListeLignes.Strings[i]='<Caractres>' then
      if ListeLignes.Strings[i][1]='<' then
        begin
          n:=i+1;
          break;
        end;
      L.CommaText:=ListeLignes[i];
      T:=TTaxon.Create;
      T.Selected:=False;
      T.Enabled:=True;
      T.Nom:=L[0];
      T.TypeTaxon:=L[1];
      try
        T.AgeApp:=StrToInt(L[2]);
        T.AgeDisp:=StrToInt(L[3]);
      except
      end;
      T.Image:=L[4];
      for j:=5 to L.Count-1 do T.ImageCars.Add(L[j]);
      AddTaxon(T);
    end;
  L.Free;
   // NbCaract :=  NbCaract du premier taxon
  //NbCaract:=TTaxon(Items[0]).ImageCars.Count;
end;
procedure TTaxons.CopieDansStringList(Tout:boolean;var ListeLignes: TStringList); // nouvelle version qui sauvegarde le type et les ges
var
  L:TStringList;
  T:TTaxon;
  i,j:integer;
begin
  L:=TStringList.Create;

  for i:=0 to Count-1 do
    begin
      T:=TTaxon(Items[i]);
      if (Tout or T.Selected) then // si tout= False : n'enregistre que les Taxons slectionns
        begin
          L.Clear;
          L.Add(T.Nom);
          L.Add(T.TypeTaxon);
          L.Add(IntToStr(T.AgeApp));
          L.Add(IntToStr(T.AgeDisp));
          L.Add(T.Image);
          for j:=0 to T.ImageCars.Count-1 do
            begin
              if (FCaracteres<>nil)and (Length(FCaracteres.Selectionnes)>=T.ImageCars.Count) then
                begin
                  if  (Tout or FCaracteres.Selectionnes[j]) then  //limiter  celles qui corespondent  des caractres utiliss
                    L.Add(T.ImageCars[j]);
                end
              else L.Add(T.ImageCars[j]);
            end;
          ListeLignes.Add(L.CommaText);
        end;
    end;
  L.Free;
end;

procedure TTaxons.CopieDansStringListVAnc(var ListeLignes: TStringList); //  supprimer  terme;
var
  L:TStringList;
  T:TTaxon;
  i,j:integer;
begin
  L:=TStringList.Create;

  for i:=0 to Count-1 do
    begin
      T:=TTaxon(Items[i]);
      if T.Selected then // n'enregistre que les Taxons slectionns
        begin
          L.Clear;
          L.Add(T.Nom);
          L.Add(T.Image);
          for j:=0 to T.ImageCars.Count-1 do
            begin
              if (FCaracteres<>nil)and (Length(FCaracteres.Selectionnes)>=T.ImageCars.Count) then
                begin
                  if  FCaracteres.Selectionnes[j] then  //limiter  celles qui corespondent  des caractres utiliss
                    L.Add(T.ImageCars[j]);
                end
              else L.Add(T.ImageCars[j]);
            end;
          ListeLignes.Add(L.CommaText);
        end;
    end;
  L.Free;
end;
// ancienne structure  supprimer  terme;
procedure TTaxons.EnregistrerFichier(Fich: string); // enregistrement d'un fichier .phg
var                                                 // utilise la procdure prcdente
  ListeLignes: TStringList;                         // Placer avant Taxons.FCaracteres:=Caracteres et ajuster
begin
  ListeLignes:=TStringList.Create;

  CopieDansStringListVAnc(ListeLignes);

  ListeLignes.SaveToFile(Fich);
  ListeLignes.Free;
end;
function TTaxons.GetNbCaract:integer;
begin
  GetNbCaract:=FCaracteres.Noms.Count;
end;
procedure TTaxons.InsereTaxon(T:TTaxon;Var num:integer); //num numro du nouveau taxon les suivants changent de numro
Var
  //UnTaxon:TTaxon;
  i,n:integer;
begin
  if T=nil then exit;
  n:=Count;
  if num>=n then
    begin
      Add(T);
      num:=n;
    end
  else
    begin
      Insert(num,T);
{      Add(Items[n-1]);
      for i:=n-1 downto num+1 do
        begin
          Items[i]:=Items[i-1];
        end;
      Items[Num]:=@T; }
    end;
  inc(NbTaxons);
end;
procedure TTaxons.AddTaxon(T:TTaxon);
begin
  Add(T);
  inc(NbTaxons);
end;
procedure TTaxons.RAZSelected;
Var
  i:integer;
begin
  For i:=0 to nbTaxons-1 do
    TTaxon(Items[i]).Selected:=False;
end;
procedure TTaxons.RAZChoisis;
Var
  i:integer;
begin
  For i:=0 to nbTaxons-1 do
    TTaxon(Items[i]).Choisi:=False;
end;
procedure TTaxons.ChoisisTout;
Var
  i:integer;
begin
  For i:=0 to nbTaxons-1 do
    TTaxon(Items[i]).Choisi:=True;
end;

procedure TTaxons.SelectAll;
Var
  i:integer;
begin
  For i:=0 to nbTaxons-1 do
    TTaxon(Items[i]).Selected:=True;
end;

procedure TTaxons.RetireTaxon(Num: integer);
begin
  if Num<Count then
    begin
      Delete(Num);
      dec(NbTaxons);
    end;
end;
procedure TTaxons.RetireTaxonNomme(Nom: string);
Var
  Num:integer;
begin
  Num:=GetNumTaxon(Nom);
  if (Num>-1)and(Num<Count) then
    begin
      Delete(Num);
      dec(NbTaxons);
    end;
end;

function TTaxons.GetNom(Num: integer):string;
// renvoie le nom du taxon d'index Num dans la liste
begin
  GetNom:='';
  if (Num>-1)and (Num<NbTaxons)then
    GetNom:=TTaxon(Items[Num]).Nom;
end;

function TTaxons.GetImage(Num: integer):string;
// renvoie le pathname complet de l'image du taxon d'index Num dans la liste
Var
  Tax:TTaxon;
begin
  GetImage:='';
  if (Num>-1)and (Num<NbTaxons)then
    begin
      Tax:=TTaxon(Items[Num]);
      if Tax<>Nil then
        GetImage:=CheminImagesT+Tax.Image+ExtImage;
    end;
end;

function TTaxons.GetIcone(Num: integer):string;
// renvoie le pathname complet de l'icone du taxon d'index Num dans la liste
Var
  Tax:TTaxon;
begin
  GetIcone:='';
  if (Num>-1)and (Num<NbTaxons)then
    begin
      Tax:=TTaxon(Items[Num]);
      if Tax<>Nil then
        GetIcone:=CheminIconesT+Tax.Image+ExtIcone;
    end;
end;
function TTaxons.GetTaxon(NomTaxon:string):TTaxon;
Var
  n:integer;
begin
  Result:=Nil;
  n:=GetNumTaxon(NomTaxon);
  if (n>-1) then Result:=TTaxon(Items[n]);
end;
function TTaxons.GetNumTaxon(NomTaxon: string):integer;
// renvoie le rang de NomTaxon ds Taxons (de 0  Count-1)
// -1 si NomTaxon n'existe pas
var
  i:integer;
  Trouve:boolean;
begin
  Trouve:=false;
  i:=0;
  while (not Trouve) and (i < Count) do   //Taxons.
  if (NomTaxon=GetNom(i)) then Trouve:=True else inc(i);  //Taxons.

  if Trouve then GetNumTaxon:=i else GetNumTaxon:=-1;
end;

function TTaxons.GetImageCar(NumEsp: integer; NumCar: integer):string;
// renvoie le pathname complet de l'image du caractere NumCar pour le taxon NumEsp
Var
  Tax:TTaxon;
  NomFichier:string;
begin
  GetImageCar:='';
  if (NumEsp>-1)and (NumCar>-1)and (NumEsp<NbTaxons)and (NumCar<NbCaract) then
    begin
      Tax:=TTaxon(Items[NumEsp]);
      if Tax<>Nil then
        begin
          //GetImageCar:=FCaracteres.CheminImagesC+Tax.ImageCars[NumCar]+ExtImage;
          NomFichier:=FCaracteres.CheminImagesC+Tax.ImageCars[NumCar]+ExtImageb;
          if Not FileExists(NomFichier) then
            NomFichier:=FCaracteres.CheminImagesC+Tax.ImageCars[NumCar]+ExtImage;
          GetImageCar:=NomFichier;
        end;
    end;
end;

function TTaxons.GetImageCarBig(NumEsp: integer; NumCar: integer):string;
// renvoie le pathname complet de l'image de grande taille  ('B'  la fin)
// du caractere NumCar pour le taxon NumEsp
Var
  Tax:TTaxon;
  NomFichier:string;
begin
  GetImageCarBig:='';
  if (NumEsp>-1)and (NumCar>-1)and (NumEsp<NbTaxons)and (NumCar<NbCaract) then
    begin
      Tax:=TTaxon(Items[NumEsp]);
      if Tax<>Nil then
        //GetImageCarBig:=FCaracteres.CheminImagesC+Tax.ImageCars[NumCar]+'B'+ExtImage;
        begin
          NomFichier:=FCaracteres.CheminImagesC+Tax.ImageCars[NumCar]+'B'+ExtImageb;
          if Not FileExists(NomFichier) then
            NomFichier:=FCaracteres.CheminImagesC+Tax.ImageCars[NumCar]+'B'+ExtImage;
          GetImageCarBig:=NomFichier;
        end;
    end;
end;

function TTaxons.GetTexteCar(NumEsp: integer; NumCar: integer):string;
// renvoie le pathname complet du texte associ au caractere NumCar
// pour le taxon NumEsp
Var
  Tax:TTaxon;
begin
  GetTexteCar:='';
  if (NumEsp>-1)and (NumCar>-1)and (NumEsp<NbTaxons)and (NumCar<NbCaract) then
    begin
      Tax:=TTaxon(Items[NumEsp]);
      if Tax<>Nil then
        GetTexteCar:=FCaracteres.CheminTextesC+TTaxon(Items[NumEsp]).ImageCars[NumCar]+ExtTxt;
    end;
end;

procedure TTaxons.LireFichier(Fich: string); // lecture d'un fichier .phg
var
  ListeLignes: TStringList;
  L:TStringList;
  T:TTaxon;
  i,j,deb:integer;
begin
  Deb:=0;
  ListeLignes:=TStringList.Create;
  L:=TStringList.Create;
  if FileExists(Fich) then
    ListeLignes.LoadFromFile(Fich)
  else
    begin
//      ShowMessage('Le fichier '+Fich+' n''existe pas');
      ShowMessage(M_Lefichier+Fich+L_NexistePas);
      Exit;
    end;
  //if ListeLignes.Count>0 then if ListeLignes[0]='<V2>' then Deb:=2;

  for i:=Deb to ListeLignes.Count - 1 do
    begin
      L.CommaText:=ListeLignes[i];
      T:=TTaxon.Create;
      T.Selected:=False;
      T.Enabled:=True;
      T.Nom:=L[0];
      T.Image:=L[1];
      for j:=2 to L.Count-1 do T.ImageCars.Add(L[j]);
      AddTaxon(T);
    end;
  ListeLignes.Free;
  L.Free;
   // NbCaract :=  NbCaract du premier taxon
  //NbCaract:=TTaxon(Items[0]).ImageCars.Count;
end;
procedure TTaxons.Copie(Modele:TTaxons;Tout:Boolean);
Var
  i:integer;
  NvTaxon,TaxMod:TTaxon;
begin
  CheminImagesT:=Modele.CheminImagesT;
  CheminIconesT:=Modele.CheminIconesT;
  For i:=0 to Modele.NbTaxons-1 do
    begin
      NvTaxon:=TTaxon.create;
      TaxMod:=TTaxon(Modele[i]);
      if TaxMod<>Nil then
        begin
          NvTaxon.Nom:=TaxMod.Nom;
          NvTaxon.Image:=TaxMod.Image;
          NvTaxon.Selected:=TaxMod.Selected;
          NvTaxon.Enabled:=TaxMod.Enabled;
          NvTaxon.TypeTaxon:=TaxMod.TypeTaxon;
          NvTaxon.AgeApp:=TaxMod.AgeApp;
          NvTaxon.AgeDisp:=TaxMod.AgeDisp;
          NvTaxon.ImageCars.CommaText:=TaxMod.ImageCars.CommaText;
          NvTaxon.DocsDivers.CommaText:=TaxMod.DocsDivers.CommaText;
          AddTaxon(NvTaxon);
        end;
    end;
  FCaracteres:=Modele.FCaracteres;
end;
//================== Caracteres =====================
//*******************  TCaractD
constructor TCaractD.create;
begin
  inherited create;
  TypeCarD:=0;  // 0: non ordonn,  1: ordonn
  Selected:=true;
  Active:=false;
  ListeEtats:=TStringList.create; //Liste ordonne (si possible)  des tats : l'tat primitif toujours en premier,
                             // puis tats drivs puis '?' (si ncessaire)  la fin
  ListeDocEtats:=TStringList.create;
  NomsGroupes:=TStringList.create;
  NomsGroupesNommes:=TStringList.create;
  AffRAZ.Active:=false;
  AffRAZ.CouleurFond:=clWhite;
  AffRAZ.CouleurTexte:=clBlack;
  AffRAZ.styleFond:=bsSolid;
  AffRAZ.CouleurContour:=ClBlack;
  Couleur:=clWhite;
end;
destructor TCaractD.Destroy;
begin
  if ListeEtats<>Nil then ListeEtats.free;
  if ListeDocEtats<>Nil then ListeDocEtats.Free;
  if NomsGroupes<>Nil then NomsGroupes.Free;
  if NomsGroupesNommes<>Nil then NomsGroupesNommes.Free;
  SetLength(GroupesNommes,0);
  SetLength(CouleursEtats,0);
  inherited Destroy;
end;
function TCaractD.LitAffichCellEtatNm(etat:string):TAffichCell;
Var
  Numetat:integer;
begin
  Result:=AffRAZ;
  Numetat:=ListeEtats.IndexOf(etat);
  if NumEtat>-1 then
    begin
      AjusteEtats;
      Result:=CouleursEtats[NumEtat];
    end;
end;
function TCaractD.LitAffichCellEtat(numetat:integer):TAffichCell;
begin
  Result:=AffRAZ;
  if (NumEtat>-1) and (NumEtat<ListeEtats.Count) then
    begin
      AjusteEtats;
      Result:=CouleursEtats[NumEtat];
    end;
end;
function TCaractD.FixeAffichCellEtatNm(etat:string;Aff:TAffichCell):boolean;
Var
  Numetat:integer;
begin
  Result:=false;
  Numetat:=ListeEtats.IndexOf(etat);
  if NumEtat>-1 then
    begin
      AjusteEtats;
      CouleursEtats[NumEtat]:=Aff;
      Result:=true;
    end;
end;
function TCaractD.FixeAffichCellEtat(numetat:integer;Aff:TAffichCell):boolean;
begin
  Result:=false;
  if (NumEtat>-1)and (NumEtat<ListeEtats.Count) then
    begin
      AjusteEtats;
      CouleursEtats[NumEtat]:=Aff;
      Result:=true;
    end;
end;

procedure TCaractD.AjusteEtats;
Var
  j,ancNb:integer;
begin
  SetLength(GroupesNommes,ListeEtats.Count);
  for j:=ListeDocEtats.Count to ListeEtats.Count-1  do ListeDocEtats.Add('');
  for j:=NomsGroupes.Count to ListeEtats.Count-1  do
    begin
      NomsGroupes.Add('');
      NomsGroupesNommes.Add('');
      GroupesNommes[j]:=false;
    end;
  ancNb:=Length(CouleursEtats);
  SetLength(CouleursEtats,ListeEtats.Count);
  For j:=ancNb to ListeEtats.Count-1 do
    CouleursEtats[j]:=AffRAZ;
end;
procedure TCaractD.AjouteEtat(nouvEtat,NouvDoc,NouvGroupe:string);
Var
  j:integer;
begin
  for j:=ListeDocEtats.Count to ListeEtats.Count-1  do ListeDocEtats.Add('');
  ListeEtats.Add(nouvEtat);
  ListeDocEtats.Add(nouvDoc);
  if NouvGroupe<>'' then
    NomsGroupes.Add(NouvGroupe)
  else
    NomsGroupes.Add('');
  NomsGroupesNommes.Add('');
  SetLength(GroupesNommes,ListeEtats.Count);
  GroupesNommes[ListeEtats.Count-1]:=False;
end;
procedure TCaractD.InsereEtat(i:integer;nouvEtat,NouvDoc:string);
Var
  j:integer;
begin
  for j:=ListeDocEtats.Count to ListeEtats.Count-1  do ListeDocEtats.Add('');
  if i<ListeEtats.Count then ListeEtats.Insert(i,nouvEtat);
  if i<ListeDocEtats.Count then ListeDocEtats.Insert(i,NouvDoc);
  SetLength(GroupesNommes,ListeEtats.Count);
end;
procedure TCaractD.RetireEtat(i:integer);
Var
  j:integer;
begin
  for j:=ListeDocEtats.Count to ListeEtats.Count-1  do ListeDocEtats.Add('');
  if i<ListeEtats.Count then ListeEtats.Delete(i);
  if i<ListeDocEtats.Count then ListeDocEtats.Delete(i);
  SetLength(GroupesNommes,ListeEtats.Count);
end;
procedure TCaractD.RAZEtat;
begin
  ListeEtats.Clear;
  ListeDocEtats.Clear;
  NomsGroupes.Clear;
  NomsGroupesNommes.Clear;
  SetLength(GroupesNommes,0);
end;
procedure TCaractD.RAZGroupesNommes;
Var
  i:integer;
begin
  SetLength(GroupesNommes,ListeEtats.Count);
  For i:=0 to Length(GroupesNommes)-1 do
    begin
      GroupesNommes[i]:=False;
      NomsGroupesNommes[i]:='';
    end;
end;
procedure TCaractD.Assign(CaracD:TCaractD);
Var
  i:integer;
begin
  if CaracD<>nil then
    begin
      Nom:=CaracD.Nom;
      TypeCarD:=CaracD.TypeCarD;
      NomCarParent:=CaracD.NomCarParent;
      Selected:=CaracD.Selected;
      Active:=CaracD.Active;
      ListeEtats.Assign(CaracD.ListeEtats);
      ListeDocEtats.Assign(CaracD.ListeDocEtats);
      NomsGroupes.Assign(CaracD.NomsGroupes);
      NomsGroupesNommes.Assign(CaracD.NomsGroupesNommes);
      SetLength(CouleursEtats,Length(CaracD.CouleursEtats));
      For i:=0 to Length(CaracD.CouleursEtats)-1 do
        CouleursEtats[i]:=CaracD.CouleursEtats[i];
      SetLength(GroupesNommes,Length(CaracD.GroupesNommes));
      For i:=0 to Length(CaracD.GroupesNommes)-1 do
        GroupesNommes[i]:=CaracD.GroupesNommes[i];
      AffRAZ:=CaracD.AffRAZ;
    end;
  Couleur:=CaracD.Couleur;
end;
//****************** TCarDs
constructor TCarDs.Create;
begin
  inherited create;
  CodAuto:=false;// true pour neutraliser le chargement du .cod pour des vrifications
  DeuxEtatsMax:=true;
  FCodesEtats:=TStrListArray.CreateListArray;
  FItems:=TList.Create;
end;
destructor TCarDs.Destroy;
Var
  i,n:integer;
begin
  if FCodesEtats<>Nil then FCodesEtats.Free;
  n:=FItems.Count-1;
  for i:=n Downto 0 do
    begin
      if Items[i]<>Nil then Items[i].Free;
      FItems.Delete(n);
    end;
  inherited Destroy;
end;
function TCarDs.Add(UnCarD:TCaractD):integer;
Var
 j,n:integer;
begin
  n:=FItems.Add(UnCarD);
  //Ajustement du FCodeEtats
  FCodesEtats.StrItems[n,0]:=UnCarD.Nom;
  FCodesEtats.StrItems[n,1]:=IntToStr(UnCarD.TypeCarD);
  For j:=0 to UnCarD.ListeEtats.Count-1 do
    begin
      FCodesEtats.StrItems[n,(j*2)+2]:=UnCarD.ListeEtats[j];
      FCodesEtats.StrItems[n,(j*2)+3]:=IntToStr(j);  // pour la compatibilit avec l'ancien format
    end;
  Result:=n;
end;
procedure TCarDs.Clear;
Var
  i,n:integer;
begin
  n:=FItems.count-1;
  for i:=n downto 0 do
    TCaractD(FItems.Items[i]).Free;
  FItems.clear;
  FCodesEtats.ClearListArray(todelete);
end;
procedure TCarDs.Delete(Index:integer);
begin
  if Items[Index]<>Nil then Items[Index].Free;
  FItems.Delete(Index);
  CreeCodeSEtats;
end;
procedure TCarDs.Exchange(Index1, Index2: Integer);
begin
  FItems.Exchange(Index1, Index2);
  CreeCodeSEtats;
end;
procedure TCarDs.Move(CurIndex, NewIndex: Integer);
begin
  FItems.Move(CurIndex, NewIndex);
  CreeCodeSEtats;
end;
procedure TCarDs.Insert(Index: Integer; UnCarD:TCaractD);
begin
  FItems.Insert(Index, UnCarD);
  CreeCodeSEtats;
end;
function TCarDs.IndexOf(UnCarD:TCaractD):integer;
begin
  Result:=FItems.IndexOf(UnCarD);
end;
procedure TCarDs.Assign(Modele:TCarDs);
Var
  i:integer;
  UnCaracD:TCaractD;
begin
  if Modele=nil then exit;
  Clear;
  CodAuto:=Modele.CodAuto;
  DeuxEtatsMax:=Modele.DeuxEtatsMax;

  for i:=0 to Modele.NbCarD-1 do
    begin
      UnCaracD:=TCaractD.create;
      Add(UnCaracD);
      UnCaracD.Assign(Modele.Items[i]);
    end;
  CreeCodesEtats;
end;

function TCarDs.GetItem(Index:integer):TCaractD;
begin
  if (Index>=FItems.Count) or (Index<0) then result:=Nil
  else Result:=TCaractD(FItems.Items[Index]);
end;
procedure TCarDs.SetItem(Index:integer;UnCard:TCaractD);
begin
  if (Index>0)and (Index<FItems.Count) then
    begin
      FItems.Items[Index]:=UnCard;
      CreeCodeSEtats;
    end;
end;
function TCarDs.GetNomCarD(NumCarD: integer):string;
begin
   if (NumCarD>=FItems.Count) or (NumCarD<0) then GetNomCarD:=''
   else GetNomCarD:=Items[NumCarD].Nom;
end;
function TCarDs.GetNumCarD(NomCarD: string):integer;
// renvoie le rang de NomCarD ds CarD (de 0  Count-1)
// -1 si NomCarD n'existe pas
var
  i:integer;
  Trouve:boolean;
begin
  Trouve:=false;
  i:=0;
  while (not Trouve) and (i <FItems.Count) do
    if (NomCarD=GetNomCarD(i)) then
      Trouve:=True
    else
      inc(i);
  if Trouve then GetNumCarD:=i else GetNumCarD:=-1;
end;
function TCarDs.GetCarD(NomCard:string):TCaractD;
Var
  n:integer;
begin
  n:=GetNumCarD(NomCarD);
  if n>-1 then Result:=TCaractD(FItems.Items[n])
  else Result:=Nil;
end;

function TCarDs.GetEtats(NumCarD: integer):TStringList;
begin
  if (NumCarD<0)or(NumCarD>=FItems.Count) then GetEtats:=Nil
  else GetEtats:=TCaractD(FItems.Items[NumCarD]).ListeEtats;
end;
function TCarDs.GetDocEtats(NumCarD: integer):TStringList;
begin
  if (NumCarD<0)or(NumCarD>=FItems.Count) then GetDocEtats:=Nil
  else GetDocEtats:=TCaractD(FItems.Items[NumCarD]).ListeDocEtats;
end;
function TCarDs.GetEtat(NumCarD,NumEtat: integer):String;
Var
  UnCarD:TCaractD;
begin
  GetEtat:='';
  if (Numcard>-1)and(NumCarD<FItems.Count) then
    begin
      UnCarD:=TCaractD(FItems.Items[NumCarD]);
      if (NumEtat<-1)and(NumEtat<UnCarD.ListeEtats.Count) then
        GetEtat:=UnCarD.ListeEtats[NumEtat];
    end;
end;
function TCarDs.GetNbMaxiEtats:integer;
var
  i,n:integer;
  UnCaractD:TCaractD;
begin
  Result:=0;
  n:=0;
  for i:=0 to FItems.Count-1 do
    begin
      UnCaractD:=TCaractD(FItems.Items[i]);
      if UnCaractD<>nil then n:=UnCaractD.ListeEtats.Count;
      if n>Result then Result:=n;
    end;
end;
procedure TCarDs.LireCod(FichCod:string);  //Lecture du fichier .cod
var
  ListeLignes: TStringList;
  Nom,LigneEtats:string;
  typeCar:integer;
  LeCaractD:TCaractD;
  procedure VerifieEtats(Laligne:TStringList);
  Var
    j,k,n:integer; //,p
    CopieEtats:TStringList;
  begin
    //vrification des tats du caractereD
    for j:=LeCaractD.ListeEtats.Count-1 downto 0 do
      if trim(LeCaractD.ListeEtats[j])='' then LeCaractD.ListeEtats.Delete(j);
    if LeCaractD.ListeEtats.IndexOf('?')>-1 then
      begin
        if LaLigne.IndexOf('?')=-1 then
          begin
            LaLigne.Add('?');
            LaLigne.Add(IntToStr(LeCaractD.ListeEtats.Count-1));
          end;
      end;
    n:=LaLigne.Count;
    CopieEtats:=TStringList.Create;
    LigneEtats:='';
    for j:=0 to LeCaractD.ListeEtats.Count-1 do
      begin
        for k:=0 to (n-2) div 2 do
          if LaLigne.Strings[k*2+1]=IntToStr(j) then
              if LeCaractD.ListeEtats.IndexOf(LaLigne.Strings[k*2])>-1 then
                begin
                  if LigneEtats<>'' then LigneEtats:=LigneEtats+',';
                  LigneEtats:=LigneEtats+'"'+LaLigne.Strings[k*2]+'"';
                  break;
                end;
      end;
    CopieEtats.CommaText:=LigneEtats;
    if CopieEtats.Count=LeCaractD.ListeEtats.Count then
      begin
        LeCaractD.ListeEtats.Clear;
        LeCaractD.ListeEtats.AddStrings(CopieEtats);
      end;
    CopieEtats.Free;
    LeCaractD.ListeDocEtats.Clear;
    For j:=1 to LeCaractD.ListeEtats.Count do LeCaractD.ListeDocEtats.Add('');
  end;
Var
  L:TStringList;
  i,j,n:integer;
begin
  if FileExists(FichCod) then
    begin
      ListeLignes:=TStringList.Create;
      ListeLignes.Clear;
      if FCodesEtats=Nil then
        FCodesEtats:=TStrListArray.createListArray
      else
        FCodesEtats.ClearListArray(todelete);
      FCodesEtats.LoadFromFile(FichCod,#7,1);
      for i:=0 to FCodesEtats.RowCount-1 do
        begin
          Nom:=FCodesEtats.StrItems[i,0];
          n:=-1;
          if (trim(Nom)<>'') then n:=GetNumCarD(Nom);
          if (n>-1) then
            begin
              LeCaractD:=Items[n];
              try
                TypeCar:=StrToInt(FCodesEtats.StrItems[i,1]);
              except
                TypeCar:=0;  //par dfaut : non ordonn
              end;
              LeCaractD.TypeCarD:=TypeCar;
              L:=TStringList.Create;
              L.Clear;
              For j:=2 to FCodesEtats.ColCount[i]-1 do
                if trim(FCodesEtats.StrItems[i,j])<>'' then
                  L.Add(FCodesEtats.StrItems[i,j])
                else break;
              VerifieEtats(L); // ordonner les tats suivant le .cod
              L.Free;
            end;
        end;
      ListeLignes.Free;
    end
  else
    begin
//      if Not CodAuto then ShowMessage('Le fichier '+FichCod+' n''existe pas');
      if Not CodAuto then ShowMessage(M_Lefichier+FichCod+L_NexistePas);
      //Exit;
    end;
  if CodAuto or Not FileExists(FichCod) then
    begin
      For i:=0 to NbCarD-1 do
        begin
          LeCaractD:=Items[i];
          LeCaractD.TypeCarD:=0;   //par dfaut : non ordonn
        end;
    end;
  CreeCodeSEtats; // remise  plat du TStrListArray  partir du CarD modifi
end;

function TCarDs.SauveCod(NomFicCod:string):boolean;
Var
  NbCol,NbRow,i,j:integer;
  Astring:string;
  UnCaractD:TCaractD;
  Tf:TextFile;
begin
  Result:=False;
  CreeCodesEtats;
  NbCol:=GetNbMaxiEtats+3;
  NbRow:=FItems.Count;
  if (NbCol>1) and (NbRow>0) then
    begin
      Astring:='CARACTERE'+#7+'TYPE';
      for i:=2 to NbCol-1 do
        Astring:=Astring+#7+'ETAT'+IntToStr(i-1)+#7+'CODE'+IntToStr(i-1);
      Astring:=Astring+#7;
      AssignFile(Tf,NomFicCod);
      try
        ReWrite(Tf);
        writeln(Tf,Astring);
        for i:=0 to NbRow-1 do
          begin
            UnCaractD:=Items[i];
            if UnCaractD<>nil then
              begin
                Astring:=UnCaractD.Nom+#7+IntToStr(UnCaractD.TypeCarD)+#7;
                for j:=0 to UnCaractD.ListeEtats.Count-1 do
                  Astring:=Astring+#7+UnCaractD.ListeEtats[j];
                Astring:=Astring+#7;
                writeln(Tf,Astring);
              end;
          end;
        Result:=True;
      finally
        CloseFile(Tf);
      end;
    end;
end;
procedure TCarDs.SelecTout;
var
  i:integer;
begin
  for i:=0 to FItems.Count-1 do
    Items[i].Selected:=True;
end;
procedure TCarDs.RazSelect;
var
  i:integer;
begin
  for i:=0 to FItems.Count-1 do
    Items[i].Selected:=False;
end;
procedure TCarDs.RazCouleursD;
var
  i:integer;
begin
  for i:=0 to FItems.Count-1 do
    Items[i].Couleur:=clwhite;
end;
procedure TCarDs.CouleursDefaut;
var
  i,p:integer;
begin
  p:=0;
  for i:=0 to FItems.Count-1 do
    if Items[i].Active then
      begin
        Items[i].Couleur:=CouleursCaractDBoites[p mod Length(CouleursCaractDBoites)];
        inc(p);
      end;
end;
procedure TCarDs.RazDActive;
var
  i:integer;
begin
  for i:=0 to FItems.Count-1 do
    Items[i].Active:=False;
end;
procedure TCarDs.CreeCodeSEtats; //Ajout JFM 01/06/08
Var
  i,j:integer;
  nblignes:integer;  //nbcol,
  UnCaractD:TCaractD;
begin
  if FCodesEtats=nil then FCodesEtats:=TStrListArray.createListArray
  else FCodesEtats.ClearListArray(todelete);
  nblignes:=FItems.Count;
  //NbCol:=GetNbMaxiEtats+2;
  For i:=0 to nblignes-1 do
    begin
      UnCaractD:=Items[i];
      FCodesEtats.StrItems[i,0]:=UnCaractD.Nom;
      FCodesEtats.StrItems[i,1]:=IntToStr(UnCaractD.TypeCarD);
      For j:=0 to UnCaractD.ListeEtats.Count-1 do
        begin
          FCodesEtats.StrItems[i,(j*2)+2]:=UnCaractD.ListeEtats[j];
          FCodesEtats.StrItems[i,(j*2)+3]:=IntToStr(j);  // pour la compatibilit avec l'ancien format
        end;
    end;
end;
function TCarDs.GetCodesEtats:TStrListArray;
begin
  Result:=FCodesEtats;
end;
function TCarDs.GetAffichage(NomCarD,etat:string):TAffichCell;
Var
  UnCarD:TCaractD;
begin
  UnCarD:=GetCarD(NomCard);
  if UnCarD<>Nil then
    begin
      Result:=UnCarD.LitAffichCellEtatNm(etat);
    end
  else
    begin
      UnCarD:=TCaractD.create;
      Result:=UnCarD.AffRAZ;
      UnCarD.Free;
    end;
end;
procedure TCarDs.SetAffichage(NomCarD,etat:string;Aff:TAffichCell);
Var
  UnCarD:TCaractD;
begin
  UnCarD:=GetCarD(NomCard);
  if UnCarD<>Nil then UnCarD.FixeAffichCellEtatNm(etat,Aff);
end;
function TCarDs.GetNbCarD:integer;
begin
  Result:=FItems.Count;
end;
procedure TCarDs.EtablitAffichage(Tableau:TStringGrid);
Var
  i,j:integer;
  NomCarD,etat:string;
begin
  if (Not (Tableau is TMyCustomGrid)) and (Not (Tableau is TColorStringGrid)) then exit;
  For i:=Tableau.FixedCols to Tableau.ColCount-1 do
    begin
      NomCarD:=Tableau.Cells[i,0];
      For j:=Tableau.FixedRows to Tableau.RowCount-1 do
        begin
          etat:=Tableau.Cells[i,j];
          if (Tableau is TMyCustomGrid) then
            TMyCustomGrid(Tableau).AffichCell[i,j]:=Affichage[NomCarD,etat]
          else if (Tableau is TColorStringGrid) then
            TColorStringGrid(Tableau).AffichCell[i,j]:=ConvertitAffCelAffCoul(Affichage[NomCarD,etat]);
        end;
    end;
end;


// *****************  TCaracteres
procedure TCaracteres.ChargeCDRef;
begin
  if CarDRef=Nil then CarDRef:=TCarDs.Create;
  CarDRef.Assign(CarDs);
end;
procedure TCaracteres.RetourCDARef;
begin
  if CarDRef=nil then exit;
end;
procedure TCaracteres.SelecTout;
Var
  i:integer;
begin
  SetLength(Selectionnes,Noms.Count);
  For i:=0 to Length(Selectionnes)-1 do Selectionnes[i]:=True;
end;
procedure TCaracteres.RazSelect;
Var
  i:integer;
begin
  SetLength(Selectionnes,Noms.Count);
  For i:=0 to Length(Selectionnes)-1 do Selectionnes[i]:=False;
end;
procedure TCaracteres.RazDActive;
begin
  CarDs.RazDActive;
end;
function TCaracteres.GetNbCar(NumType: integer):integer;
// renvoie le Nb de caractres de type Num (Ex: nb de car biologiques)
begin
  GetNbCar:=StrToInt(NCarParType[NumType]);
end;

function TCaracteres.GetNumCar(NumType: integer; Num: integer):integer;
// renvoie le numro "absolu" du caractre, cad son rang ds la liste
// complte des caractres
var
  i,N: integer;
begin
   N:=Num;
   for i:=0 to NumType-1 do N:=N+GetNbCar(i);
   GetNumCar:=N;
end;
function TCaracteres.GetNumPremCar(NumType: integer):integer;
// renvoie le numro "absolu" du  premier caractre d'un type, cad son rang ds la liste
// complte des caractres
begin
  Result:=GetNumCar(NumType,0);
end;
function TCaracteres.GetNumDernCar(NumType: integer):integer;
// renvoie le numro "absolu" du  dernier caractre d'un type, cad son rang ds la liste
// complte des caractres
begin
  Result:=GetNumCar(NumType,GetNbCar(NumType)-1);
end;

Procedure TCaracteres.GetTypeNumdeNumabs(Numabs:integer;var numtype,numero:integer);
var
  i:integer;
  deb:integer;
begin
  deb:=0;
  numtype:=-1;
  numero:=-1;
  For i:=0 to TypeCaract.Count-1 do
    begin
      if Numabs<deb+GetNbCar(i) then
        begin
          numtype:=i;
          numero:=Numabs-deb;
          break;
        end;
      deb:=deb+GetNbCar(i);
    end;
end;
Procedure TCaracteres.GetTypeNum(Nom:string;var numtype,numero:integer);
var
  n:integer;
begin
  numtype:=-1;
  numero:=-1;
  n:=Noms.IndexOf(Nom);
  if n>-1 then GetTypeNumdeNumabs(n,numtype,numero);
end;

procedure TCaracteres.GetListeCar(NumType: integer;Var ListeCarT:TStringList);
var
  i,deb:integer;
begin
  if ListeCarT=nil then exit;
  ListeCarT.Clear;
  deb:=GetNumCar(NumType,0);
  For i:=0 to GetNbCar(NumType)-1 do
    ListeCarT.Add(Noms[deb+i]);
end;
Procedure TCaracteres.CreeNomsCourts;
Var
  i:integer;
begin
  NomsCourts:=TStringList.create;
  For i:=0 to Noms.Count-1 do NomsCourts.Add('');
end;
function TCaracteres.GetNomCourt(NumC:integer):string;
// renvoie le nom court d'un caractre (Ex: Teg., Circ., ...)
begin
  if NumC>=Noms.Count then
    begin
      GetNomCourt:='';
      exit;
    end;
  if NomsCourts=nil then
    CreeNomsCourts;
  GetNomCourt:=NomsCourts[NumC];
end;

function TCaracteres.GetNom(NumC:integer):string;
// renvoie le nom d'un caractre (Ex: Tgument, App. Circulatoire, ...)
begin
 GetNom:=Noms[NumC];
end;

function TCaracteres.GetNomCarD(NumCarD:integer):string;
begin
  Result:=CarDs.GetNomCarD(NumCarD);
end;

function TCaracteres.GetNumCarD(NomCarD: string):integer;
// renvoie le rang de NomCarD ds CarD (de 0  Count-1)
// -1 si NomCarD n'existe pas
begin
  Result:=CarDs.GetNumCarD(NomCarD);
end;
function TCaracteres.GetEtat(NumCarD,NumEtat: integer):String;
begin
  Result:=CarDs.GetEtat(NumCarD,NumEtat);
end;
function TCaracteres.GetDocEtat(NumCarD,NumEtat: integer):String;
Var
  LeCarD:TCaractD;
  chaine:string;
begin
  GetDocEtat:='';
  if NumCarD<CarDs.NbCarD then
    begin
      LeCarD:=CarDs.Items[NumCarD];
      if NumEtat<LeCarD.ListeDocEtats.Count then
        begin
          Chaine:=LeCarD.ListeDocEtats[NumEtat];
          if Chaine<>'' then
            begin
              GetDocEtat:=CheminImagesC+Chaine+ExtImage;
              if Not FileExists(CheminImagesC+Chaine+ExtImage) then
                GetDocEtat:=CheminImagesT+Chaine+ExtImage;
            end;
        end;
    end;
end;

function TCaracteres.GetEtats(NumCarD: integer):TStringList;
begin
  Result:=CarDs.GetEtats(NumCarD);
end;
function TCaracteres.GetDocEtats(NumCarD: integer):TStringList;
begin
  Result:=CarDs.GetDocEtats(NumCarD);
end;

function TCaracteres.GetNumCarParent(NumCarD: integer):integer; //-2 si on doit afficher l'image du taxon                                                                //-1 si le caractre associ n'existe pas
Var
  LeCarD:TCaractD;
  CarParent:string;
begin
  LeCarD:=CarDs.Items[NumCarD];
  If LeCarD<>Nil then
    begin
      CarParent:=LeCarD.NomCarParent;
//      if (UpperCase(CarParent)='TAXON') or (UpperCase(CarParent)='MORPHOLOGIE') then  GetNumCarParent:=-2
      if (UpperCase(CarParent)=M_TaxonMaj) or (UpperCase(CarParent)=M_MORPHOLOGIE) then  GetNumCarParent:=-2
      else GetNumCarParent:=Noms.IndexOf(CarParent);
    end
  else GetNumCarParent:=-1;
end;
function TCaracteres.LireCarDeStrinList(V2:boolean;var n:integer;ListeLignes: TStringList):boolean;  //Lecture dans un StrinList  partir du rang n
var                                                                                                  // V2 si nouvel encodage des CaractresD
  L: TStringList;
  UnCaracD:TCaractD;
  i,j,nb,cn: integer;
begin
  Result:=True;
  DeuxEtatsMax:=True;
  cn:=n;
  try
    if TypeCaract=nil then TypeCaract:=TStringList.create
    else TypeCaract.Clear;
    TypeCaract.CommaText:=ListeLignes[cn];
    if NumTypeComp=nil then NumTypeComp:=TStringList.create
    else NumTypeComp.Clear;
    NumTypeComp.CommaText:=ListeLignes[cn+1];   // en fait toujours un seul nombre
    if NCarParType=nil then NCarParType:=TStringList.create
    else NCarParType.Clear;
    NCarParType.CommaText:=ListeLignes[cn+2];
    if Noms=nil then Noms:=TStringList.create
    else Noms.Clear;
    Noms.CommaText:=ListeLignes[cn+3];
    if NomsCourts=nil then NomsCourts:=TStringList.create
    else NomsCourts.Clear;
    For i:=0 to Noms.Count-1 do NomsCourts.Add('');
    if CarDs=Nil then CarDs:=TCarDs.Create
    else CarDs.Clear;
    for i:=cn+4 to ListeLignes.Count-1 do
    begin
      if ListeLignes.Strings[i][1]='<' then
        begin
          n:=i+1;
          break;
        end;
      L:=TStringList.Create;
      L.CommaText:=ListeLignes[i];
      if (V2 and(L.Count>5)) or ((Not V2) and (L.Count>3))then
        begin
          UnCaracD:=TCaractD.create;
          if V2 then
            begin
              UnCaracD.Nom:=L[0];
              UnCaracD.NomCarParent:=L[1];
              try
                UnCaracD.TypeCarD:=StrToInt(L[2]);
              except
                UnCaracD.TypeCarD:=0; //par dfaut
              end;
              UnCaracD.Selected:=True;  //par dfaut;
              L.Delete(2);
              L.Delete(1);
              L.Delete(0);
            end
          else
            begin
              UnCaracD.Nom:=L[0];
              UnCaracD.TypeCarD:=0; //par dfaut
              UnCaracD.NomCarParent:=L[1];
              UnCaracD.NomsGroupes.Add(''); //par dfaut
              UnCaracD.NomsGroupesNommes.Add('');
              UnCaracD.Selected:=True;  //par dfaut;
              L.Delete(1);
              L.Delete(0);
            end;
          if V2 then
            begin
              UnCaracD.RAZEtat;
              for j:=0 to (L.Count-1)div 3 do
                UnCaracD.AjouteEtat(L[j*3],L[j*3+1],L[j*3+2]);
            end
          else
            begin
              UnCaracD.ListeEtats:=L; //Liste ordonne (si possible)  des tats : l'tat primitif toujours en premier,
              UnCaracD.AjusteEtats;
              UnCaracD.RAZGroupesNommes;
            end;
          CarDs.Add(UnCaracD);
          if L.IndexOf('?')=-1 then nb:=2 else nb:=3;
          if (L.Count>nb) then DeuxEtatsMax:=False;
        end
      else L.Free;
    end;
    
    SelecTout;
    CreeCodeSEtats;
    ChargeCDRef;
  except
    Result:=False;
  end;
end;
procedure TCaracteres.LireCar(FichCar:string);  //Lecture du fichier .car
var
  ListeLignes: TStringList;
  n:integer;
begin
  n:=0;
  ListeLignes:=TStringList.Create;
  if FileExists(FichCar) then
    ListeLignes.LoadFromFile(FichCar)
  else
    begin
//      ShowMessage('Le fichier '+FichCar+' n''existe pas');
      ShowMessage(M_Lefichier+FichCar+L_NexistePas);
      Exit;
    end;
//  if Not LireCarDeStrinList(false,n,ListeLignes) then ShowMessage('Erreur de lecture du fichier '+FichCar);
  if Not LireCarDeStrinList(false,n,ListeLignes) then ShowMessage(M_Erreurdelectureduf+FichCar);
  ListeLignes.Free;
end;
function TCaracteres.GetCodesEtats:TStrListArray;
begin
  Result:=carDs.FCodesEtats;
end;

Procedure TCaracteres.CreeCodeSEtats; //Ajout JFM 01/06/08
begin
  carDs.CreeCodeSEtats;
end;

procedure TCaracteres.LireCod(FichCod:string);  //Lecture du fichier .cod
begin
  CarDs.LireCod(FichCod);
end;

function TCaracteres.SauveCar(Fich:string):boolean;  //enregistrement d'un fichier .Car
var
  ListeLignes: TStringList;
begin
  Result:=False;
  ListeLignes:=TStringList.Create;
  if TransformeCarEnStrinList(false,true,ListeLignes) then
    begin
      ListeLignes.SaveToFile(Fich);
      Result:=True;
    end
//  else ShowMessage('Erreur d''criture du fichier '+Fich);
  else ShowMessage(M_Erreurdcrituredufi+Fich);
  ListeLignes.Free;
end;

function TCaracteres.TransformeCarEnStrinList(V2,Tous:boolean;var ListeLignes:TStringList):boolean;  //Ecriture dans un StrinList
var
  L: TStringList;
  i,j: integer;  //,nb
  LeCaractD:TCaractD;
begin
  Result:=False;
  if Length(Selectionnes)<Noms.Count then SelecTout;
  try
    L:=TStringList.Create;
    if TypeCaract=nil then exit
    else ListeLignes.Add(TypeCaract.CommaText);
    ListeLignes.Add(IntToStr(TypeCaract.Count));
    if NCarParType=nil then exit
    else ListeLignes.Add(NCarParType.CommaText);
    if Noms=nil then exit
    else ListeLignes.Add(Noms.CommaText);
    if CarDs=nil then exit
    else
      for i:=0 to CarDs.NbCarD-1 do
        begin
          LeCaractD:=CarDs.Items[i];
          if Tous or LeCaractD.Selected then
            begin
              L.Clear;
              L.Add(LeCaractD.Nom);
              L.Add(LeCaractD.NomCarParent);
              if V2 then
                begin
                  L.Add(IntToStr(LeCaractD.TypeCarD));
                  LeCaractD.AjusteEtats;
                  for j:=0 to LeCaractD.ListeEtats.Count-1 do
                    begin
                      L.Add(LeCaractD.ListeEtats[j]);
                      L.Add(LeCaractD.ListeDocEtats[j]);
                      L.Add(LeCaractD.NomsGroupes[j]);
                    end;
                end
              else
                begin
                  for j:=0 to LeCaractD.ListeEtats.Count-1 do
                    L.Add(LeCaractD.ListeEtats[j]);
                end;
              ListeLignes.Add(L.CommaText);
            end;
        end;
    Result:=True;
  except
    Result:=False;
  end;
  if L<>nil then L.Free;
end;

function TCaracteres.GetNumTypeComp(Index: integer): integer;
begin
   GetNumTypeComp:=StrToInt(NumTypeComp[Index])-1; // -1 car numrotation de 1  n ds le fichier
end;
function TCaracteres.GetNbMaxiEtats:integer;
begin
  Result:=CarDs.GetNbMaxiEtats;
end;
function TCaracteres.SauveCod(NomFicCod:string):boolean;
begin
  Result:=CarDs.SauveCod(NomFicCod);
end;
end.
