unit Ut_echel;

interface
uses WinTypes,Classes,SysUtils,Str_ech;
procedure Lit_Gif_comment(chaines:TStrings;var Echelle:TEchelle;var Commentaire:TStringList);

function transcrit_Echelle(Echelle:TEchelle):string;

procedure ecrit_Echelle(Echelle:TEchelle;Stream:TStream);

function Lit_Gif_Echelle(chaines:TStrings):TEchelle;

function Lit_String_Echelle(chain:String):TEchelle;

function Lit_Stream_Echelle(Stream:TStream):TEchelle;


function Charge_Echelle(Fichier:String):TEchelle;

procedure Sauve_Echelle(Fichier:String;Echelle:TEchelle);

procedure Lit_Gif_Comm(chaines:TStrings;var com_temp:TStringList);

procedure Modifie_Commentaires(ancien:TStrings;modif:Tstrings; var nouveau:TStringList);

implementation
uses StrUtils;
procedure ecrit_Echelle(Echelle:TEchelle;Stream:TStream);
var
  echellestring:string;
  longueurtexte:word;
  buffer:array[0..2] of Char;
begin
  if Echelle.active then echellestring:=transcrit_Echelle(Echelle)
  else echellestring:='';
  longueurtexte:=Length(echellestring);
  buffer[0]:=chr(longueurtexte and 255);
  buffer[1]:=chr(longueurtexte div 256);
  Stream.Write(Buffer,2);
  if longueurtexte>0 then Stream.Write(Pointer(echellestring)^,longueurtexte);
end;
function Lit_Stream_Echelle(Stream:TStream):TEchelle;
var
  echellestring:string;
  longueurtexte:word;
  buffer:array[0..2] of Char;
begin
  Result.active:=false;
  Result.mode:=0;
  Result.coeff:=1;
  Result.unite:='pixels';
  Stream.Read(Buffer,2);
  longueurtexte:=Ord(buffer[0])+256*Ord(buffer[1]);
  if longueurtexte>0 then
    begin
      SetString(echellestring, nil,longueurtexte);
      Stream.Read(Pointer(echellestring)^,longueurtexte);
      Result:=Lit_String_Echelle(echellestring);
    end;
end;

function Lit_Gif_Echelle(chaines:TStrings):TEchelle;
var
  chaine,chaine2,symbdec,notsymbdec:String;
  i:integer;
  Echelle:TEchelle;
begin
  try
    if 1.5=StrToFloat('1,5') then
      begin
        symbdec:=',';
        Notsymbdec:='.';
      end
    else
      begin
        symbdec:='.';
        Notsymbdec:=',';
      end;
  except
    symbdec:='.';
    Notsymbdec:=',';
  end;
  Echelle.active:=false;
  For i:=0 to chaines.Count-1 do
    begin
      chaine:=chaines.Strings[i];
      if Pos('<SCALE', UpperCase(chaine))>0 then
        begin
          chaine2:=Copy2SymbDelb(chaine,'=');
          if (pos('>',chaine)=0) and (i<chaines.Count-1) then
                                       chaine:=chaine+chaines.Strings[i+1];
          chaine:=Copy2Symb(chaine,'>');
          chaine2:=Copy2SymbDelb(chaine,';');
          try
            Echelle.mode:=StrToInt(chaine2);
            chaine2:=Copy2SymbDelb(chaine,';');
            Case Echelle.mode of
              0: begin
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite:=chaine2;
                   Echelle.active:=True;
                 end;
              1: begin
                   Echelle.cadre_actif.Left:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.cadre_actif.Top:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.cadre_actif.Right:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.cadre_actif.Bottom:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.zero_X:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff_X:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_X:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nombre_Y:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff_Y1:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_Y1:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.zero_Y1:=StrToInt(chaine2);
                   if Echelle.nombre_Y>1 then
                     begin
                       chaine2:=Copy2SymbDelb(chaine,';');
                       if pos(Notsymbdec,chaine2)> 0 then
                         if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                         else chaine2[pos(Notsymbdec,chaine2)]:='.';
                       Echelle.coeff_Y2:=StrToFloat(chaine2);
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.unite_Y2:=chaine2;
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.zero_Y2:=StrToInt(chaine2);
                     end;
                   if Echelle.nombre_Y>2 then
                     begin
                       chaine2:=Copy2SymbDelb(chaine,';');
                       if pos(Notsymbdec,chaine2)> 0 then
                         if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                         else chaine2[pos(Notsymbdec,chaine2)]:='.';
                       Echelle.coeff_Y3:=StrToFloat(chaine2);
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.unite_Y3:=chaine2;
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.zero_Y3:=StrToInt(chaine2);
                     end;
                   Echelle.active:=True;
                 end;
              2: begin
                   Echelle.X_G:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.Y_G:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.longueur:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.sens:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nom_X:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nom_Y:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nom_Z:=chaine2;
                   Echelle.active:=True;
                 end;
              3: begin
                   Echelle.X_C:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.Y_C:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_angle:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.angle_Zero:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff_r:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_r:=chaine2;
                   Echelle.active:=True;
                 end;
            end;
          except
            Echelle.active:=false;
          end;
          Break;
        end;
    end;
  Result:=Echelle;
end;
procedure Lit_Gif_Comm(chaines:TStrings;var com_temp:TStringList);
var
  chaine:String;
  i,n,j:integer;
begin
  com_temp.Clear;
  For i:=0 to chaines.Count-1 do
    begin
      chaine:=chaines.Strings[i];
      if Pos('<COMMENT>', UpperCase(chaine))>0 then
        begin
          Delete(chaine,1,Pos('<COMMENT>', UpperCase(chaine))+8);
          n:=i;
          while (n<chaines.Count-1) and (Pos('</COMMENT>', UpperCase(chaine))=0) do
            begin
              if (n>i) or (chaine<>'') then j:=com_temp.Add(chaine);
              n:=n+1;
              chaine:=chaines.Strings[n];
            end;
          if (Pos('</COMMENT>', UpperCase(chaine))>0) then
            begin
              chaine:=Copy(chaine,1,Pos('</COMMENT>', UpperCase(chaine))-1);
              if chaine<>'' then
                 j:=com_temp.Add(chaine);
            end;
          Break;
        end;
    end;
end;
procedure Modifie_Commentaires(ancien:TStrings;modif:Tstrings; var nouveau:TStringList);
var
  i,j:integer;
  chaine:string;
begin
  nouveau.Clear;
  i:=0;
  if ancien.Count=0 then chaine:='' else chaine:=ancien.Strings[0];
  While (Pos('<COMMENT>', UpperCase(chaine))=0) and (i<ancien.Count) do
    begin
      nouveau.add(chaine);
      i:=i+1;
      chaine:=ancien.Strings[i];
    end;
  if Pos('<COMMENT>', UpperCase(chaine))>0 then
    begin
      if Pos('<COMMENT>', UpperCase(chaine))>1 then
        nouveau.Add(Copy(Chaine,1,Pos('<COMMENT>', UpperCase(chaine))-1));
      Delete(chaine,1,Pos('<COMMENT>', UpperCase(chaine))+8);
    end;
  if modif.Count>0 then
    begin
      nouveau.Add('<COMMENT>');
      for j:=0 to modif.Count-1 do nouveau.Add(modif.Strings[j]);
      nouveau.Add('<\COMMENT>');
    end;
  if Pos('<\COMMENT>', UpperCase(chaine))>0 then
    begin
      Delete(chaine,1,Pos('<\COMMENT>', UpperCase(chaine))+8);
      if chaine<>'' then
        nouveau.Add(chaine);
    end;
  if i<ancien.Count-1 then
    for j:=i+1 to ancien.Count-1 do nouveau.Add(ancien.Strings[j]);
end;
procedure Lit_Gif_comment(chaines:TStrings;var Echelle:TEchelle;var Commentaire:TStringList);
begin
  Echelle:=Lit_Gif_Echelle(chaines);
  Lit_Gif_Comm(chaines,Commentaire);
end;
function transcrit_Echelle(Echelle:TEchelle):string;
var
  chaine:string;
begin
  chaine:='<SCALE=';
  chaine:=chaine+IntToStr(Echelle.mode)+';';
  Case Echelle.mode of
    0: begin
         chaine:=chaine+FloatToStrF(Echelle.coeff,ffGeneral,4,1)+';';
         chaine:=chaine+Echelle.unite;
       end;
    1: begin
         chaine:=chaine+IntToStr(Echelle.cadre_actif.Left)+';';
         chaine:=chaine+IntToStr(Echelle.cadre_actif.Top)+';';
         chaine:=chaine+IntToStr(Echelle.cadre_actif.Right)+';';
         chaine:=chaine+IntToStr(Echelle.cadre_actif.Bottom)+';';
         chaine:=chaine+IntToStr(Echelle.zero_X)+';';
         chaine:=chaine+FloatToStrF(Echelle.coeff_X,ffGeneral,4,1)+';';
         chaine:=chaine+Echelle.unite_X+';';
         chaine:=chaine+IntToStr(Echelle.nombre_Y)+';';
         chaine:=chaine+FloatToStrF(Echelle.coeff_Y1,ffGeneral,4,1)+';';
         chaine:=chaine+Echelle.unite_Y1+';';
         chaine:=chaine+IntToStr(Echelle.zero_Y1);
         if Echelle.nombre_Y>1 then
           begin
             chaine:=chaine+';'+FloatToStrF(Echelle.coeff_Y2,ffGeneral,4,1)+';';
             chaine:=chaine+Echelle.unite_Y2+';';
             chaine:=chaine+IntToStr(Echelle.zero_Y2);
           end;
         if Echelle.nombre_Y>2 then
           begin
             chaine:=chaine+';'+FloatToStrF(Echelle.coeff_Y3,ffGeneral,4,1)+';';
             chaine:=chaine+Echelle.unite_Y3+';';
             chaine:=chaine+IntToStr(Echelle.zero_Y3);
           end;
       end;
    2: begin
         chaine:=chaine+IntToStr(Echelle.X_G)+';';
         chaine:=chaine+IntToStr(Echelle.Y_G)+';';
         chaine:=chaine+IntToStr(Echelle.longueur)+';';
         chaine:=chaine+IntToStr(Echelle.sens)+';';
         chaine:=chaine+Echelle.nom_X+';';
         chaine:=chaine+Echelle.nom_Y+';';
         chaine:=chaine+Echelle.nom_Z;
       end;
    3: begin
         chaine:=chaine+IntToStr(Echelle.X_C)+';';
         chaine:=chaine+IntToStr(Echelle.Y_C)+';';
         chaine:=chaine+Echelle.unite_angle+';';
         chaine:=chaine+FloatToStrF(Echelle.angle_Zero,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(Echelle.coeff_r,ffGeneral,4,1)+';';
         chaine:=chaine+Echelle.unite_r;
       end;
  end;
  result:=chaine+';>';
end;
function Lit_string_Echelle(Chain:string):TEchelle;
var
  chaine,chaine2,symbdec,notsymbdec:String;
  i,j,n:integer;
  Echelle:TEchelle;
begin
  try
    if 1.5=StrToFloat('1,5') then
      begin
        symbdec:=',';
        Notsymbdec:='.';
      end
    else
      begin
        symbdec:='.';
        Notsymbdec:=',';
      end;
  except
    symbdec:='.';
    Notsymbdec:=',';
  end;
  Echelle.active:=false;
  Chaine:=Chain;
  if Pos('<SCALE', UpperCase(chaine))>0 then chaine2:=Copy2SymbDelb(chaine,'=');
          chaine:=Copy2Symb(chaine,'>');
          chaine2:=Copy2SymbDelb(chaine,';');
          try
            Echelle.mode:=StrToInt(chaine2);
            chaine2:=Copy2SymbDelb(chaine,';');
            Case Echelle.mode of
              0: begin
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite:=chaine2;
                   Echelle.active:=True;
                 end;
              1: begin
                   Echelle.cadre_actif.Left:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.cadre_actif.Top:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.cadre_actif.Right:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.cadre_actif.Bottom:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.zero_X:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff_X:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_X:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nombre_Y:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff_Y1:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_Y1:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.zero_Y1:=StrToInt(chaine2);
                   if Echelle.nombre_Y>1 then
                     begin
                       chaine2:=Copy2SymbDelb(chaine,';');
                       if pos(Notsymbdec,chaine2)> 0 then
                         if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                         else chaine2[pos(Notsymbdec,chaine2)]:='.';
                       Echelle.coeff_Y2:=StrToFloat(chaine2);
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.unite_Y2:=chaine2;
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.zero_Y2:=StrToInt(chaine2);
                     end;
                   if Echelle.nombre_Y>2 then
                     begin
                       chaine2:=Copy2SymbDelb(chaine,';');
                       if pos(Notsymbdec,chaine2)> 0 then
                         if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                         else chaine2[pos(Notsymbdec,chaine2)]:='.';
                       Echelle.coeff_Y3:=StrToFloat(chaine2);
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.unite_Y3:=chaine2;
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.zero_Y3:=StrToInt(chaine2);
                     end;
                   Echelle.active:=True;
                 end;
              2: begin
                   Echelle.X_G:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.Y_G:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.longueur:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.sens:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nom_X:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nom_Y:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nom_Z:=chaine2;
                   Echelle.active:=True;
                 end;
              3: begin
                   Echelle.X_C:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.Y_C:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_angle:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.angle_Zero:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff_r:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_r:=chaine2;
                   Echelle.active:=True;
                 end;
            end;
          except
            Echelle.active:=false;
          end;
  Result:=Echelle;
end;
function Charge_Echelle(Fichier:String):TEchelle;
var
  Chaine,fic:string;
  F:TextFile;
  Echelle:TEchelle;
begin
  fic:=Copy(Fichier,1,Length(Fichier)-4)+'.sca';
  Echelle.mode:=0;
  Echelle.unite:='pixels';
  Echelle.coeff:=1;
  Echelle.active:=True;
  Result:=Echelle;
  if Not FileExists(Fic) then exit;
  try
    AssignFile(F, fic);
    Reset(F);
    Readln(F, Chaine);
    CloseFile(F);
    Echelle:=Lit_string_Echelle(Chaine);
    Echelle.active:=true;
  except
    Echelle.mode:=0;
    Echelle.unite:='pixels';
    Echelle.coeff:=1;
    Echelle.active:=True;
  end;
  Result:=Echelle;
end;
procedure Sauve_Echelle(Fichier:String;Echelle:TEchelle);
var
  Chaine,fic:string;
  F:TextFile;
begin
  Chaine:=transcrit_Echelle(Echelle);
  fic:=Copy(fichier,1,Length(fichier)-4)+'.sca';
  AssignFile(F, fic);
  Rewrite(F);
  Writeln(F, Chaine);
  CloseFile(F);
end;
end.

